"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _AuthorizeContext = require("../../context/AuthorizeContext");

var _excluded = ["children", "authKey", "authReg"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Disable_ClassName = 'auth-disable';

var Auth = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Auth, _Component);

  var _super = _createSuper(Auth);

  function Auth(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Auth);
    _this = _super.call(this, props);

    _this.classnames = function (c1, c2) {
      if (c1) {
        return "".concat(c1, " ").concat(c2);
      } else {
        return c2;
      }
    };

    _this.getConfigureByAuthKey = function (configure, authKeyStr) {
      var _a = authKeyStr.split('.'); // _a: ['home', 'createReceipt']


      var _v = configure[_a[0]]; // _v: configure['home']

      for (var i = 1; i < _a.length; i++) {
        if (_v) {
          _v = _v[_a[i]];
        }
      }

      return _v;
    };

    _this.clonedNode = function (children, otherProps, _config) {
      if (_config && _config.disable) {
        // 展示但是置灰
        return _react.default.Children.map(children, function (child) {
          return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.isValidElement(child) ? /*#__PURE__*/_react.default.cloneElement(child, _objectSpread(_objectSpread({}, otherProps), {}, {
            onClick: function onClick(e) {
              e.stopPropagation();
              return false;
            },
            className: _this.classnames(child.props.className, Disable_ClassName)
          })) : null);
        });
      } else {
        return _react.default.Children.map(children, function (child) {
          return /*#__PURE__*/_react.default.isValidElement(child) ? /*#__PURE__*/_react.default.cloneElement(child, otherProps) : null;
        });
      }
    };

    _this.isShow = function (_defaultHide, _config) {
      if (_defaultHide) {
        if (_config && _config.show) {
          // 是否展示
          return true;
        } else {
          return false;
        }
      } else {
        if (_config && _config.hide) {
          // 是否展示
          return false;
        } else {
          return true;
        }
      }
    };

    _this.isVisibleOfAuthKey = function (_config, _defaultHide, authReg) {
      // 如果是叶子节点:类似于这种结构{show: true} or {hide: true}
      if (_config && ('show' in _config || 'hide' in _config)) {
        return _this.isShow(_defaultHide, _config);
      } else {
        if (_config && Object.keys(_config).length > 0) {
          var arr = Object.keys(_config);
          var visibleAccount = 0;
          arr.forEach(function (item) {
            var isTheItemVisible = _this.isShow(_defaultHide, _config[item]);

            if (isTheItemVisible) {
              visibleAccount++;
            }
          });

          if (authReg) {
            // eslint-disable-next-line no-eval
            if (eval("".concat(visibleAccount).concat(authReg))) {
              return true;
            } else {
              return false;
            }
          } else {
            if (visibleAccount > 0) {
              return true;
            } else {
              return false;
            }
          }
        } else {
          if (_defaultHide) {
            return false;
          } else {
            return true;
          }
        }
      }
    };

    _this.renderByConfigure = function (configure) {
      var _this$props = _this.props,
          children = _this$props.children,
          authKey = _this$props.authKey,
          authReg = _this$props.authReg,
          otherProps = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var _defaultHide = configure._defaultHide;

      var _config = _this.getConfigureByAuthKey(configure, authKey);

      var visible = _this.isVisibleOfAuthKey(_config, _defaultHide, authReg);

      if (visible) {
        return _this.clonedNode(children, otherProps, _config);
      } else {
        return null;
      } // if (_defaultHide) {
      //     if (_config && _config.show) { // 是否展示
      //         return this.clonedNode(children, otherProps, _config);
      //     } else {
      //         return null;
      //     }
      // } else { // 默认展示的话：通过hide这个字段来判断是否隐藏
      //     if (_config && _config.hide) {
      //         return null;
      //     } else {
      //         return this.clonedNode(children, otherProps, _config);
      //     }
      // }

    };

    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(Auth, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      // authKey是判断取哪个配置key
      var configure = this.props.configure;
      return configure ? this.renderByConfigure(configure) : /*#__PURE__*/_react.default.createElement(_AuthorizeContext.AuthorizeContext.Consumer, null, function (_ref) {
        var _ref$configure = _ref.configure,
            configure = _ref$configure === void 0 ? {} : _ref$configure;
        return _this2.renderByConfigure(configure);
      });
    }
  }]);
  return Auth;
}(_react.Component);

var _default = Auth;
exports.default = _default;