"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _AuthorizeContext = require("../../context/AuthorizeContext");

var _Authorize = _interopRequireDefault(require("../../Authorize"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var AuthorizeMaster = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(AuthorizeMaster, _Component);

  var _super = _createSuper(AuthorizeMaster);

  function AuthorizeMaster(props) {
    var _this;

    (0, _classCallCheck2.default)(this, AuthorizeMaster);
    _this = _super.call(this, props);

    _this.setConfigure = function (obj) {
      _this.setState(_objectSpread({}, obj), function () {
        // 每次更新权限配置的时候，也会将存储在authorize中的更新
        _Authorize.default._setAuthorizeMaster((0, _assertThisInitialized2.default)(_this));
      });
    };

    _this.initVersion = function (version) {
      _this.switchVersion(version);
    };

    _this.switchVersion = function (version) {
      _Authorize.default.switchVersion(_this.setConfigure, version);
    };

    _this.addVersion = function (obj) {
      _Authorize.default._addVersion(obj);
    };

    _this.getConfigureByAuthKey = function (authKeyStr) {
      var _a = authKeyStr.split('.'); // _a: ['home', 'createReceipt']


      var _v = _this.state[_a[0]]; // _v: configure['home']

      for (var i = 1; i < _a.length; i++) {
        if (_v) {
          _v = _v[_a[i]];
        }
      }

      return _v;
    };

    _this.getIsVisibleByAuthKey = function (authKeyStr) {
      var _defaultHide = _this.state._defaultHide;

      var _config = _this.getConfigureByAuthKey(authKeyStr);

      if (_defaultHide) {
        if (_config && _config.show) {
          return true;
        } else {
          return false;
        }
      } else {
        if (_config && _config.hide) {
          return false;
        } else {
          return true;
        }
      }
    };

    _this.state = {};
    return _this;
  }

  (0, _createClass2.default)(AuthorizeMaster, [{
    key: "render",
    value: function render() {
      // authKey是判断取哪个配置key
      var children = this.props.children;
      return /*#__PURE__*/_react.default.createElement(_AuthorizeContext.AuthorizeContext.Provider, {
        value: {
          configure: this.state,
          setConfigure: this.setConfigure,
          initVersion: this.initVersion,
          switchVersion: this.switchVersion,
          addVersion: this.addVersion,
          getConfigureByAuthKey: this.getConfigureByAuthKey,
          getIsVisibleByAuthKey: this.getIsVisibleByAuthKey
        }
      }, children);
    }
  }]);
  return AuthorizeMaster;
}(_react.Component);

var _default = AuthorizeMaster;
exports.default = _default;