"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var colors = ['c1', 'c2', 'c3', 'c4', 'c5', 'c6', 'c7', 'c8', 'c9', 'c10', 'c11', 'c12', 'c13', 'c14'];

function hashCode(str) {
  str = str || '';

  if (Array.prototype.reduce) {
    return str.split('').reduce(function (a, b) {
      a = (a << 5) - a + b.charCodeAt(0);
      return a & a;
    }, 0);
  }

  var hash = 0;
  if (str.length === 0) return hash;

  for (var i = 0; i < str.length; i++) {
    var character = str.charCodeAt(i);
    hash = (hash << 5) - hash + character;
    hash = hash & hash; // Convert to 32bit integer
  }

  return hash;
}

var Avatar = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(Avatar, _Component);

  var _super = _createSuper(Avatar);

  function Avatar(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Avatar);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_Avatar').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.state = {
      abbrName: '',
      color: '',
      t: _mkTranslate.default.noop()
    };
    _this.getAbbrName = _this.getAbbrName.bind((0, _assertThisInitialized2.default)(_this));
    _this.updateState = _this.updateState.bind((0, _assertThisInitialized2.default)(_this));
    _this.onClickAvatar = _this.onClickAvatar.bind((0, _assertThisInitialized2.default)(_this));

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(Avatar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var user = this.props.user;
      this.updateState(user);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var user = nextProps.user;
      this.updateState(user);
    }
  }, {
    key: "updateState",
    value: function updateState(user) {
      if (user) {
        var abbrName = this.getAbbrName(user.userName);
        var idx = Math.abs(hashCode(user.userName)) % colors.length;
        this.setState({
          abbrName: abbrName,
          color: colors[idx]
        });
      }
    }
  }, {
    key: "onClickAvatar",
    value: function onClickAvatar(e) {
      var _this$props = this.props,
          onClick = _this$props.onClick,
          isProp = _this$props.isProp;

      if (!isProp) {
        e.stopPropagation();
      }

      if (typeof onClick === 'function') {
        onClick();
      }
    }
  }, {
    key: "getAbbrName",
    value: function getAbbrName(name) {
      if (!name) return '';
      var chineseReg = new RegExp("[\u4E00-\uFA29\uE7C7-\uE7F3]+", 'g');
      var wordReg = new RegExp('[A-Za-z]', 'g');
      var result = '';
      var m = (name || '').match(chineseReg);

      if (m && m.length !== 0) {
        result = m[0];

        if (result && result.length > 2) {
          result = result.substring(result.length - 2, result.length);
        }
      }

      if (!result) {
        m = (name || '').match(wordReg);

        if (m && m.length !== 0) {
          result = this.formatAvatarEn(name);
        }
      }

      if (!result) {
        result = name.substr(0, 1);
      }

      return result;
    }
  }, {
    key: "formatAvatarEn",
    value: function formatAvatarEn() {
      var name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var names = (name || '').split(' ');
      var result = '';

      for (var i = 0; i < names.length; i++) {
        if (i > 2) break;
        result += ".".concat(names[i].charAt(0).toUpperCase());
      }

      return result.substr(1, result.length);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          customStyle = _this$props2.customStyle,
          avatarUrl = _this$props2.avatarUrl;
      var t = this.state.t;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, avatarUrl ? /*#__PURE__*/_react.default.createElement("img", {
        onClick: this.onClickAvatar,
        className: "".concat(prefix, "-avatar-img"),
        src: avatarUrl,
        alt: t('abbrName'),
        style: _objectSpread({}, customStyle)
      }) : /*#__PURE__*/_react.default.createElement("span", {
        onClick: this.onClickAvatar,
        className: "".concat(prefix, "-avatar ").concat(this.state.color || 'c0'),
        style: _objectSpread({}, customStyle)
      }, /*#__PURE__*/_react.default.createElement("span", null, this.state.abbrName)));
    }
  }]);
  return Avatar;
}(_react.Component);

Avatar.propTypes = {
  /** 个人用户信息  */
  user: _propTypes.default.object,

  /** 自定义组件style  */
  customStyle: _propTypes.default.object
};
var _default = Avatar;
exports.default = _default;