"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = require("lodash");

var _MileageInfo = _interopRequireDefault(require("./components/MileageInfo"));

var _service = require("./service");

var _utils = _interopRequireDefault(require("../utils/utils"));

var _MileProcess = _interopRequireDefault(require("./components/MileProcess"));

var _MileIcon = _interopRequireDefault(require("./components/MileIcon"));

var _ProcessBtn = _interopRequireDefault(require("./components/ProcessBtn"));

var _toast = _interopRequireDefault(require("./components/toast"));

var _windowOrGlobal = require("window-or-global");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var prefix = _utils.default.prefixCls;
var TRACK_RUNNING = "RUNNING";
var TRACK_STOP = "STOP";
var TRACK_PAUSE = "PAUSE";

var CarMileage = function CarMileage(props) {
  console.log(props);
  var initPoints = props.initPoints,
      actions = props.actions;
  var onSavePoint = props.onSavePoint,
      onCalculate = props.onCalculate,
      onFeeGenerate = props.onFeeGenerate,
      onViewTrackMap = props.onViewTrackMap,
      onGetTrackInfo = props.onGetTrackInfo,
      onAdjustPoint = props.onAdjustPoint,
      onSwitchToOld = props.onSwitchToOld; // 途经点

  var _useState = (0, _react.useState)([]),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      points = _useState2[0],
      setPoints = _useState2[1]; // 里程信息


  var _useState3 = (0, _react.useState)({}),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      mileInfo = _useState4[0],
      setMileInfo = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      mileInfoOpen = _useState6[0],
      setMileInfoOpen = _useState6[1]; // 鹰眼相关信息


  var _useState7 = (0, _react.useState)(),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      trackInfo = _useState8[0],
      setTrackInfo = _useState8[1]; // 实时路径状态


  var _useState9 = (0, _react.useState)(TRACK_STOP),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      trackStatus = _useState10[0],
      setTrackStatus = _useState10[1]; // 主按钮点击状态


  var _useState11 = (0, _react.useState)(false),
      _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
      mainBtnDisabled = _useState12[0],
      setMainBtnDisabled = _useState12[1];

  var pauseBtnClass = (0, _classnames.default)("".concat(prefix, "-ng-button circle-btn"), {
    pause: trackStatus !== TRACK_RUNNING
  });
  var trackBoxClass = (0, _classnames.default)("".concat(_service.milePrefix, "-track-box pause-svg"), {
    pause: trackStatus !== TRACK_RUNNING
  });

  if (actions) {
    // 重置
    actions.resetPoint = function () {
      setPoints((0, _service.manageInitPoints)());
      setTrackInfo({}); //如果正在使用实时定位，结束

      if (trackStatus === TRACK_RUNNING) {
        _stopTrack();
      }

      _hideLoading();
    };
  }

  (0, _react.useEffect)(function () {
    var mIPoints = (0, _service.manageInitPoints)(initPoints);
    console.log(mIPoints);
    setPoints(mIPoints);
  }, [initPoints]);
  (0, _react.useEffect)(function () {
    if (!_windowOrGlobal.window.MKTrack) {
      _windowOrGlobal.window.MKTrack = {};
    }

    _windowOrGlobal.window.MKTrack.trackStatus = trackStatus;
  }, [trackStatus]);
  (0, _react.useEffect)(function () {
    console.log("useEffect[]");
    (0, _service.checkAndroidBackgroundMode)();
  }, []);
  /**
   * 记录途经点
   */

  var handleRecordPoint = function handleRecordPoint(pt, index) {
    var newPoints = (0, _toConsumableArray2.default)(points); // const idx = findIndex(points, { code: pt.code });

    return new Promise(function (resolve, reject) {
      // 获取定位信息
      (0, _service.getCurrentPoisition)().then(function (location) {
        if (!location.address) return;
        newPoints[index] = _objectSpread(_objectSpread({}, newPoints[index]), location);
        onSavePoint(newPoints).then(function () {
          var pts = (0, _service.recordPointSuccess)(pt, newPoints);
          setPoints(pts);
          resolve();
        });
      }, function () {
        _toast.default.info("获取定位失败，请重试");

        _hideLoading();

        reject();
      });
    });
  };
  /**
   * 出发/结束/继续出发按钮点击
   */


  var handleMainBtn = function handleMainBtn() {
    if (points.length === 2) {
      // 出发
      _showLoading();

      handleRecordPoint((0, _lodash.find)(points, {
        type: _service.POINT_START
      }), 0).then(function () {
        startTrack();
      });
    } else if (trackStatus === TRACK_PAUSE) {
      // 暂停后继续出发
      _continueTrack();
    } else if (trackStatus === TRACK_STOP) {
      // 停止后继续出发
      startTrack();
    } else {
      // 到达
      _showLoading();

      handleRecordPoint((0, _lodash.find)(points, {
        type: _service.POINT_END
      }), points.length - 1).then(function () {
        _stopTrack();
      });
    }
  };
  /**
   *  删除途经点
   */


  var handleDeletePoint = function handleDeletePoint(pt) {
    var newPoints = (0, _toConsumableArray2.default)(points);
    (0, _lodash.remove)(newPoints, {
      code: pt.code
    });
    console.log(newPoints);
    onSavePoint(newPoints).then(function () {
      setPoints(newPoints);
    });
  };
  /**
   * 里程计算
   */


  var handleCalculate = function handleCalculate() {
    onCalculate().then(function (info) {
      setMileInfo(info);
      console.log(info);
      setMileInfoOpen(true);
    });
  };
  /**
   * 里程改变，重新计算
   */


  var handleMileChange = function handleMileChange(distance) {
    console.log(distance);
    onCalculate(distance).then(function (info) {
      setMileInfo(info);
    });
  };
  /**
   * 切换回旧版打点模式
   */


  var handleSwitchToOld = function handleSwitchToOld() {
    // if (points && points.length) {
    //   Modal.confirm({
    //     title: "提示",
    //     content: "切换模式会清空当前信息，确认继续吗",
    //     cancelText: "取消",
    //     okText: "切换",
    //     onOk: switchToOld,
    //   });
    // } else {
    onSwitchToOld(); // }
  };
  /**
   * 地点微调
   */


  var handleAdjustPoint = function handleAdjustPoint(pt, index) {
    var newPoints = (0, _toConsumableArray2.default)(points);
    onAdjustPoint().then(function (adjustPt) {
      if (!pt.originalLocation) {
        adjustPt.originalLocation = pt.address;
      }

      newPoints[index] = _objectSpread(_objectSpread({}, newPoints[index]), adjustPt);
      setPoints(newPoints);
    });
  };
  /**
   * 暂停实时路径
   */


  var handlePauseTrack = function handlePauseTrack() {
    if (trackStatus === TRACK_RUNNING) {
      (0, _service.pauseAmapTrack)().then(function () {
        setTrackStatus(TRACK_PAUSE);

        _toast.default.info("暂停成功");
      });
    }
  };
  /**
   * 开启实时路径
   */


  var startTrack = function startTrack() {
    if (!trackInfo || !trackInfo.serviceId) {
      onGetTrackInfo().then(function (data) {
        console.log(data);
        setTrackInfo(data);

        _initTrack(data);
      });
    } else {
      _initTrack(trackInfo);
    }
  };
  /**
   * 初始化并开启高德猎鹰
   */


  var _initTrack = function _initTrack(info) {
    (0, _service.initStartAmapTrack)(info).then(function () {
      setTrackStatus(TRACK_RUNNING);

      _hideLoading();
    }, function () {
      _toast.default.info("实时路径开启失败");

      _hideLoading();
    });
  };
  /**
   * 关闭实时路径
   */


  var _stopTrack = function _stopTrack() {
    (0, _service.stopAmapTrack)().then(function () {
      setTrackStatus(TRACK_STOP);

      _hideLoading();
    }, function () {
      _toast.default.info("实时路径关闭失败");

      _hideLoading();
    });
  };
  /**
   * 继续实时路径
   */


  var _continueTrack = function _continueTrack() {
    (0, _service.startAmapTrack)().then(function () {
      setTrackStatus(TRACK_RUNNING);
    });
  };

  var _showLoading = function _showLoading() {
    setMainBtnDisabled(true);
  };

  var _hideLoading = function _hideLoading() {
    setMainBtnDisabled(false);
  };

  var onCloseFeeModal = (0, _react.useCallback)(function () {
    setMileInfoOpen(false);
  }, []);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: _service.milePrefix
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-container")
  }, /*#__PURE__*/_react.default.createElement(_MileProcess.default, {
    points: points,
    recordPoint: handleRecordPoint,
    onDelete: handleDeletePoint,
    onAdjustPoint: handleAdjustPoint
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: trackBoxClass,
    onClick: onViewTrackMap
  }, /*#__PURE__*/_react.default.createElement(_MileIcon.default, {
    name: "location"
  }), /*#__PURE__*/_react.default.createElement("span", {
    className: "track-text"
  }, "\u5B9E\u65F6\u8DEF\u5F84")), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-btn-box")
  }, points.length && points[points.length - 1].address ? /*#__PURE__*/_react.default.createElement("button", {
    className: "".concat(prefix, "-ng-button parimary full align-end"),
    onClick: handleCalculate
  }, "\u91CC\u7A0B\u8BA1\u7B97") : /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_ProcessBtn.default, {
    className: "".concat(prefix, "-ng-button tick-btn"),
    loading: mainBtnDisabled,
    onClick: handleMainBtn
  }, mainBtnDisabled ? null : points.length === 2 ? "出 发" : trackStatus !== TRACK_RUNNING ? "继续出发" : "到 达"), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-btn-box-right")
  }, /*#__PURE__*/_react.default.createElement("button", {
    className: pauseBtnClass,
    onClick: handlePauseTrack
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "btn-icon pause"
  }, /*#__PURE__*/_react.default.createElement(_MileIcon.default, {
    name: "pause"
  }))), /*#__PURE__*/_react.default.createElement("button", {
    className: "".concat(prefix, "-ng-button circle-btn"),
    onClick: handleSwitchToOld
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "btn-icon"
  }, /*#__PURE__*/_react.default.createElement(_MileIcon.default, {
    name: "switch"
  }))))))), points.length && points[points.length - 1].address ? /*#__PURE__*/_react.default.createElement(_MileageInfo.default, {
    isOpen: mileInfoOpen,
    onClose: onCloseFeeModal,
    points: points,
    mileInfo: mileInfo,
    onViewTrackMap: onViewTrackMap,
    onGenerate: function onGenerate(finalMileInfo) {
      onFeeGenerate(finalMileInfo, points);
    },
    onMileChange: function onMileChange(distance) {
      handleMileChange(distance);
    }
  }) : null);
};

CarMileage.propTypes = {
  initPoints: _propTypes.default.array,
  actions: _propTypes.default.object,
  onSavePoint: _propTypes.default.func.isRequired,
  onCalculate: _propTypes.default.func.isRequired,
  onFeeGenerate: _propTypes.default.func.isRequired,
  onGetTrackInfo: _propTypes.default.func.isRequired
};
CarMileage.defaultProps = {
  initPoints: []
};
var _default = CarMileage;
exports.default = _default;