#### 私车公用

## 何时使用


### CarMileage props
| 参数 | 说明 | 类型 | 默认值
| --- | --- | --- | --- |
| initPoints | 初始途经点 | array | - |
| trackInfo | 高德鹰眼相关信息 | object | - |
| actions | 外部调用组件方法的实例对象 | object | - |
<!-- | mileInfo | 里程信息 | object | - | -->
| disabled | 是否只读 | boolean | false |
| isTrack | 是否开启鹰眼实时路径 | boolean | - |
| onSavePoint | 保存途经点回调 | function | - |
<!-- | onDetletePoint | 删除途经点回调 | function | - | -->
<!-- | onReset | 重置回调 | function | - | -->
| onCalculate | 里程计算回调 | function | - |
| onFeeGenerate | 生成费用回调 | function | -  |
| onViewTrackMap | 查看实时路径地图轨迹回调 | function | -  |

### actions
| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| resetPoint | 重置 | function | - |

### initPoints
| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| type | 途经点类型 | `START`;`VIA`;`END` | - |
| timestamp | 途经点时间戳 | number | - |
| address | 地址名称 | string | - |
| addrDescp | 地址详情 | string | - |
| originalLocation | 调整前地址名称 | string | - |
| latitude | 纬度 | string | - |
| longitude | 经度 | string | - |

### trackInfo(高德鹰眼相关配置信息)
| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| sid | 轨迹服务id | string | - |
| tid | 设备终端id（根据e`entcode-usercode`创建） | string | - |
| trid | 行程轨迹id（对应业务中的一段行程,由行程code获取） | string | - |

### mileInfo
| 参数 | 说明 | 类型 | 默认值 |
| --- | --- | --- | --- |
| amount | 补贴总额 | number | - |
| unitAmount | 补贴单价 | number | - |
| distance | 参考里程(地图sdk返回) | number | - |
| actualDistance | 调整里程(修改后) | number | - |
| ccyCode | 币种 | string | - |
| ccySymbol | 币种符号 | string | - |
| ruleDimension | 计价方式 | `UNIFY`(统一计价);`LADDER`（阶梯计价） | - |
| ladders | 阶梯计价信息 | object[] | - |


```jsx
<div style={{width:"375px",height:"667px",border: "1px solid #e1e1e1"}}>
         <CarMileage
              onSavePoint={() => {
                return new Promise(resolve => {
                  resolve();
                });
              }}
              onCalculate={(distance) => {
                return new Promise(resolve => {
                  resolve({
                    amount: 100,
                    unitAmount: 1,
                    distance: 100 ,
                    actualDistance: distance || 0,
                    ccyCode: "CNY",
                    ccySymbol: "¥"
                  });
                });
              }}
              onGetTrackInfo={() => {
                return new Promise(resolve => {
                  resolve();
                });
              }}
        />
</div>
```