"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _service = require("../service");

var prefix = _utils.default.prefixCls;

var MileProcess = function MileProcess(props) {
  var points = props.points;
  var recordPoint = props.recordPoint,
      onDelete = props.onDelete,
      onAdjustPoint = props.onAdjustPoint;
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-content")
  }, points.map(function (point, index) {
    var pointClass = (0, _classnames.default)("".concat(_service.milePrefix, "-point"), {
      start: point.type === _service.POINT_START,
      end: point.type === _service.POINT_END
    });
    return /*#__PURE__*/_react.default.createElement("div", {
      className: pointClass,
      key: point.code || point.timestamp
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "idc"
    }), /*#__PURE__*/_react.default.createElement("div", {
      className: "info"
    }, point.address || point.type !== _service.POINT_VIA ? /*#__PURE__*/_react.default.createElement("div", {
      className: "label"
    }, !point.address ? point.type === _service.POINT_START ? "出发地点" : "到达地点" : null, point.address ? /*#__PURE__*/_react.default.createElement("span", {
      className: "tag"
    }, point.type === _service.POINT_START ? "出发" : point.type === _service.POINT_END ? "到达" : "途径" + points.indexOf(point)) : null, point.timestamp ? /*#__PURE__*/_react.default.createElement("span", {
      className: "time"
    }, (0, _service.timeFormate)(point.timestamp)) : null) : null, point.address ? /*#__PURE__*/_react.default.createElement("div", {
      className: "location"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "title"
    }, point.address), /*#__PURE__*/_react.default.createElement("div", null, point.addrDescp)) : null, point.address && point.originalLocation ? /*#__PURE__*/_react.default.createElement("div", {
      className: "adjust"
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "weak-color"
    }, "\u7531"), point.originalLocation, /*#__PURE__*/_react.default.createElement("span", {
      className: "weak-color"
    }, "\u6539\u4E3A"), point.address) : null, point.address ? /*#__PURE__*/_react.default.createElement("div", {
      className: "action-box"
    }, /*#__PURE__*/_react.default.createElement("button", {
      className: "".concat(prefix, "-ng-button"),
      onClick: function onClick() {
        return onAdjustPoint(point, index);
      }
    }, "\u5730\u70B9\u5FAE\u8C03")) : null, !point.address && point.type === _service.POINT_VIA ? /*#__PURE__*/_react.default.createElement("button", {
      className: "".concat(prefix, "-ng-button outline"),
      onClick: function onClick() {
        return recordPoint(point, index);
      }
    }, "\u8BB0\u5F55\u9014\u7ECF\u70B9") : null), point.address && point.type === _service.POINT_VIA ? /*#__PURE__*/_react.default.createElement("span", {
      className: "close-icon",
      onClick: function onClick() {
        return onDelete(point);
      }
    }, /*#__PURE__*/_react.default.createElement("i", null, "x")) : null);
  }));
};

var _default = MileProcess;
exports.default = _default;