"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = require("lodash");

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _service = require("../service");

var _MileChange = _interopRequireDefault(require("./MileChange"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var prefix = _utils.default.prefixCls;

var MileageInfo = function MileageInfo(props) {
  var points = props.points,
      mileInfoProp = props.mileInfo,
      isOpen = props.isOpen,
      onClose = props.onClose,
      onViewTrackMap = props.onViewTrackMap;
  var onGenerate = props.onGenerate,
      onMileChange = props.onMileChange;
  var start = (0, _lodash.find)(points, {
    type: _service.POINT_START
  });
  var end = (0, _lodash.find)(points, {
    type: _service.POINT_END
  });

  var _useState = (0, _react.useState)({}),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      mileInfo = _useState2[0],
      setMileInfo = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      changeOpen = _useState4[0],
      setChangeOpen = _useState4[1];

  var distanceClass = (0, _classnames.default)("full gray-text", {
    "line-through": mileInfo.distance !== mileInfo.actualDistance
  });
  console.log(mileInfo);
  (0, _react.useEffect)(function () {
    var info = _objectSpread({}, mileInfoProp);

    if (!info.actualDistance) {
      info.actualDistance = info.distance;
    }

    setMileInfo(info);
  }, [mileInfoProp]);
  /**
   * 修改里程弹窗
   */

  var handleChangeMile = function handleChangeMile() {
    setChangeOpen(true);
  };

  var closeMileChange = function closeMileChange() {
    setChangeOpen(false);
  };

  var mileChangeOk = function mileChangeOk(distance) {
    setChangeOpen(false);
    setMileInfo(_objectSpread(_objectSpread({}, mileInfo), {}, {
      actualDistance: distance
    }));
    console.log(_objectSpread(_objectSpread({}, mileInfo), {}, {
      actualDistance: distance
    }));
    onMileChange(distance);
  };

  return /*#__PURE__*/_react.default.createElement(_modal.default, {
    visible: isOpen,
    onCancel: onClose,
    wrapClassName: "ngmk-modal-content",
    maskStyle: {
      position: "absolute"
    },
    style: {
      padding: 0,
      bottom: 0,
      top: "unset",
      position: "absolute"
    },
    bodyStyle: {
      padding: 0
    },
    width: "100%" // className="ngmk-modal-content bottom-position"
    // parentSelector={() => document.querySelector(`.${milePrefix}`)}
    // ariaHideApp={false}
    ,
    footer: null,
    getContainer: function getContainer() {
      return document.querySelector(".".concat(_service.milePrefix));
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-fee-generate ngmk-modal")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-content")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-point")
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "idc"
  }), start && start.address), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-point end")
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "idc"
  }), end && end.address)), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-img-box")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "content"
  }, /*#__PURE__*/_react.default.createElement("span", null, "\u884C\u9A76\u91CC\u7A0B\uFF1A", mileInfo.actualDistance || 0, " KM"), /*#__PURE__*/_react.default.createElement("button", {
    className: "".concat(prefix, "-ng-button no-padding"),
    onClick: onViewTrackMap
  }, "\u67E5\u770B\u884C\u7A0B\u8DEF\u7EBF"))), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-content")
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "content-info"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "half"
  }, "\u91CC\u7A0B\u6570"), /*#__PURE__*/_react.default.createElement("div", {
    className: "half right"
  }, mileInfo.actualDistance || 0, " KM"), mileInfo.distance !== mileInfo.actualDistance ? /*#__PURE__*/_react.default.createElement("div", {
    className: "full gray-text"
  }, "\u4FEE\u6539\u91CC\u7A0B\uFF1A", mileInfo.actualDistance, " KM") : null, /*#__PURE__*/_react.default.createElement("div", {
    className: distanceClass
  }, "\u53C2\u8003\u91CC\u7A0B\u6570\uFF1A", mileInfo.distance, " KM")), /*#__PURE__*/_react.default.createElement("div", {
    className: "content-info"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "half"
  }, "\u8865\u8D34\u603B\u989D"), /*#__PURE__*/_react.default.createElement("div", {
    className: "half right"
  }, mileInfo.ccySymbol + " " + mileInfo.amount || 0), /*#__PURE__*/_react.default.createElement("div", {
    className: "full gray-text"
  }, "\u5355\u4EF7\uFF1A", mileInfo.ccyCode + " " + mileInfo.unitAmount + "/KM"), /*#__PURE__*/_react.default.createElement("div", {
    className: "full right"
  }, /*#__PURE__*/_react.default.createElement("button", {
    className: "".concat(prefix, "-ng-button no-padding"),
    onClick: handleChangeMile
  }, "\u7F16\u8F91")))), /*#__PURE__*/_react.default.createElement("textarea", {
    className: "".concat(prefix, "-ng-textarea"),
    placeholder: "\u8BF7\u8F93\u5165\u4E8B\u7531"
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(_service.milePrefix, "-btn-box")
  }, /*#__PURE__*/_react.default.createElement("button", {
    className: "".concat(prefix, "-ng-button parimary full"),
    onClick: function onClick() {
      onGenerate(mileInfo);
    }
  }, "\u751F\u6210\u8D39\u7528"))), /*#__PURE__*/_react.default.createElement(_MileChange.default, {
    mileInfo: mileInfo,
    isOpen: changeOpen,
    onClose: closeMileChange,
    onOk: mileChangeOk
  }));
};

MileageInfo.propTypes = {
  points: _propTypes.default.array,
  mileInfo: _propTypes.default.object
};
MileageInfo.defaultProps = {
  points: [],
  mileInfo: {}
};
var _default = MileageInfo;
exports.default = _default;