"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

require("maycur-antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("maycur-antd/lib/radio"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash"));

var _cache = _interopRequireDefault(require("../utils/cache"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _i18next = _interopRequireDefault(require("i18next"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var t = _i18next.default.t;
var prefix = _utils.default.prefixCls;
var Group = _radio.default.Group,
    RadioButton = _radio.default.Button;
var Search = _input.default.Search;
/* 热门国内城市 */

var hotCityCodes = ['ZH1_0_00', 'ZH4_0_00', 'ZH9_4_01', 'ZH9_15_01', 'ZH32_1_01', 'ZH2_0_00', 'ZH28_3_01', 'ZH33_0_00'];
var localStore = _cache.default.localStore;

var CityList = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(CityList, _Component);

  var _super = _createSuper(CityList);

  function CityList(_props) {
    var _this;

    (0, _classCallCheck2.default)(this, CityList);
    _this = _super.call(this, _props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_PageHeaderBar').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.defaultProps = {
      type: 'expense',
      placeholder: t('MK_CityList:expensePlaceholder')
    };

    _this.getPlaceDataByCodes = function (codes, type) {
      var _this$props = _this.props,
          placesHashMap = _this$props.placesHashMap,
          bankPlacesHashMap = _this$props.bankPlacesHashMap;
      type = type || 'expense';
      var places = [];

      if (_lodash.default.isArray(codes)) {
        _lodash.default.each(codes, function (code) {
          if (code) {
            if (type === 'expense') {
              places.push(placesHashMap[code]);
            } else {
              places.push(bankPlacesHashMap[code]);
            }
          }
        });

        return places;
      } else {
        if (type === 'expense') {
          places.push(placesHashMap[codes]);
        } else {
          places.push(bankPlacesHashMap[codes]);
        }

        return places.length > 0 ? places[0] : undefined;
      }
    };

    _this.getSimpleCityName = function (code, type) {
      var _this$props2 = _this.props,
          placesHashMap = _this$props2.placesHashMap,
          bankPlacesHashMap = _this$props2.bankPlacesHashMap;
      type = type ? type : 'expense';
      var locationName = '';

      if (code) {
        var lastStrikethroughIndex = code.lastIndexOf('-'),
            placeCode = code.substr(lastStrikethroughIndex + 1),
            hashMap = type === 'expense' ? placesHashMap : bankPlacesHashMap;
        var place = hashMap[placeCode];

        if (place) {
          locationName = place.name;
        }
      }

      return locationName;
    };

    _this.formatPlaces = function (props) {
      var places = [];
      var type = props.type;

      if (type === 'bank') {
        var bankPlaces = props.bankPlaces;
        places = bankPlaces;
      } else {
        var expensePlaces = props.expensePlaces;
        places = expensePlaces;
      }

      if (places && places.length) {
        _this.setState({
          places: places,
          cityData: places[0].children,
          hotCity: _this.getPlaceDataByCodes(hotCityCodes),
          latestUseCity: _this.getPlaceDataByCodes(localStore.getItem('latestUseCityCodes')) || []
        });
      }
    };

    _this.handleClickOutside = function (evt) {
      _this.hideDropDown();
    };

    _this.hideDropDown = function () {
      var hideDropDown = _this.props.hideDropDown;

      _this.setState({
        searchValue: ''
      }, function () {
        if (typeof hideDropDown === 'function') {
          hideDropDown();
        }
      });
    };

    _this.expandNextLevelLocation = function (data, index) {
      var _this$state = _this.state,
          selectedCity = _this$state.selectedCity,
          places = _this$state.places;
      var afterChange = _this.props.afterChange;

      if (index) {
        selectedCity.length = index - 1;
      }

      selectedCity.push(data.code);

      if (!data.children) {
        if (typeof afterChange === 'function') {
          afterChange({
            value: {
              location: data.fullCode || selectedCity.join('-'),
              cityPair: null
            }
          });
        }

        _this.setCityToLatestUse(data.code);

        _this.setState({
          cityData: places[0].children,
          selectedCity: ['domestic']
        });

        _this.hideDropDown();
      } else {
        _this.setState({
          cityData: data.children,
          selectedCity: selectedCity
        });
      }
    };

    _this.setCityToLatestUse = function (code) {
      var hideFrequent = _this.props.hideFrequent;
      if (hideFrequent) return;
      var selectedIndex,
          latestUseCityCodes = localStore.getItem('latestUseCityCodes') || [];
      selectedIndex = _lodash.default.indexOf(latestUseCityCodes, code);

      if (selectedIndex !== -1) {
        latestUseCityCodes.splice(selectedIndex, 1);
      }

      latestUseCityCodes.unshift(code); // 最多保存8个最近使用的城市

      if (latestUseCityCodes.length > 8) {
        latestUseCityCodes.length = 8;
      }

      localStore.setItem('latestUseCityCodes', latestUseCityCodes);

      _this.setState({
        latestUseCity: _this.getPlaceDataByCodes(latestUseCityCodes)
      });
    };

    _this.handleCategoryChange = function (e) {
      var value = e.target.value;
      var places = _this.state.places;
      var cityData = places[0].children,
          selectedCity = ['domestic'];

      if (value === 'abroad') {
        cityData = places[1].children;
        selectedCity = ['abroad'];
      }

      _this.setState({
        cityData: cityData,
        selectedCity: selectedCity
      });
    };

    _this.state = {
      places: [],
      cityData: [],
      selectedCity: ['domestic'],
      hotCity: [],
      latestUseCity: [],
      searchValue: '',
      t: _mkTranslate.default.noop()
    };

    _this.localeProcess();
    /* lodash debounce不可以使用bind到this的操作，否则就无效 */


    _this.searchDebounce = _lodash.default.debounce(function (key) {
      _this.searchCity(key);
    }, 700);
    return _this;
  }

  (0, _createClass2.default)(CityList, [{
    key: "searchCity",
    value: // 城市搜索
    function searchCity(searchValue) {
      this.setState({
        searchValue: searchValue
      });
      var _this$props3 = this.props,
          type = _this$props3.type,
          placesHashMap = _this$props3.placesHashMap,
          bankPlacesHashMap = _this$props3.bankPlacesHashMap;
      var hashMap = type === 'bank' ? bankPlacesHashMap : placesHashMap;

      var leafNodes = _lodash.default.filter(hashMap, {
        isLeaf: true
      });

      if (searchValue) {
        var searchList = [];

        _lodash.default.each(leafNodes, function (area) {
          if (area.fuzzy.toLowerCase().indexOf(searchValue) !== -1) {
            searchList.push(area);
          }
        });

        this.setState({
          searchList: searchList
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.formatPlaces(this.props);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var type = nextProps.type;

      if (type === 'bank') {
        if (this.props.bankPlaces !== nextProps.bankPlaces) {
          this.formatPlaces(nextProps);
        }
      } else {
        if (this.props.expensePlaces !== nextProps.expensePlaces) {
          this.formatPlaces(nextProps);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          hideFrequent = _this$props4.hideFrequent,
          hideHot = _this$props4.hideHot,
          type = _this$props4.type,
          value = _this$props4.value,
          readOnly = _this$props4.readOnly,
          placeholder = _this$props4.placeholder;
      var _this$state2 = this.state,
          hotCity = _this$state2.hotCity,
          latestUseCity = _this$state2.latestUseCity,
          cityData = _this$state2.cityData,
          selectedCity = _this$state2.selectedCity,
          searchValue = _this$state2.searchValue,
          searchList = _this$state2.searchList,
          t = _this$state2.t;
      var singleValue = value && value.location;
      var cityName = this.getSimpleCityName(singleValue) || '';
      var rootCls = "".concat(prefix, "-city-list");
      return /*#__PURE__*/_react.default.createElement("div", {
        className: rootCls,
        ref: function ref(_ref) {
          _this2.dropdownRef = _ref;
        }
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(rootCls, "-display-value")
      }, singleValue ? /*#__PURE__*/_react.default.createElement("div", null, cityName) : /*#__PURE__*/_react.default.createElement("div", {
        className: "placeholder"
      }, readOnly ? t('MK_CityList:emptyText') : placeholder)), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(rootCls, "-search")
      }, /*#__PURE__*/_react.default.createElement(Search, {
        placeholder: t('searchPlaceholder'),
        onChange: function onChange(e) {
          _this2.searchDebounce(e.target.value);
        }
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(rootCls, "-city")
      }, searchValue ? /*#__PURE__*/_react.default.createElement("ul", {
        className: 'city-list-wrapper'
      }, searchList && searchList.map(function (city) {
        return /*#__PURE__*/_react.default.createElement("li", {
          key: city.code,
          className: 'city-item',
          onClick: function onClick() {
            _this2.expandNextLevelLocation(city);
          }
        }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("h4", {
          className: 'city-name'
        }, city.name), /*#__PURE__*/_react.default.createElement("p", {
          className: 'city-desc'
        }, city.fullName)), /*#__PURE__*/_react.default.createElement("div", {
          className: "flex-1"
        }), city.children && /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-angle-right"
        }));
      })) : null, !hideFrequent && !searchValue && latestUseCity && latestUseCity.length > 0 ? /*#__PURE__*/_react.default.createElement("div", {
        className: "hot-city-panel"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "sub-title"
      }, t('subTitle')), /*#__PURE__*/_react.default.createElement("div", {
        className: "hot-city-list"
      }, latestUseCity && latestUseCity.map(function (city, index) {
        return /*#__PURE__*/_react.default.createElement(_button.default, {
          key: index,
          onClick: function onClick(e) {
            e.stopPropagation();

            _this2.expandNextLevelLocation(city);
          }
        }, city.name);
      }))) : null, !hideHot && !searchValue ? /*#__PURE__*/_react.default.createElement("div", {
        className: "hot-city-panel"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "sub-title"
      }, t('hotCity')), /*#__PURE__*/_react.default.createElement("div", {
        className: "hot-city-list"
      }, hotCity && hotCity.map(function (city, index) {
        return /*#__PURE__*/_react.default.createElement(_button.default, {
          key: index,
          onClick: function onClick() {
            _this2.expandNextLevelLocation(city);
          }
        }, city.name);
      }))) : null, !searchValue ? /*#__PURE__*/_react.default.createElement("div", {
        className: "nav-panel"
      }, type === 'bank' ? null : /*#__PURE__*/_react.default.createElement(Group, {
        onChange: this.handleCategoryChange,
        defaultValue: "domestic",
        buttonStyle: "solid"
      }, /*#__PURE__*/_react.default.createElement(RadioButton, {
        value: "domestic"
      }, t('domestic')), /*#__PURE__*/_react.default.createElement(RadioButton, {
        value: "abroad"
      }, t('abroad'))), /*#__PURE__*/_react.default.createElement("div", {
        className: "crumb"
      }, selectedCity.map(function (cityCode, index) {
        var city = _this2.getPlaceDataByCodes(cityCode);

        return /*#__PURE__*/_react.default.createElement("span", {
          className: "crumb-item",
          key: cityCode,
          onClick: function onClick() {
            _this2.expandNextLevelLocation(city, index + 1);
          }
        }, city.name);
      }))) : null, !searchValue ? /*#__PURE__*/_react.default.createElement("ul", {
        className: 'city-list-wrapper'
      }, cityData && cityData.map(function (city) {
        return /*#__PURE__*/_react.default.createElement("li", {
          key: city.code,
          className: 'city-item',
          onClick: function onClick() {
            _this2.expandNextLevelLocation(city);
          }
        }, /*#__PURE__*/_react.default.createElement("span", null, city.name), /*#__PURE__*/_react.default.createElement("div", {
          className: "flex-1"
        }), city.children && /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-angle-right"
        }));
      })) : null));
    }
  }]);
  return CityList;
}(_react.Component);

CityList.propTypes = {
  /** 城市选择的类型  */
  type: _propTypes.default.string,

  /** 普通城市映射字段信息  */
  placesHashMap: _propTypes.default.object,

  /** 银行城市映射字段信息  */
  bankPlacesHashMap: _propTypes.default.object,

  /**  隐藏常用功能 */
  hideFrequent: _propTypes.default.bool,

  /**  隐藏热点城市功能 */
  hideHot: _propTypes.default.bool,

  /**  当前选择城市的为空的占位符 */
  placeholder: _propTypes.default.string
};
var _default = CityList;
exports.default = _default;