"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function commonComparator(sourceList, fieldValue, isPositive) {
  var _fieldValue;

  if (_lodash.default.isObject(fieldValue)) {
    _fieldValue = fieldValue.code;
  } else {
    _fieldValue = fieldValue;
  }

  var bool = _lodash.default.indexOf(sourceList, _fieldValue) !== -1;
  return isPositive ? bool : !bool;
}
/**
 * 部门选择控件(包含子部门)里面返回的fieldValue的数据结构如下,并且唯一标识是code
 * [{code}]
 */


function departmentComparator(sourceList, fieldValue, isPositive) {
  return _lodash.default.every(Array.isArray(fieldValue) ? fieldValue : [fieldValue], function (item) {
    var bool = _lodash.default.intersection(_lodash.default.split(sourceList, ','), _lodash.default.split(item.heirCode, '.')).length > 0;
    return isPositive ? bool : !bool;
  });
}

function comparaRules(condition, data, isPositive) {
  var field = condition.field,
      identifier = condition.identifier;
  var fieldValue = data[identifier];

  var sourceList = _lodash.default.split(condition.valueCodes, ','); //当值为空的时候，属于条件返回false，不属于返回true


  if (_lodash.default.isEmpty(fieldValue)) {
    return !isPositive;
  }

  var result;

  switch (field) {
    case 'WEB_CHECK_COVER_DEPARTMENT_CODE':
      // 含下级部门
      result = departmentComparator(sourceList, fieldValue, isPositive);
      break;

    default:
      result = commonComparator(sourceList, fieldValue, isPositive);
      break;
  }

  return result;
}
/**
 * 
 * @param {*} condition 条件
 * @param {*} data 表单数据对象
 * @param {*} isPositive 是否包含
 */


function LIKE(condition, data, isPositive) {
  return comparaRules(condition, data, isPositive);
}

var _default = LIKE;
exports.default = _default;