"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _constants = require("./constants");

var _lodash = _interopRequireDefault(require("lodash"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var ConditionItem = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(ConditionItem, _Component);

  var _super = _createSuper(ConditionItem);

  function ConditionItem(props) {
    var _this;

    (0, _classCallCheck2.default)(this, ConditionItem);
    _this = _super.call(this, props);

    _this.toggleClick = function (e) {
      var _this$props = _this.props,
          onToggle = _this$props.onToggle,
          node = _this$props.node,
          onSelected = _this$props.onSelected,
          mode = _this$props.mode;
      if (mode === 'PREVIEW') return; //const targetNode = this.findNodeData(treeData, e.target.id);

      if (_this.isNodeSelected(node)) {
        onToggle(node, !node.active);
      }

      onSelected(node);
      e.stopPropagation();
    };

    _this.isNodeSelected = function (node) {
      var selectedNode = _this.props.selectedNode;
      return node.code === selectedNode.code;
    };

    _this.selectChild = function (e) {
      var _this$props2 = _this.props,
          node = _this$props2.node,
          onSelected = _this$props2.onSelected,
          mode = _this$props2.mode;
      if (mode === 'PREVIEW') return;
      onSelected(node);
      e.stopPropagation();
    };

    _this.deleteNode = function (code, e) {
      _this.props.onDeleteNode(code);

      e.stopPropagation();
    };

    _this.isFieldComplete = function (node) {
      if (node.opType === 'IS_EMPTY') return true;

      switch (node.field) {
        case 'APPROVED_AMOUNT_COMPARE_APPLY_AMOUNT':
        case 'EXISTED_EXTERNAL_VALIDATION_RESULT':
        case 'IS_COVER_DEPARTMENT_PRINCIPLE':
          return node.field && node.opType;

        default:
          return node.field && node.opType && node.value1;
      }
    };

    _this.renderRedularName = function (node) {
      var initData = _this.props.initData;

      var regular = _lodash.default.find(initData['EXPENSE_REGULATE'], {
        code: node.value1
      });

      return regular && regular.name;
    };

    _this.renderValueName = function (value, key) {
      if (['LEGAL_ENTITY', 'LegalEntityInput'].indexOf(key) !== -1) {
        return _lodash.default.map(value, 'invoiceTitle').join(',');
      } else if (["EXPENSE_TYPE_AMOUNT_INCLUDE_DEDUCTION", "VICE_EXPENSE_TYPE_AMOUNT", "AGGREGATED_EXPENSE_TYPE_AMOUNT"].indexOf(key) !== -1) {
        return _lodash.default.map(value, 'expenseTypeName').join(',');
      }

      return _lodash.default.map(value, 'name').join(',');
    };

    _this.renderConditonItem = function (node) {
      switch (node.field) {
        case 'BUDGET_OCCUPY_PERCENT':
          return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
            className: "operator"
          }, _constants.WORD_MAP[node.opType] || '?'), /*#__PURE__*/_react.default.createElement("span", {
            className: "value"
          }, node.value1 || '?', " %"));

        case 'EXISTED_EXTERNAL_VALIDATION_RESULT':
        case 'IS_COVER_DEPARTMENT_PRINCIPLE':
        case 'APPLICATION_QUOTA':
          return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
            className: "operator"
          }, !node.opType ? '?' : node.opType === 'EQ' ? _this.t('yes') : _this.t('no')));

        default:
          return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
            className: "operator"
          }, _constants.WORD_MAP[node.opType] || '?'), node.opType === 'IS_EMPTY' ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null) : node.temp && node.temp.value1 ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
            className: "value"
          }, _this.renderValueName(node.temp.value1, node.field)), /*#__PURE__*/_react.default.createElement("span", {
            className: "total"
          }, _this.t('total'), /*#__PURE__*/_react.default.createElement("span", {
            className: "num"
          }, node.temp.value1.length), _this.t('item'))) : node.temp && node.temp.value2 ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
            className: "value"
          }, "\xA0", _this.renderValueName(node.temp.value2, node.field)), /*#__PURE__*/_react.default.createElement("span", {
            className: "total"
          }, _this.t('total'), /*#__PURE__*/_react.default.createElement("span", {
            className: "num"
          }, node.temp.value2.length), _this.t('item'))) : node.field === 'ASSOCIATION_APPLICATION' ? /*#__PURE__*/_react.default.createElement("span", {
            className: "value"
          }, node.value1 === 'ALL' && _this.t('AllRequestTypes')) : node.field === 'EXPENSE_REGULATE' ? /*#__PURE__*/_react.default.createElement("span", null, _this.renderRedularName(node)) : node.field !== 'REFERENCE_DATA_DETAIL' && node.field !== 'APPROVED_AMOUNT_COMPARE_APPLY_AMOUNT' ? /*#__PURE__*/_react.default.createElement("span", {
            className: "value"
          }, node.value1 || '?') : '');
      }
    };

    _this.renderName = function () {
      var _field;

      var _this$props3 = _this.props,
          node = _this$props3.node,
          initData = _this$props3.initData,
          conditionBuilder = _this$props3.conditionBuilder;
      var field = null;

      if (node.conditionSource === 'CUSTOM') {
        var _node$temp;

        field = node === null || node === void 0 ? void 0 : (_node$temp = node.temp) === null || _node$temp === void 0 ? void 0 : _node$temp.fieldConfig;
      } else {
        field = _lodash.default.find(conditionBuilder && conditionBuilder.getConditionOptions(initData === null || initData === void 0 ? void 0 : initData.processType, 'NODE', initData === null || initData === void 0 ? void 0 : initData.functionList), {
          value: node.field
        }) || {};
      }

      return ((_field = field) === null || _field === void 0 ? void 0 : _field.name) || '--';
    };

    _this.t = _mkTranslate.default.getLocalNs('MK_ConditionSetting', (0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(ConditionItem, [{
    key: "render",
    value:
    /**
     * Refactor：
     * 这块代码需要重构，将条件在树里面回显的代码和检验是否完整的代码都写在相应的form里面，这里只管调用
     */
    function render() {
      var _this2 = this;

      var _this$props4 = this.props,
          node = _this$props4.node,
          children = _this$props4.children;
      return /*#__PURE__*/_react.default.createElement("li", {
        key: node.code
      }, node.conditionType === "RELATION" ? /*#__PURE__*/_react.default.createElement("div", {
        onClick: this.toggleClick
      }, /*#__PURE__*/_react.default.createElement("div", {
        id: node.code,
        className: "parent-wrap node-wrap ".concat(this.isNodeSelected(node) ? 'selected' : '')
      }, node.opType ? /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement("i", {
        className: "fm fm-angle-right ".concat(node.active ? "expanded" : "")
      }), /*#__PURE__*/_react.default.createElement("i", {
        className: "fm fm-list"
      }), _constants.WORD_MAP[node.opType]) : /*#__PURE__*/_react.default.createElement("span", {
        className: "not-complete"
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "fm fm-info-o"
      }), this.t('conditionSetNotConfigured')), !node.isRoot && /*#__PURE__*/_react.default.createElement("span", {
        className: "del-node-wrap",
        onClick: function onClick(e) {
          _this2.deleteNode(node.code, e);
        }
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "fm fm-cross"
      }))), /*#__PURE__*/_react.default.createElement("div", null, children)) : /*#__PURE__*/_react.default.createElement("div", {
        className: "child-wrap node-wrap ".concat(this.isNodeSelected(node) ? 'selected' : ''),
        onClick: this.selectChild
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: this.isFieldComplete(node) ? "complete" : "not-complete",
        style: {
          display: 'flex'
        }
      }, this.isFieldComplete(node) ? /*#__PURE__*/_react.default.createElement("i", {
        className: "fm fm-circle"
      }) : /*#__PURE__*/_react.default.createElement("i", {
        className: "fm fm-info-o"
      }), /*#__PURE__*/_react.default.createElement("span", {
        className: "field-key"
      }, this.renderName()), this.renderConditonItem(node), !node.isRoot && /*#__PURE__*/_react.default.createElement("span", {
        className: "del-node-wrap",
        onClick: function onClick(e) {
          _this2.deleteNode(node.code, e);
        }
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "fm fm-cross"
      })))));
    }
  }]);
  return ConditionItem;
}(_react.Component);
/* const mapStateToProps = (state) => {
    return {
        process: state.commonData.process,
        initData: state.commonData.init
    }
} */


var _default = ConditionItem;
exports.default = _default;