"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _mkSelect = _interopRequireDefault(require("../../Process/mkSelect"));

var _optionPicker = _interopRequireDefault(require("../../Process/optionPicker"));

var _TranslateHook = _interopRequireDefault(require("../../hooks/TranslateHook"));

var _constants = _interopRequireDefault(require("../../utils/constants"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var OPTION_PICKER = _constants.default.OPTION_PICKER;

var Option = function Option(props) {
  var t = (0, _TranslateHook.default)('MK_ConditionSetting');
  var selectedNode = props.selectedNode,
      handleTempChange = props.handleTempChange,
      fieldConfig = props.fieldConfig,
      apis = props.apis,
      ModalManager = props.ModalManager;

  var _ref = fieldConfig || {},
      dataSource = _ref.dataSource,
      sourceMode = _ref.sourceMode,
      manualItems = _ref.manualItems;

  var isSelectCategory = false;

  try {
    var arr = selectedNode.key.split('-');
    isSelectCategory = arr[arr.length - 1] === OPTION_PICKER.MOCK_OPTION_INPUT_CATEGORY;
  } catch (error) {
    console.log(error);
  }

  var handleOptionChange = function handleOptionChange(data) {
    handleTempChange(data, 'code', 'value1');
  };

  var formatManualItems = manualItems === null || manualItems === void 0 ? void 0 : manualItems.map(function (item) {
    return _objectSpread(_objectSpread({}, item), {}, {
      value: item.code
    });
  });
  return /*#__PURE__*/_react.default.createElement("div", null, sourceMode === 'DATA_SOURCE' ? /*#__PURE__*/_react.default.createElement("div", {
    className: "option-picker"
  }, /*#__PURE__*/_react.default.createElement("label", null, t('object')), /*#__PURE__*/_react.default.createElement(_optionPicker.default, {
    code: dataSource,
    value: selectedNode.temp.value1,
    group: dataSource,
    onChange: handleOptionChange,
    ModalManager: ModalManager,
    isSelectCategory: isSelectCategory,
    apis: apis
  })) : /*#__PURE__*/_react.default.createElement(_mkSelect.default, {
    label: t('object'),
    onChange: function onChange(value) {
      var temp = formatManualItems.filter(function (d) {
        return value.indexOf(d.value) !== -1;
      });
      handleTempChange(temp, 'code', 'value1');
    },
    mode: "multiple",
    value: selectedNode.value1 ? selectedNode.value1.split(',') : [],
    options: formatManualItems
  }));
};

var _default = Option;
exports.default = _default;