"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _reactI18next = require("react-i18next");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Search = _input.default.Search;
var basicCls = "".concat(_utils.default.prefixCls, "-currency-selector");

function CurrencyItem(props) {
  var currency = props.currency,
      handleClick = props.handleClick;
  var itemCls = "".concat(basicCls, "-item");
  return /*#__PURE__*/_react.default.createElement("div", {
    onClick: function onClick() {
      handleClick(currency);
    },
    className: itemCls
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "".concat(itemCls, "_code")
  }, currency.code), /*#__PURE__*/_react.default.createElement("span", {
    className: "".concat(itemCls, "_divider")
  }, "-"), /*#__PURE__*/_react.default.createElement("span", {
    className: "".concat(itemCls, "_name")
  }, currency.name));
}

var CurrencySelector = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(CurrencySelector, _Component);

  var _super = _createSuper(CurrencySelector);

  function CurrencySelector(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CurrencySelector);
    _this = _super.call(this, props);

    _this.switch = function (val) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          visibleChange = _this$props.visibleChange;

      if (!disabled) {
        _this.setState({
          visible: val,
          searchKey: ''
        });

        if (typeof visibleChange === 'function') visibleChange(val);
      }
    };

    _this.close = function () {
      var visibleChange = _this.props.visibleChange;
      if (typeof visibleChange === 'function') visibleChange(false);

      _this.setState({
        visible: false,
        searchKey: ''
      });
    };

    _this.search = function (key) {
      _this.setState({
        searchKey: key || ''
      });
    };

    _this.choose = function (currency) {
      var onChange = _this.props.onChange;

      if (typeof onChange === 'function') {
        onChange(currency);
      }

      _this.close();
    };

    _this.onPopupVisibleChange = function (val) {
      var readOnly = _this.props.readOnly;
      if (readOnly) return;

      _this.switch(val);
    };

    _this.state = {
      visible: false,
      searchKey: ''
    };
    return _this;
  }

  (0, _createClass2.default)(CurrencySelector, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          currencyList = _this$props2.data,
          latestCurrencys = _this$props2.latestCurrencys,
          popWidth = _this$props2.popWidth,
          _this$props2$offset = _this$props2.offset,
          offset = _this$props2$offset === void 0 ? [] : _this$props2$offset,
          loading = _this$props2.loading,
          t = _this$props2.t,
          isShowRecentlyUse = _this$props2.isShowRecentlyUse;
      var _this$state = this.state,
          searchKey = _this$state.searchKey,
          visible = _this$state.visible;

      var MainList = /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "-wrapper")
      }, loading ? null : /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "-search")
      }, /*#__PURE__*/_react.default.createElement(Search, {
        type: "gray",
        placeholder: t("请输入货币简称名称搜索"),
        onChange: function onChange(e) {
          _this2.search(e.target.value);
        }
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "-body")
      }, searchKey || !isShowRecentlyUse ? null : /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "-latest")
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "-label")
      }, t('最近使用')), currencyList.map(function (currency) {
        var itemProps = {
          currency: currency,
          handleClick: _this2.choose,
          key: currency.code
        };
        var itemVisible = false;

        if (latestCurrencys && latestCurrencys.length > 0 && latestCurrencys.includes(currency.code)) {
          itemVisible = true;
        }

        return itemVisible ? /*#__PURE__*/_react.default.createElement(CurrencyItem, itemProps) : null;
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "-list")
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "-label")
      }, t('货币类型')), currencyList.map(function (currency) {
        var itemProps = {
          currency: currency,
          handleClick: _this2.choose,
          key: currency.code
        };
        var itemVisible = true;
        var isSearch = !!searchKey;

        if (isSearch) {
          var reg = new RegExp(searchKey, 'i');

          if (reg.test(currency.code) || reg.test(currency.name)) {
            itemVisible = true;
          } else {
            itemVisible = false;
          }
        }

        return itemVisible ? /*#__PURE__*/_react.default.createElement(CurrencyItem, itemProps) : null;
      }))), loading ? /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(basicCls, "-loading")
      }) : null);

      return /*#__PURE__*/_react.default.createElement(_rcTrigger.default, {
        action: ['click'],
        popupVisible: visible,
        destroyPopupOnHide: true,
        onPopupVisibleChange: this.onPopupVisibleChange,
        popupAlign: {
          points: ['tl', 'bl'],
          offset: offset
        },
        popupClassName: basicCls,
        popupStyle: {
          width: popWidth
        },
        popup: MainList
      }, this.props.children);
    }
  }]);
  return CurrencySelector;
}(_react.Component);

CurrencySelector.defaultProps = {
  data: [],
  latestCurrencys: [],
  //保存的是货币的code信息
  popWidth: 300,
  disabled: false,
  loading: false,
  //加载状态
  isShowRecentlyUse: true //是否显示最近使用

};
CurrencySelector.propTypes = {
  /** 所有可选货币数据  */
  data: _propTypes.default.array,

  /** 最近被选过的货币代号  */
  latestCurrencys: _propTypes.default.array,

  /** 选择组件的宽度  */
  popWidth: _propTypes.default.number,
  visibleChange: _propTypes.default.func,
  loading: _propTypes.default.bool
};

var _default = (0, _reactI18next.withTranslation)('MK_CurrencySelector')(CurrencySelector);

exports.default = _default;