"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

require("maycur-antd/lib/tooltip/style/css");

var _tooltip = _interopRequireDefault(require("maycur-antd/lib/tooltip"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _DownloadList = _interopRequireDefault(require("./DownloadList"));

var _TranslateHook = _interopRequireDefault(require("../hooks/TranslateHook"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefix = _utils.default.prefixCls;

function DownloadCenter(props) {
  var t = (0, _TranslateHook.default)('MK_Download');
  var menu = props.menu,
      api = props.api,
      visible = props.visible;

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      download = _useState2[0],
      setDownload = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      Err = _useState4[0],
      setErr = _useState4[1];

  var _useState5 = (0, _react.useState)([]),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      dataList = _useState6[0],
      setDataList = _useState6[1];

  var _useState7 = (0, _react.useState)([]),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      typeList = _useState8[0],
      setTypeList = _useState8[1];

  var _useState9 = (0, _react.useState)(''),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      key = _useState10[0],
      setKey = _useState10[1];

  var dateRef = (0, _react.useRef)(null);
  var downloadCenterHistorty = (0, _react.useCallback)(function () {
    var DownloadHistortyFetcher = setInterval(function () {
      api.downloadCenterHistorty({
        keyword: key
      }).then(function (res) {
        if (res && res.code === 'ACK') {
          if (res.data.length === 0) {
            clearInterval(DownloadHistortyFetcher);
            setDownload(false);
          } else {
            var isOk = _lodash.default.findIndex(res.data, function (i) {
              return i.exportStatus === 'PROCESSING' || i.exportStatus === 'SUBMITTED';
            });

            if (isOk === -1) {
              clearInterval(DownloadHistortyFetcher);
              setDownload(false);
            } else {
              setDownload(true);
            }

            var isErr = _lodash.default.findIndex(res.data, function (i) {
              return i.exportStatus === 'ERROR';
            });

            if (isErr === -1) {
              setErr(false);
            } else {
              setErr(true);
            }

            setDataList(res.data);
          }
        }
      }).catch(function (err) {
        setDownload(false);
        clearInterval(DownloadHistortyFetcher);
      });
    }, 6000);
  }, [api, key]);
  var getDownloadCenterHistorty = (0, _react.useCallback)(function () {
    api.downloadCenterHistorty({
      keyword: key
    }).then(function (res) {
      if (res && res.code === 'ACK') {
        if (res.data.length === 0) {
          setDownload(false);
        } else {
          var isOk = _lodash.default.findIndex(res.data, function (i) {
            return i.exportStatus === 'PROCESSING' || i.exportStatus === 'SUBMITTED';
          });

          if (isOk === -1) {
            setDownload(false);
          } else {
            setDownload(true);
          }

          var isErr = _lodash.default.findIndex(res.data, function (i) {
            return i.exportStatus === 'ERROR';
          });

          if (isErr === -1) {
            setErr(false);
          } else {
            setErr(true);
          }
        }

        setDataList(res.data);
      }
    }).catch(function (err) {
      setDownload(false);
    });
  }, [api, key]);

  var searchData = function searchData(key) {
    setKey(key);
  };

  var downloadCentertype = (0, _react.useCallback)(function () {
    api.downloadCentertype().then(function (resp) {
      if (resp && resp.code === 'ACK') {
        setTypeList(resp.data);
      }
    }).catch(function (error) {
      console.log('error', error); // eslint-disable-line
    });
  }, [api]);
  (0, _react.useEffect)(function () {
    downloadCentertype();
    getDownloadCenterHistorty();
    downloadCenterHistorty();

    if (visible) {
      dateRef.current.dispatchEvent(new MouseEvent('click', {
        bubbles: true
      }));
    }
  }, [downloadCenterHistorty, getDownloadCenterHistorty, downloadCentertype, visible]);
  return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_popover.default, {
    placement: "bottom",
    content: /*#__PURE__*/_react.default.createElement(_DownloadList.default, {
      api: api,
      typeList: typeList,
      getDownloadCenterHistorty: getDownloadCenterHistorty,
      dataList: dataList,
      searchData: searchData
    }),
    trigger: "click"
  }, /*#__PURE__*/_react.default.createElement(_tooltip.default, {
    placement: "bottom",
    title: t('downloadCenter')
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-download-menus")
  }, /*#__PURE__*/_react.default.createElement("span", {
    ref: dateRef,
    className: "fm ".concat(download ? 'fm-download2' : 'fm-cloud-download'),
    style: {
      fontSize: menu.iconSize || '18px'
    }
  }), Err ? /*#__PURE__*/_react.default.createElement("span", {
    style: {
      color: 'red',
      fontSize: '12px',
      position: 'absolute',
      left: '30px'
    },
    className: "fm fm-info-o"
  }) : null))));
}

var _default = DownloadCenter;
exports.default = _default;