"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _EditableTableContext = require("./EditableTableContext");

var _excluded = ["editable", "field", "record", "handleRowChange", "children", "privateProps", "publicProps", "rowIndex", "columnIndex"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function HocEditableCell(FormFood) {
  return /*#__PURE__*/function (_Component) {
    (0, _inherits2.default)(EditableCell, _Component);

    var _super = _createSuper(EditableCell);

    function EditableCell() {
      var _this;

      (0, _classCallCheck2.default)(this, EditableCell);

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      _this = _super.call.apply(_super, [this].concat(args));

      _this.renderCell = function (_ref) {
        var form = _ref.form,
            formReady = _ref.formReady,
            formChefFormFields = _ref.formChefFormFields,
            rowsPublicProps = _ref.rowsPublicProps;
        var _this$props = _this.props,
            identifier = _this$props.identifier,
            privateProps = _this$props.privateProps,
            publicProps = _this$props.publicProps,
            readOnly = _this$props.readOnly,
            rowIndex = _this$props.rowIndex,
            columnIndex = _this$props.columnIndex;

        var matchedFormChefField = _lodash.default.find(formChefFormFields, {
          identifier: identifier
        });

        return formReady && matchedFormChefField && /*#__PURE__*/_react.default.createElement(FormFood, {
          form: form,
          field: matchedFormChefField,
          fieldStyleCategory: "origin",
          isInTable: true,
          privateProps: privateProps,
          publicProps: _objectSpread(_objectSpread({}, publicProps), rowsPublicProps),
          EditableContext: _EditableTableContext.EditableContext,
          readOnly: readOnly,
          rowIndex: rowIndex,
          columnIndex: columnIndex
        });
      };

      return _this;
    }

    (0, _createClass2.default)(EditableCell, [{
      key: "render",
      value: function render() {
        var _this$props2 = this.props,
            editable = _this$props2.editable,
            field = _this$props2.field,
            record = _this$props2.record,
            handleRowChange = _this$props2.handleRowChange,
            children = _this$props2.children,
            privateProps = _this$props2.privateProps,
            publicProps = _this$props2.publicProps,
            rowIndex = _this$props2.rowIndex,
            columnIndex = _this$props2.columnIndex,
            restProps = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);
        return /*#__PURE__*/_react.default.createElement("td", restProps, editable ? /*#__PURE__*/_react.default.createElement(_EditableTableContext.EditableContext.Consumer, null, this.renderCell) : children);
      }
    }]);
    return EditableCell;
  }(_react.Component);
}

var _default = HocEditableCell;
exports.default = _default;