"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _EditableTableContext = require("./EditableTableContext");

var _FormChef = _interopRequireDefault(require("../../FormChef"));

var _ev = _interopRequireDefault(require("../../utils/ev"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _lodash = _interopRequireDefault(require("lodash"));

var _excluded = ["formValue", "form", "formFields", "updateRowForms", "FormDish", "FormBuild", "formChange", "rowIndex", "formState", "genPreFormulas", "rowsPublicProps"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var EditableRow = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var formValue = props.formValue,
      form = props.form,
      formFields = props.formFields,
      updateRowForms = props.updateRowForms,
      FormDish = props.FormDish,
      FormBuild = props.FormBuild,
      formChange = props.formChange,
      rowIndex = props.rowIndex,
      _props$formState = props.formState,
      formReady = _props$formState.formReady,
      formChefFormFields = _props$formState.formFields,
      genPreFormulas = props.genPreFormulas,
      rowsPublicProps = props.rowsPublicProps,
      restProps = (0, _objectWithoutProperties2.default)(props, _excluded);
  var formInstantiate = form.formInstantiate,
      initData = form.initData,
      rebuildForm = form.rebuildForm;
  var isInit = (0, _react.useRef)(false);
  var prevFormFields = (0, _react.useRef)(formFields);
  var updateRowForm = (0, _react.useCallback)(function (isDestroy) {
    var rowForm = isDestroy ? undefined : form;
    updateRowForms((0, _defineProperty2.default)({}, "".concat(props['data-row-key']), rowForm));
  }, [form, props, updateRowForms]);
  var formatFormFields = (0, _react.useCallback)(function () {
    var _formFields = []; // 单元格合并

    _lodash.default.each(formFields, function (field) {
      if (field.children) {
        var children = _lodash.default.map(field.children, function (child) {
          return _objectSpread(_objectSpread({}, child), {}, {
            children: null
          });
        });

        _formFields.push.apply(_formFields, (0, _toConsumableArray2.default)(children));
      } else {
        _formFields.push(field);
      }
    });

    return _formFields;
  }, [formFields]);
  (0, _react.useEffect)(function () {
    if (typeof ref === 'function') ref({
      props: props
    });
    updateRowForm();
    return function () {
      return updateRowForm(true);
    };
  }, [props, ref, updateRowForm]);
  (0, _react.useEffect)(function () {
    function formInit() {
      return _formInit.apply(this, arguments);
    }

    function _formInit() {
      _formInit = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
        var instanceOptions, _formFields, _formFields2;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (isInit.current) {
                  _context.next = 10;
                  break;
                }

                isInit.current = true;
                instanceOptions = {};
                _formFields = formatFormFields();
                /* TODO 加入数据外联的规则生成步骤 */

                if (typeof genPreFormulas === 'function') instanceOptions.preDefinedFormulas = genPreFormulas(_formFields);
                _context.next = 7;
                return formInstantiate(_formFields, instanceOptions);

              case 7:
                initData(formValue, rowsPublicProps.isNew);
                _context.next = 15;
                break;

              case 10:
                if (!(formFields !== prevFormFields.current)) {
                  _context.next = 15;
                  break;
                }

                _formFields2 = formatFormFields();
                _context.next = 14;
                return rebuildForm(_formFields2);

              case 14:
                prevFormFields.current = formFields;

              case 15:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _formInit.apply(this, arguments);
    }

    if (formFields && formFields.length) {
      formInit(formFields);
    }
  }, [formFields, formValue, initData, formInstantiate, rebuildForm, formatFormFields, genPreFormulas, rowsPublicProps]);
  return formReady && /*#__PURE__*/_react.default.createElement(_EditableTableContext.EditableContext.Provider, {
    value: {
      form: form,
      formReady: formReady,
      formChefFormFields: formChefFormFields,
      rowsPublicProps: rowsPublicProps
    }
  }, /*#__PURE__*/_react.default.createElement("tr", restProps));
});

var HocEditableRow = function HocEditableRow(FieldFood) {
  var t = _mkTranslate.default.getLocalNs('MK_FormFields');

  return (0, _FormChef.default)({
    isValueMap: true,
    extra: {
      api: {// TODO 传入方法
        // fetchExternalOptionData: baseService.fetchExternalOptionData 
      },
      emitter: _ev.default,
      isInTable: true
    },
    cookerOption: {
      validateMessages: {
        required: function required() {
          return t('validation.mustInput');
        },
        string: {
          max: function max(name, maxLength) {
            return t('validation.maxLength', {
              maxLength: maxLength
            });
          }
        }
      }
    },
    FormDish: FieldFood
  })(EditableRow);
};

var _default = HocEditableRow;
exports.default = _default;