"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _DemoFormChef = _interopRequireDefault(require("./DemoFormChef"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var mockFormFields = [{
  identifier: 'name',
  type: 'SingleTextInput',
  editable: true,
  property: {
    label: '名称',
    isFieldHide: false,
    required: true,
    maxShowLength: 2,
    placeholder: '请输入名称',
    maxSelectLength: -1
  }
}, {
  identifier: 'unit',
  type: 'AmountInput',
  editable: true,
  property: {
    label: '单价',
    required: true,
    isFieldHide: false,
    placeholder: '请输入单价'
  }
}, {
  identifier: 'count',
  type: 'NumberField',
  editable: true,
  property: {
    label: '数量',
    required: true,
    isFieldHide: false,
    valueFormat: '00',
    placeholder: '请输入数量'
  }
}, {
  identifier: 'totalAmount',
  type: 'AmountInput',
  editable: true,
  property: {
    label: '总金额',
    isFieldHide: false,
    placeholder: '请输入总金额'
  }
}, {
  identifier: 'linkField',
  type: 'NumberField',
  editable: true,
  property: {
    label: '外网数据',
    isFieldHide: false,
    valueFormat: '00',
    placeholder: '请输入外网数据'
  }
}, {
  identifier: 'linkField2',
  type: 'NumberField',
  editable: true,
  property: {
    label: '内网数据',
    isFieldHide: false,
    valueFormat: '00',
    placeholder: '请输入内网数据'
  }
}];

function Demo(props) {
  var form = props.form;
  (0, _react.useEffect)(function () {
    form.formInstantiate(mockFormFields, {
      preDefinedFormulas: [{
        targetField: 'totalAmount',
        referField: 'count',
        formula: 'count*unit'
      }, {
        targetField: 'totalAmount',
        referField: 'unit',
        formula: 'count*unit'
      }, {
        targetField: 'totalAmount',
        referField: 'linkField',
        asyncFn: function asyncFn(formData, fieldData) {
          return new Promise(function (resolve, reject) {
            var fieldValue = fieldData.value;
            setTimeout(function () {
              resolve({
                status: 'success',
                data: fieldValue * 5
              });
            }, 2000);
          });
        }
      }, {
        targetField: 'linkField',
        referField: 'linkField2',
        formula: 'linkField2*8'
      }, {
        targetField: 'count',
        referField: 'linkField2',
        formula: 'linkField2+3'
      }]
    }).then(function () {
      form.initData({});
    });
  }, [form]);
  return /*#__PURE__*/_react.default.createElement("div", null, form.cookForm());
}

var _default = (0, _DemoFormChef.default)({})(Demo);

exports.default = _default;