"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _asyncValidator = _interopRequireDefault(require("async-validator"));

var _lodash = require("lodash");

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var ruleMap = {
  required: 'required',
  maxLength: 'max'
};
var defaultMessage = {
  required: '%s 必填',
  max: '%s 最大值'
}; //给schema增加addRule规则

_asyncValidator.default.prototype.addRule = function (name, rule) {
  if (name && rule && !(0, _lodash.isEmpty)(rule)) {
    var theRule = this.rules[name] || [];
    var hasExist = false;

    if (theRule.length > 0) {
      (0, _lodash.forEach)(theRule, function (r) {
        if ((0, _lodash.isEqual)(rule, r)) {
          hasExist = true;
          return false;
        }
      });
    }

    if (!hasExist) {
      theRule = theRule.concat(Array.isArray(rule) ? rule : [rule]);
      this.rules[name] = theRule;
    }
  }
};

var customRules = {};

function buildCustomRules() {
  var t = _mkTranslate.default.getLocalNs('MK_FormFields');

  var pairRequire = function pairRequire(rule, value, callback, source, options, field) {
    var errorMsg;

    if (field.property.required) {
      if (value !== undefined && value !== null) {
        var validResult = true;
        (0, _lodash.forEach)(value, function (v, k) {
          if (v === undefined || v === null) {
            validResult = false;
          }
        });
        if (!validResult) errorMsg = t('validation.wholeDataInfo');
      } else {
        errorMsg = t('validation.wholeDataInfo');
      }
    }

    callback(errorMsg || '');
  };
  /* 每刻城市必填行校验 */


  var CityInput = function CityInput(rule, value, callback, source, options, field) {
    var errorMsg;

    if (field.property.required) {
      var _options$formFields = options.formFields,
          formFields = _options$formFields === void 0 ? {} : _options$formFields;
      var fieldInfo = (0, _lodash.find)(formFields, {
        identifier: rule.fullField
      });
      var selectionModule = fieldInfo ? fieldInfo.property.selectionModule : 'SINGLE';

      if (value !== undefined && value !== null) {
        var singleValue = value.location;
        var pairValue = value.cityPair;
        var validResult = true;

        if (selectionModule === 'SINGLE' && singleValue) {
          validResult = true;
        } else if (selectionModule === 'PAIR' && pairValue) {
          (0, _lodash.forEach)(pairValue, function (v, k) {
            if ((0, _lodash.isEmpty)(v)) {
              validResult = false;
            }
          });
        } else {
          validResult = false;
        }

        if (!validResult) errorMsg = t('validation.wholeDataInfo');
      } else {
        errorMsg = t('validation.wholeDataInfo');
      }
    }

    callback(errorMsg || '');
  };
  /* 每刻日期必填行校验 */


  var DateTimeInput = function DateTimeInput(rule, value, callback, source, options, field) {
    var _options$formFields2 = options.formFields,
        formFields = _options$formFields2 === void 0 ? {} : _options$formFields2;
    var fieldInfo = (0, _lodash.find)(formFields, {
      identifier: rule.fullField
    });
    var selectionModule = fieldInfo ? fieldInfo.property.selectionModule : 'SINGLE';
    var errorMsg;

    if (field.property.required) {
      if (value !== undefined && value !== null) {
        var singleValue = value.currentTime;
        var pairValue = value.timeRange;
        var validResult = true;

        if (selectionModule === 'SINGLE' && singleValue) {
          validResult = true;
        } else if (selectionModule === 'PAIR' && pairValue) {
          (0, _lodash.forEach)(pairValue, function (v, k) {
            if (v === undefined || v === null) {
              validResult = false;
            }
          });
        } else {
          validResult = false;
        }

        if (!validResult) errorMsg = t('validation.wholeDataInfo');
      } else {
        errorMsg = t('validation.wholeDataInfo');
      }
    }

    callback(errorMsg);
  };
  /* 每刻发票必填行校验 */


  var InvoiceInput = function InvoiceInput(rule, value, callback, source, options) {
    var _options$formFields3 = options.formFields,
        formFields = _options$formFields3 === void 0 ? {} : _options$formFields3;
    var fieldInfo = (0, _lodash.find)(formFields, {
      identifier: rule.fullField
    });
    var required = fieldInfo && fieldInfo.property.required;
    var errors = [];

    if (value !== undefined && value !== null) {
      var validResult = true;

      var _list = (0, _lodash.filter)(value.list || [], {
        identityFlag: true
      });

      if ((0, _lodash.isEmpty)(_list) && value.invoiceStatus !== 1 && required) {
        validResult = false;
      } else if (value.invoiceStatus === 1 && !value.invoiceExpectSubmitTime) {
        validResult = false;
      }

      if (!validResult) errors.push(t('validation.required'));
    } else if (required) {
      errors.push(t('validation.required'));
    }

    callback(errors);
  };
  /* 收款账户校验 */


  var AccountInput = function AccountInput(rule, value, callback, source, options) {
    var _options$formFields4 = options.formFields,
        formFields = _options$formFields4 === void 0 ? {} : _options$formFields4;
    var fieldInfo = (0, _lodash.find)(formFields, {
      identifier: rule.fullField
    });
    var required = fieldInfo && fieldInfo.property.required;
    var errors = [];

    if (value !== undefined && value !== null) {
      var validResult = true;

      if ((0, _lodash.isEmpty)(value.bankAcctName) && required) {
        validResult = false;
      }

      if (!validResult) errors.push(t('validation.required'), rule.fullField);
    } else if (required) {
      errors.push(t('validation.required'), rule.fullField);
    }

    callback(errors);
  };

  var AssociationInput = function AssociationInput(rule, value, callback, source, options) {
    var _options$formFields5 = options.formFields,
        formFields = _options$formFields5 === void 0 ? {} : _options$formFields5;
    var fieldInfo = (0, _lodash.find)(formFields, {
      identifier: rule.fullField
    });
    var required = fieldInfo && fieldInfo.property.required;
    var errors = [];

    if (value) {
      if (required && (0, _lodash.isEmpty)(value.value)) {
        errors.push(t('validation.required'), rule.fullField);
      }
    } else {
      if (required) errors.push(t('validation.required'), rule.fullField);
    }

    callback(errors);
  };

  var ApplicationDetailListInput = function ApplicationDetailListInput(rule, value, callback, source, options, field) {
    var required = field.property.required;

    if (!required) {
      return callback();
    }

    if (!value) {
      callback(t('validation.required')); // - requireItem
    } else if (Array.isArray(value.consumeDetails) && (0, _lodash.isEmpty)(value.consumeDetails)) {
      callback(t('validation.required'));
    } else if (value.applicationPattern === 'CONSUME_DETAIL' && !isApplDetailListValid(value.consumeDetails)) {
      callback(t('validation.required')); // - expenseTipWarn
    } else {
      callback();
    }
  };

  var AmountInput = function AmountInput(rule, value, callback, source, options, field) {
    var required = field.property.required;

    if (!required) {
      return callback();
    }

    if (!value) {
      callback(t('validation.required'));
    } else if ((0, _lodash.isObject)(value) && ((0, _lodash.isNaN)(value.amount) || (0, _lodash.isNull)(value.amount) || (0, _lodash.isUndefined)(value.amount))) {
      callback(t('validation.required'));
    } else {
      callback();
    }
  };

  var textValidator = function textValidator(rule, value, callback, source, options, field) {
    var _field$property = field.property,
        required = _field$property.required,
        maxLength = _field$property.maxLength;

    if (required && !(0, _lodash.trim)(value)) {
      callback(t('validation.mustInput'));
    } else if (value !== undefined && value !== null && "".concat(value).length > maxLength) {
      callback(t('validation.maxLength', {
        maxLength: maxLength
      }));
    } else {
      callback('');
    }
  };

  var RegionField = function RegionField(rule, value, callback, source, options, field) {
    var required = field.property.required;

    if (!required) {
      return callback();
    }

    if (!value) {
      callback(t('validation.mustInput'));
    } else if (Array.isArray(value) && (0, _lodash.isEmpty)(value)) {
      callback(t('validation.mustInput'));
    } else {
      callback();
    }
  };

  var FestivalRuleField = function FestivalRuleField(rule, value, callback, source, options, field) {
    var required = field.property.required;

    if (!required) {
      return callback();
    }

    if (!value) {
      callback(t('validation.mustInput'));
    } else if (Array.isArray(value) && (0, _lodash.isEmpty)(value)) {
      callback(t('validation.mustInput'));
    } else {
      callback();
    }
  }; // 校验


  var ExternalOptionInput = function ExternalOptionInput(rule, value, callback, source, options) {
    var field = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};
    //    { field: { property: { required } }, value, callback }) => {
    var required = field.property.required;

    if (value) {
      var _value = Array.isArray(value.value) ? value.value[0] : value.value;

      if (required && (0, _lodash.isEmpty)(_value) && !value.bizCode) {
        callback(t('validation.required'));
      } else {
        callback();
      }
    } else {
      if (required) callback(t('validation.required'));else callback();
    }
  };

  customRules = {
    DateRangeInput: pairRequire,
    StayTimeInput: pairRequire,
    CityPairInput: pairRequire,
    CityInput: CityInput,
    DateTimeInput: DateTimeInput,
    InvoiceInput: InvoiceInput,
    AccountInput: AccountInput,
    AssociationInput: AssociationInput,
    ApplicationDetailListInput: ApplicationDetailListInput,
    AmountInput: AmountInput,
    CollectionAmountInput: AmountInput,
    SingleTextInput: textValidator,
    MultiTextInput: textValidator,
    RegionField: RegionField,
    FestivalRuleField: FestivalRuleField,
    ExternalOptionInput: ExternalOptionInput
  };
}

function isApplDetailListValid() {
  var list = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var bool = true;

  if (list.length === 0) {
    bool = false;
  }

  var _iterator = _createForOfIteratorHelper(list),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var t = _step.value;

      if (!t.expenseTypeCode || !t.amount) {
        bool = false;
        break;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return bool;
}

function fieldValidator(rule, value, callback, source, options, field) {
  try {
    var _options$fieldInstanc = options.fieldInstances,
        fieldInstances = _options$fieldInstanc === void 0 ? {} : _options$fieldInstanc;
    var componentInstance;

    if (fieldInstances[rule.field]) {
      componentInstance = fieldInstances[rule.field].componentInstance || {};
      componentInstance = componentInstance.wrappedInstance ? componentInstance.wrappedInstance : componentInstance;
    }

    if (componentInstance && componentInstance.fieldValidation) {
      componentInstance.fieldValidation(rule, value, callback, source, options);
    } else if (field.fieldValidation) {
      field.fieldValidation(rule, value, callback, source, options);
    } else if (customRules[field.type]) {
      customRules[field.type](rule, value, callback, source, options, field);
    } else {
      callback();
    }
  } catch (e) {
    console.error(e);
    throw e;
  }
}

var BladeValidator = function BladeValidator() {
  var _this = this;

  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  (0, _classCallCheck2.default)(this, BladeValidator);

  this.addRule = function (name, rule) {
    if (name && rule && !(0, _lodash.isEmpty)(rule)) {
      if (_this.descriptors[name]) {
        _this.descriptors[name].push(rule);
      } else {
        _this.descriptors[name] = [rule];
      }
    }
  };

  this.validate = function () {
    var source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var callback = arguments.length > 2 ? arguments[2] : undefined;
    if ((0, _lodash.isEmpty)(source)) return;
    var theDescriptors = {};
    Object.keys(source).forEach(function (key) {
      if (_this.descriptors[key]) theDescriptors[key] = _this.descriptors[key];
    });

    if (!(0, _lodash.isEmpty)(theDescriptors)) {
      var validator = new _asyncValidator.default(theDescriptors);
      validator.messages(_this.validateMessages);
      validator.validate(source, options, callback);
    }
  };

  var _props$descriptors = props.descriptors,
      descriptors = _props$descriptors === void 0 ? {} : _props$descriptors,
      _props$messages = props.messages,
      messages = _props$messages === void 0 ? {} : _props$messages;
  this.descriptors = descriptors;
  this.validateMessages = messages;
};
/* 生成validator */


function generateValidator(formFields) {
  var validateMessages = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  if ((0, _lodash.isEmpty)(customRules)) buildCustomRules();
  var descriptor = {};

  if (!(0, _lodash.isEmpty)(formFields)) {
    (0, _lodash.forEach)(formFields, function (field, index) {
      if (field.type === 'SplitSpace') return;
      var rule = [];
      (0, _lodash.each)(field.property, function (value, key) {
        var mapKey = ruleMap[key];

        if (mapKey && !(['SingleTextInput', 'MultiTextInput', 'InvoiceInput', 'InvoiceTable', 'AttachInput'].includes(field.type) && mapKey === 'max')) {
          rule.push((0, _defineProperty2.default)({}, "".concat(mapKey), value));
        }
      });
      rule.push({
        validator: function validator(rule, value, callback, source, options) {
          return fieldValidator(rule, value, callback, source, options, field);
        }
      });

      if (!(0, _lodash.isEmpty)(rule)) {
        descriptor[field.identifier] = rule;
      }
    });
    return new BladeValidator({
      descriptors: descriptor,
      messages: _objectSpread(_objectSpread({}, defaultMessage), validateMessages)
    });
  }
}

var _default = generateValidator;
exports.default = _default;