"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _ConditionPaser = _interopRequireDefault(require("../ConditionPaser"));

var _lodash = _interopRequireDefault(require("lodash"));

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2019-09-20 14:38:23
 * @LastEditors: RongWei
 * @LastEditTime: 2020-08-31 14:39:05
 */
var fieldProperty = ['isFieldHide', 'required', 'isFieldReadOnly'];

var DynamicFormCtrl = /*#__PURE__*/function () {
  function DynamicFormCtrl(_ref) {
    var _this = this;

    var updateFormFields = _ref.updateFormFields,
        fetchUserUserGroup = _ref.fetchUserUserGroup;
    (0, _classCallCheck2.default)(this, DynamicFormCtrl);

    this.init = function (formFields) {
      /*  _.forEach(formFields, (field) => {
           if (!_.isEmpty(field.conditions)) {
               field.property.default = {};
               fieldProperty.forEach((p) => {
                   field.property.default[p] = field.property[p];
               });
           }
       }); */
      _lodash.default.forEach(formFields, function (field) {
        if (!_lodash.default.isEmpty(field.conditions)) {
          _this.hasCondition = true;
          field.property.default = {};
          fieldProperty.forEach(function (p) {
            var baseFieldPerms = field.baseFieldPerms && field.baseFieldPerms[0] || {};
            field.property.default[p] = baseFieldPerms[p];
          });
        }
      });

      return formFields;
    };

    this.updateFormFields = updateFormFields;
    this.fetchUserUserGroup = fetchUserUserGroup;
    this.hasCondition = false;
  }
  /**
   * 1.将有条件的字段的(isFieldHide, required, isFieldReadOnly)在property里面缓存一份，作为默认值
   * 2.将所有条件都执行一遍
   */
  // NOTE 初始化formFields就可以判断表单是否包含条件


  (0, _createClass2.default)(DynamicFormCtrl, [{
    key: "setProperty",
    value: function setProperty(condFieldPerm, targetField) {
      if (condFieldPerm.edit === 'Y') {
        targetField.property['isFieldReadOnly'] = false;
      } else if (condFieldPerm.edit === 'N') {
        targetField.property['isFieldReadOnly'] = true;
      }

      if (condFieldPerm.required === 'Y') {
        targetField.property['required'] = true;
      } else if (condFieldPerm.required === 'N') {
        targetField.property['required'] = false;
      }

      if (condFieldPerm.display === 'Y') {
        targetField.property['isFieldHide'] = false;
      } else if (condFieldPerm.display === 'N') {
        targetField.property['isFieldHide'] = true;
      }
    }
  }, {
    key: "updateFieldProperty",
    value: function updateFieldProperty(formFields, field, result) {
      var targetField = _lodash.default.find(formFields, {
        code: field.code
      }); //property中的default为空说明没有做init，直接返回


      if (_lodash.default.isEmpty(targetField.property.default)) {
        //如果formfield没有default属性 说明没有执行init 这里再做一次init

        /*
            出现这种情况一般是因为页面重新init了 但是因为formchef里面没有重新调用init
        */
        this.init(formFields);
      }

      if (result) {
        var condFieldPerm = targetField.condFieldPerm || {};
        /* fieldProperty.forEach((p) => {
            targetField.property[p] = targetField.property.synthetic[p];
        }); */

        this.setProperty(condFieldPerm, targetField);
      } else {
        targetField.property.default = targetField.property.default ? targetField.property.default : {};
        fieldProperty.forEach(function (p) {
          targetField.property[p] = targetField.property.default[p];
        });
      }

      targetField.lastResult = result;
    }
  }, {
    key: "getConditionResult",
    value: function getConditionResult(field, formData) {
      var _this2 = this;

      return new Promise(function (resolve) {
        var p = new _ConditionPaser.default(field.conditions, formData, {
          fetchUserUserGroup: _this2.fetchUserUserGroup
        }).getResult();
        p.then(function (_ref2) {
          var conditionResult = _ref2.conditionResult;
          resolve(conditionResult);
        });
      });
    }
    /**
     * 检查更改的字段是否包含条件
     */

  }, {
    key: "checkFieldCondition",
    value: function checkFieldCondition(options) {
      var _this3 = this;

      var formFields = options.formFields,
          formData = options.formData,
          changedFields = options.changedFields,
          updateFinishCallback = options.updateFinishCallback; //const _formFields = _.cloneDeep(formFields);

      var _formFields = formFields;
      var isUpdate = false;
      var promiseList = [];

      _lodash.default.forEach(changedFields, function (val, identifier) {
        _lodash.default.forEach(_formFields, function (field, index) {
          if (field.conditions) {
            var condition = _lodash.default.find(_lodash.default.flatten(field.conditions), {
              identifier: identifier
            }); //有条件依赖这个更改的identifier,则重新执行条件组


            if (!_lodash.default.isEmpty(condition)) {
              var p = _this3.getConditionResult(field, formData);

              promiseList.push(p);
              p.then(function (conditionResult) {
                if (conditionResult !== field.lastResult) {
                  isUpdate = true;

                  _this3.updateFieldProperty(_formFields, field, conditionResult);
                }
              });
            }
          }
        });
      });

      if (promiseList.length > 0) {
        Promise.all(promiseList).then(function () {
          if (isUpdate) {
            _this3.updateFormFields && _this3.updateFormFields(_formFields, updateFinishCallback);
          }
        });
      }
    }
    /**
     * 表单中字段值改变回调
     */

  }, {
    key: "onFieldChange",
    value: function onFieldChange(options) {
      this.checkFieldCondition(options);
    }
    /* 优化 onFieldChange*/

  }, {
    key: "onNewFieldChange",
    value: function onNewFieldChange(options) {
      var _this4 = this;

      var formFields = options.formFields,
          formData = options.formData,
          changedFields = options.changedFields,
          updateFinishCallback = options.updateFinishCallback;
      var isUpdate = false;
      var promiseList = [];
      var effectFields = [];
      var thisSetProperty = this.setProperty;

      _lodash.default.forEach(changedFields, function (val, identifier) {
        _lodash.default.forEach(formFields, function (field, index) {
          if (field.conditions) {
            var condition = _lodash.default.find(_lodash.default.flatten(field.conditions), {
              identifier: identifier
            }); //有条件依赖这个更改的identifier,则重新执行条件组


            if (!_lodash.default.isEmpty(condition)) {
              var p = _this4.getConditionResult(field, formData);

              promiseList.push(p);
              p.then(function (conditionResult) {
                if (conditionResult !== field.lastResult) {
                  isUpdate = true;

                  var targetField = _updateFieldProperty(formFields, field, conditionResult);

                  if (targetField) _updateEffectFields(effectFields, targetField);
                }
              });
            }
          }
        });
      });

      return Promise.all(promiseList).then(function () {
        if (isUpdate) {
          //this.updateFormFields && this.updateFormFields(effectFields, updateFinishCallback);
          return {
            code: 'SHOULD_CHANGE',
            formFields: effectFields
          };
        } else {
          return {
            code: 'NOT_CHANGE'
          };
        }
      });

      function _updateFieldProperty(fields, field, result) {
        var targetField = _lodash.default.cloneDeep(_lodash.default.find(fields, {
          code: field.code
        })); //property中的default为空说明没有做init，直接返回


        if (_lodash.default.isEmpty(targetField.property.default)) {
          return;
        }

        if (result) {
          var condFieldPerm = targetField.condFieldPerm || {};
          thisSetProperty(condFieldPerm, targetField);
        } else {
          targetField.property.default = targetField.property.default ? targetField.property.default : {};
          fieldProperty.forEach(function (p) {
            targetField.property[p] = targetField.property.default[p];
          });
        }

        targetField.lastResult = result;
        return targetField;
      }

      function _updateEffectFields(fields, field) {
        var findIndex = _lodash.default.findIndex(fields, {
          identifier: field.identifier
        });

        if (findIndex === -1) {
          fields.push(field);
        } else {
          fields[findIndex] = field;
        }
      }
    }
  }]);
  return DynamicFormCtrl;
}();

var _default = DynamicFormCtrl;
exports.default = _default;