"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slimLodash = _interopRequireDefault(require("../utils/slimLodash"));

/**
 * 用于生成共享字段的规则的信息
 */

/* 共享字段映射 */
function genShareFieldFormula(field, shareFields) {
  var result = [];

  if (field && shareFields) {
    _slimLodash.default.forEach(shareFields, function (item) {
      result.push({
        targetField: item.identifier,
        referField: field.identifier,
        formula: item.identifier,
        privateParser: true,
        registerVariables: [item.identifier],
        updatePool: function updatePool(fieldValue, formData) {
          var result = {};
          var customObj = {};
          /* 当前共享字段都是custom级别的字段 */

          if (fieldValue && _slimLodash.default.isArray(fieldValue) && fieldValue.length > 0) {
            var last = fieldValue[fieldValue.length - 1]; // 过滤掉禁止映射的数据

            if (last.forbiddenMap) {
              customObj = {};
            } else {
              customObj = last.customObject;
            }
          } else if (fieldValue && _slimLodash.default.isObject(fieldValue)) {
            if (fieldValue.forbiddenMap) {
              customObj = {};
            } else {
              customObj = fieldValue.customObject;
            }
          }

          if (!fieldValue || fieldValue && _slimLodash.default.isEmpty(fieldValue)) {
            customObj = (0, _defineProperty2.default)({}, item.identifier, undefined);
          }

          if (_slimLodash.default.has(customObj, item.identifier)) {
            result[item.identifier] = customObj[item.identifier];
          }

          return result;
        }
      });
    });
  }

  return result;
}

var _default = genShareFieldFormula;
exports.default = _default;