"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

require("maycur-antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("maycur-antd/lib/radio"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _classnames = _interopRequireDefault(require("classnames"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _PureJs = _interopRequireDefault(require("../../PureJs"));

var _cache = _interopRequireDefault(require("../../utils/cache"));

var _reactI18next = require("react-i18next");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var locationConvertor = _PureJs.default.locationConvertor;
var Group = _radio.default.Group,
    RadioButton = _radio.default.Button;
var Search = _input.default.Search;
var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-city-field-list");
var localstoarge = _cache.default.localStore;
/* 获取每刻城市信息 by code */

function getPlaceDataByCodes(codes) {
  var placesHashMap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var places = [];

  if (_lodash.default.isArray(codes)) {
    _lodash.default.each(codes, function (code) {
      if (code && placesHashMap[code]) {
        places.push(placesHashMap[code]);
      }
    });
  } else if (codes && placesHashMap[codes]) {
    places.push(placesHashMap[codes]);
  }

  return places;
}

var CityList = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var hideFrequent = props.hideFrequent,
      type = props.type,
      showDropDown = props.showDropDown,
      value = props.value,
      readOnly = props.readOnly,
      fieldProperties = props.fieldProperties,
      _props$extraProps = props.extraProps,
      origin = _props$extraProps.origin,
      travelTrip = _props$extraProps.travelTrip,
      placesHashMap = props.placesHashMap,
      popType = props.popType,
      getCityNames = props.getCityNames;
  var placeholder = fieldProperties.placeholder,
      mode = fieldProperties.mode;

  var _useState = (0, _react.useState)([]),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      places = _useState2[0],
      setPlaces = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      cityData = _useState4[0],
      setCityData = _useState4[1];

  var _useState5 = (0, _react.useState)(['domestic']),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      selectedCity = _useState6[0],
      setSelectedCity = _useState6[1];

  var _useState7 = (0, _react.useState)([]),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      latestUseCity = _useState8[0],
      setLatestUseCity = _useState8[1];

  var _useState9 = (0, _react.useState)(''),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      searchValue = _useState10[0],
      setSearchValue = _useState10[1];

  var _useState11 = (0, _react.useState)([]),
      _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
      searchList = _useState12[0],
      setSearchList = _useState12[1];

  var _useState13 = (0, _react.useState)('domestic'),
      _useState14 = (0, _slicedToArray2.default)(_useState13, 2),
      cityTab = _useState14[0],
      setCityTab = _useState14[1];

  var _useState15 = (0, _react.useState)(origin === 'to' && !_lodash.default.isEmpty(value) ? value : []),
      _useState16 = (0, _slicedToArray2.default)(_useState15, 2),
      destinationList = _useState16[0],
      setDestinationList = _useState16[1];

  var _useTranslation = (0, _reactI18next.useTranslation)('MK_FormFields'),
      t = _useTranslation.t;

  var offsetTop = {};
  var scroll = '';
  var nav = {};
  var picker = {};
  var dropdownRef = (0, _react.useRef)();

  var formatPlaces = function formatPlaces(props) {
    var places = [];
    var type = props.type,
        placesHashMap = props.placesHashMap;

    if (type === 'bank') {
      var bankPlaces = props.bankPlaces;
      places = bankPlaces;
    } else {
      var expensePlaces = props.expensePlaces;
      places = expensePlaces;
    }

    if (places && places.length) {
      setPlaces(places);
      setCityData(places[0].children);
      setLatestUseCity(getPlaceDataByCodes(localstoarge.getItem('latestUseCityCodes'), placesHashMap) || []);
    }
  };

  (0, _react.useImperativeHandle)(ref, function () {
    return {
      onDelete: function onDelete(fullCode) {
        setDestinationList(_lodash.default.filter(destinationList, function (vm) {
          return vm !== fullCode;
        }));
      },
      updateValue: function updateValue(value) {
        var origin = props.extraProps.origin;
        setDestinationList(origin === 'to' && !_lodash.default.isEmpty(value) ? value : []);
      }
    };
  });

  var hideDropDown = function hideDropDown() {
    var hideDropDown = props.hideDropDown;
    setSearchValue('');

    if (typeof hideDropDown === 'function') {
      hideDropDown();
    }
  };

  var onChange = function onChange(value, data) {
    var onChange = props.onChange;

    if (_lodash.default.isFunction(onChange)) {
      onChange(value);
    }

    data && setCityToLatestUse(data.code);
  };

  var destinationChange = function destinationChange(data) {
    var mode = props.fieldProperties.mode;
    var destinationLists = destinationList;
    var location = data.fullCode || selectedCity.join('-');
    if (!location) return;

    if (mode === 'MULTI') {
      var index = _lodash.default.findIndex(destinationLists, function (vm) {
        return vm === location;
      });

      if (index >= 0) {
        destinationLists.splice(index, 1);
      } else if (destinationLists && destinationLists.length < 5) {
        destinationLists.push(location);
        setCityToLatestUse(data.code);
      }
    } else {
      destinationLists = [location];
    }

    setDestinationList(destinationLists);
  };

  var expandNextLevelLocation = function expandNextLevelLocation(data, index) {
    var origin = props.extraProps.origin,
        _props$fieldPropertie = props.fieldProperties,
        mode = _props$fieldPropertie.mode,
        selectionModule = _props$fieldPropertie.selectionModule;

    if (index) {
      selectedCity.length = index - 1;
    }

    selectedCity.push(data.code);

    if (!data.children) {
      var _value = data.fullCode || selectedCity.join('-'); //行程结束城市支持多选


      if (mode === 'MULTI' && origin === 'to') {
        destinationChange(data); //单个城市需要location
      } else if (selectionModule === 'SINGLE') {
        onChange({
          location: _value
        }, data);
      } else {
        onChange(_value, data);
      }

      setSelectedCity(['domestic']);
      setCityData(places[0].children);
      setCityTab('domestic');

      if (!(mode === 'MULTI' && origin === 'to')) {
        hideDropDown();
      }
    } else {
      setSelectedCity(selectedCity);
      setCityData(data.children);
    }
  }; // 设置最近使用城市，最多8个


  var setCityToLatestUse = function setCityToLatestUse(code) {
    var hideFrequent = props.hideFrequent,
        placesHashMap = props.placesHashMap;
    if (hideFrequent) return;
    var selectedIndex,
        latestUseCityCodes = localstoarge.getItem('latestUseCityCodes') || [];
    selectedIndex = _lodash.default.indexOf(latestUseCityCodes, code);

    if (selectedIndex !== -1) {
      latestUseCityCodes.splice(selectedIndex, 1);
    }

    latestUseCityCodes.unshift(code); // 最多保存8个最近使用的城市

    if (latestUseCityCodes.length > 8) {
      latestUseCityCodes.length = 8;
    }

    localstoarge.setItem('latestUseCityCodes', latestUseCityCodes);
    setLatestUseCity(getPlaceDataByCodes(latestUseCityCodes, placesHashMap));
  }; // 切换国内、国际城市


  var handleCategoryChange = function handleCategoryChange(e) {
    var value = e.target.value;
    var cityDatas = places[0].children,
        selectedCity = ['domestic'];

    if (value === 'abroad') {
      cityDatas = places[1].children;
      selectedCity = ['abroad'];
    }

    if (scroll.scrollTop > nav.offsetTop) {
      scroll.scrollTop = offsetTop.list + 110;
    }

    setCityData(cityDatas);
    setSelectedCity(selectedCity);
    setCityTab(value);
  }; //行程限制城市


  var tripSearchCityS = (0, _react.useCallback)(function (travelTrip) {
    var type = props.type;
    var cityPair = travelTrip.travelCity.cityPair;
    var departure = cityPair.departure,
        destination = cityPair.destination;
    setSearchValue(cityPair);
    var placesHashMap = type === 'bank' ? locationConvertor.getBankPlacesHashMap() : locationConvertor.getPlacesHashMap();

    var leafNodes = _lodash.default.filter(placesHashMap, {
      isLeaf: true
    });

    var searchList = destination;

    if (!searchList.includes(departure)) {
      searchList.push(departure);
    }

    searchList = _lodash.default.filter(leafNodes, function (leaf) {
      return searchList.includes(leaf.fullCode);
    });
    setSearchList(searchList);
  }, [props]); // 城市搜索

  var searchCity = function searchCity(searchValue) {
    setSearchValue(searchValue);
    var type = props.type;
    var placesHashMap = type === 'bank' ? locationConvertor.getBankPlacesHashMap() : locationConvertor.getPlacesHashMap();

    var leafNodes = _lodash.default.filter(placesHashMap, {
      isLeaf: true
    });

    if (searchValue) {
      var _searchList = [];

      _lodash.default.each(leafNodes, function (area) {
        if (area.fuzzy.toLowerCase().indexOf(searchValue) !== -1) {
          _searchList.push(area);
        }
      });

      setSearchList(_searchList);
    }
  };

  var setScroll = function setScroll(dom) {
    if (dom) {
      scroll = dom;

      dom.onscroll = function (evt) {
        if (!nav) return;

        if (evt.currentTarget.scrollTop >= offsetTop.nav + 100) {
          nav.style.position = 'absolute';
          nav.style.top = picker.clientHeight + 6 + 'px';
        } else {
          nav.style.position = 'relative';
          nav.style.top = 0;
        }
      };
    }
  };

  var setPicker = function setPicker(pickers) {
    if (pickers) {
      picker = pickers;
    }
  };

  var setNav = function setNav(navs) {
    if (navs) {
      nav = _reactDom.default.findDOMNode(navs);
      offsetTop.nav = navs.offsetTop;
    }
  };

  var setList = function setList(lists) {
    if (lists) {
      offsetTop.list = lists.offsetTop;
    }
  };

  var onOk = function onOk() {
    onChange(destinationList);
    hideDropDown();
  };

  useOnClickOutside(dropdownRef, function () {
    return hideDropDown();
  });

  function useOnClickOutside(dropdownRef, handler) {
    (0, _react.useEffect)(function () {
      var listener = function listener(event) {
        if (!dropdownRef.current || dropdownRef.current.contains(event.target)) {
          return;
        }

        handler(event);
      };

      document.addEventListener("mousedown", listener);
      document.addEventListener("touchstart", listener);
      return function () {
        document.removeEventListener("mousedown", listener);
        document.removeEventListener("touchstart", listener);
      };
    }, [dropdownRef, handler]);
  }

  (0, _react.useEffect)(function () {
    var travelTrip = props.extraProps.travelTrip,
        showDropDown = props.showDropDown,
        isPair = props.isPair;
    formatPlaces(props);

    if (travelTrip) {
      tripSearchCityS(travelTrip);
    } // NOTE 城市区间，需要实时同步两个城市面板之间的最近使用城市


    if (isPair && showDropDown && !props.showDropDown) {
      var latestUseCityCodes = localstoarge.getItem('latestUseCityCodes') || [];
      setLatestUseCity(getPlaceDataByCodes(latestUseCityCodes, props.placesHashMap));
    }
  }, [props, tripSearchCityS]);
  var cityNames = getCityNames(origin === 'from' ? value : destinationList, origin === 'to');
  var showDropDownClass = (0, _classnames.default)('dropdown', {
    'in': showDropDown,
    'up': popType === 'up'
  });
  return /*#__PURE__*/_react.default.createElement("div", {
    className: showDropDownClass,
    ref: dropdownRef,
    style: {
      position: 'relative'
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(cmName, "-display-value-clone"),
    ref: setPicker
  }, cityNames ? /*#__PURE__*/_react.default.createElement("div", {
    className: "city-names"
  }, cityNames) : /*#__PURE__*/_react.default.createElement("div", {
    className: "placeholder"
  }, readOnly ? t('empty') : placeholder)), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(cmName, "-wrap"),
    ref: setScroll
  }, !travelTrip && /*#__PURE__*/_react.default.createElement("div", {
    className: "search"
  }, /*#__PURE__*/_react.default.createElement(Search, {
    placeholder: t('searchKeywords'),
    onSearch: searchCity
  })), searchValue ? /*#__PURE__*/_react.default.createElement("div", {
    className: "search-pane"
  }, /*#__PURE__*/_react.default.createElement("ul", {
    className: cmName
  }, searchList && searchList.length > 0 ? searchList.map(function (city, index) {
    return /*#__PURE__*/_react.default.createElement("li", {
      key: index,
      className: "".concat(cmName, "-item"),
      onClick: function onClick() {
        expandNextLevelLocation(city);
      }
    }, city && /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("h4", {
      className: "".concat(cmName, "-item_name")
    }, city.name), /*#__PURE__*/_react.default.createElement("p", {
      className: "".concat(cmName, "-item_desc")
    }, city.fullName)), /*#__PURE__*/_react.default.createElement("div", {
      className: "flex-1"
    }), city.children && /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-angle-right"
    }));
  }) : /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(cmName, "-empty-text")
  }, /*#__PURE__*/_react.default.createElement("span", null, t('noData'))))) : /*#__PURE__*/_react.default.createElement("div", {
    className: "city-pane"
  }, hideFrequent ? null : /*#__PURE__*/_react.default.createElement("div", {
    className: "hot-city-pane"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "sub-title"
  }, t('cityField.recentlyUsed')), /*#__PURE__*/_react.default.createElement("div", {
    className: "hot-city-list"
  }, latestUseCity && latestUseCity.map(function (city, index) {
    return /*#__PURE__*/_react.default.createElement(_button.default, {
      key: index,
      onClick: function onClick(e) {
        e.stopPropagation();
        expandNextLevelLocation(city);
      }
    }, city === null || city === void 0 ? void 0 : city.name);
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: "nav",
    ref: setNav
  }, type === 'bank' ? null : /*#__PURE__*/_react.default.createElement(Group, {
    onChange: handleCategoryChange,
    defaultValue: "domestic",
    value: cityTab,
    buttonStyle: "solid"
  }, /*#__PURE__*/_react.default.createElement(RadioButton, {
    value: "domestic"
  }, t('cityField.china')), /*#__PURE__*/_react.default.createElement(RadioButton, {
    value: "abroad"
  }, t('cityField.international'))), /*#__PURE__*/_react.default.createElement("div", {
    className: "crumb"
  }, selectedCity.map(function (cityCode, index) {
    var city = getPlaceDataByCodes(cityCode, placesHashMap);

    if (city && city.length === 1) {
      return /*#__PURE__*/_react.default.createElement("span", {
        className: "crumb-item",
        key: cityCode,
        onClick: function onClick() {
          expandNextLevelLocation(city[0], index + 1);
        }
      }, city[0].name);
    } else {
      return null;
    }
  }))), /*#__PURE__*/_react.default.createElement("ul", {
    className: cmName,
    ref: setList
  }, cityData && cityData.map(function (city, index) {
    return /*#__PURE__*/_react.default.createElement("li", {
      key: index,
      className: "".concat(cmName, "-item"),
      onClick: function onClick() {
        expandNextLevelLocation(city);
      }
    }, (value === city.fullCode || destinationList.includes(city.fullCode)) && !city.children && /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-checking"
    }), /*#__PURE__*/_react.default.createElement("span", null, city && city.name), /*#__PURE__*/_react.default.createElement("div", {
      className: "flex-1"
    }), city.children && /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-angle-right"
    }));
  })))), mode === 'MULTI' && origin === 'to' && /*#__PURE__*/_react.default.createElement("div", {
    className: "action-bar"
  }, /*#__PURE__*/_react.default.createElement(_button.default, {
    onClick: hideDropDown
  }, t('cancel')), /*#__PURE__*/_react.default.createElement(_button.default, {
    type: "primary",
    onClick: onOk
  }, t('ok'))));
});
var _default = CityList;
exports.default = _default;