"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _OptionFieldList = _interopRequireDefault(require("./OptionFieldList"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _FullPathPopover = _interopRequireDefault(require("../../FullPathPopover"));

var _reactI18next = require("react-i18next");

var _WrapperTrigger = _interopRequireDefault(require("../../WrapperTrigger"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * @Author: yuxuan 
 * @Date: 2020-03-06 19:31:22 
 * @Last Modified by: HeyanLiu
 * @Last Modified time: 2021-03-11 11:45:48
 */
var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-option-field");

function OptionFieldPicker(props) {
  var _value$fullNames;

  var value = props.value,
      _props$extraProps = props.extraProps,
      fieldStyleCategory = _props$extraProps.fieldStyleCategory,
      showBizCode = _props$extraProps.showBizCode,
      showStandingBook = _props$extraProps.showStandingBook,
      isInTable = _props$extraProps.isInTable,
      tableRef = _props$extraProps.tableRef,
      registerEvent = _props$extraProps.registerEvent,
      readOnly = props.readOnly,
      fieldProperties = props.fieldProperties,
      onChange = props.onChange,
      openStandingModal = props.openStandingModal,
      onPopoverShow = props.onPopoverShow,
      fetchFullPath = props.fetchFullPath,
      isShowFullPath = props.isShowFullPath;
  var placeholder = fieldProperties.placeholder;

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      isDropDown = _useState2[0],
      setIsDropDown = _useState2[1];

  var _useTranslation = (0, _reactI18next.useTranslation)('MK_OptionField'),
      t = _useTranslation.t;

  var hideDropDown = (0, _react.useCallback)(function () {
    if (readOnly) {
      return;
    }

    ;
    setIsDropDown(false);
  }, [readOnly]);
  var showDropDown = (0, _react.useCallback)(function () {
    if (readOnly) {
      return;
    }

    setIsDropDown(true);
  }, [readOnly]);
  var arrowClass = (0, _react.useMemo)(function () {
    return showDropDown ? 'up' : '';
  }, [showDropDown]); // 清空所选项

  var clearValue = (0, _react.useCallback)(function (e) {
    e.preventDefault();
    e.stopPropagation();

    if (typeof onChange === 'function') {
      onChange(null);
    }
  }, [onChange]);
  var popup = (0, _react.useMemo)(function () {
    return /*#__PURE__*/_react.default.createElement(_OptionFieldList.default, (0, _extends2.default)({}, props, {
      showDropDown: isDropDown,
      hideDropDown: hideDropDown
    }));
  }, [props, isDropDown, hideDropDown]);
  /* const onVisibleChange = (visible) => {
      if(visible) {
          onPopoverShow && onPopoverShow();
      }
  } */

  return /*#__PURE__*/_react.default.createElement(_WrapperTrigger.default, {
    tableRef: tableRef,
    registerEvent: registerEvent,
    popup: popup,
    popupVisible: isDropDown,
    popupClassName: cmName,
    hideDropDown: hideDropDown,
    popupAlign: {
      points: ['tl', 'bl'],
      offset: [0, -60]
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-option-field_display-value ").concat(fieldStyleCategory, " ").concat(readOnly ? 'readOnly' : ''),
    onClick: showDropDown
  }, value && value.name ? /*#__PURE__*/_react.default.createElement("div", null, value.name, showBizCode && value.bizCode ? "(".concat(value.bizCode, ")") : '', isShowFullPath && (value === null || value === void 0 ? void 0 : (_value$fullNames = value.fullNames) === null || _value$fullNames === void 0 ? void 0 : _value$fullNames.length) > 1 && /*#__PURE__*/_react.default.createElement(_FullPathPopover.default, {
    fetchFullPath: fetchFullPath
  })) : /*#__PURE__*/_react.default.createElement("div", {
    className: "placeholder"
  }, placeholder), value && value.name && !readOnly && /*#__PURE__*/_react.default.createElement("span", {
    className: 'ant-select-clear',
    onClick: clearValue
  }, /*#__PURE__*/_react.default.createElement(_icon.default, {
    type: "close"
  })), value && showStandingBook ? /*#__PURE__*/_react.default.createElement("span", {
    onClick: function onClick(e) {
      return openStandingModal(e);
    },
    className: 'ant-select-showStandingBook'
  }, t('查看台账')) : null, /*#__PURE__*/_react.default.createElement("span", {
    className: "ant-select-arrow-font ".concat(arrowClass, " ").concat(value && value.name && 'ant-select-arrow-hide'),
    unselectable: "on"
  }, /*#__PURE__*/_react.default.createElement(_icon.default, {
    type: "down"
  }))));
}

var _default = OptionFieldPicker;
exports.default = _default;