"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableField = TableField;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _EditableTable = _interopRequireDefault(require("../../EditableTable"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _lodash = _interopRequireDefault(require("lodash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function EditableTableWrapper(WrappedComponent, params) {
  var FieldFood = params.FieldFood;
  var EditableTable = (0, _EditableTable.default)({
    FieldFood: FieldFood
  });

  var EditableTableWrapper = /*#__PURE__*/function (_PureComponent) {
    (0, _inherits2.default)(EditableTableWrapper, _PureComponent);

    var _super = _createSuper(EditableTableWrapper);

    function EditableTableWrapper(props) {
      var _this;

      (0, _classCallCheck2.default)(this, EditableTableWrapper);
      _this = _super.call(this, props);

      _this.addData = function () {
        var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var addToTop = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var _this$props = _this.props,
            _this$props$value = _this$props.value,
            value = _this$props$value === void 0 ? [] : _this$props$value,
            onChange = _this$props.onChange,
            _addData = _this$props.addData;

        if (_addData) {
          _addData(data, addToTop);
        } else {
          var newData;

          if (_lodash.default.isArray(data)) {
            newData = value.concat(data);
          } else {
            var item = _objectSpread((0, _defineProperty2.default)({}, "".concat(_this.rowKey), "MOCK_".concat(_utils.default.makeId())), data);

            newData = addToTop ? [_objectSpread({}, item)].concat((0, _toConsumableArray2.default)(value)) : [].concat((0, _toConsumableArray2.default)(value), [_objectSpread({}, item)]);
          }

          onChange && onChange(newData);
        }
      };

      _this.genRowsPrivateProps = function () {
        var _this$props2 = _this.props,
            value = _this$props2.value,
            receiptCurrency = _this$props2.extraProps.receiptCurrency,
            detailTableFields = _this$props2.fieldProps.detailTableFields;
        var rowsPrivateProps = [];

        _lodash.default.forEach(value, function (record, index) {
          var item = {
            rowKey: record["".concat(_this.rowKey)],
            privateProps: {}
          };

          _lodash.default.each(detailTableFields, function (field) {
            if (field.type === 'AmountInput') {
              item.privateProps[field.identifier] = {
                defaultCurrency: receiptCurrency
              };
            }
          });

          rowsPrivateProps.push(item);
        });

        return rowsPrivateProps;
      };

      _this.state = {
        value: props.value
      };
      _this.columns = [];
      _this.tableRef = /*#__PURE__*/(0, _react.createRef)();
      var _rowKey = props.extraProps.rowKey,
          rowKey = props.rowKey;
      _this.rowKey = rowKey || _rowKey || 'key';
      return _this;
    }

    (0, _createClass2.default)(EditableTableWrapper, [{
      key: "render",
      value: function render() {
        var _this$props3 = this.props,
            detailTableFields = _this$props3.fieldProps.detailTableFields,
            forwardedRef = _this$props3.forwardedRef;
        return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(WrappedComponent, (0, _extends2.default)({
          addData: this.addData
        }, this.props)), /*#__PURE__*/_react.default.createElement(EditableTable, (0, _extends2.default)({
          rowKey: this.rowKey,
          formFields: detailTableFields,
          ref: forwardedRef
        }, this.props, {
          rowsPrivateProps: this.genRowsPrivateProps()
        })));
      }
    }]);
    return EditableTableWrapper;
  }(_react.PureComponent);

  return /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(EditableTableWrapper, (0, _extends2.default)({}, props, {
      forwardedRef: ref
    }));
  });
}
/** 
 * @author  卫蓉
 */


function TableField() {
  //用于欺骗react-styleguidist无法识别HOC组件，不是真实组件
  return /*#__PURE__*/_react.default.createElement("div", null);
}

var _default = EditableTableWrapper;
exports.default = _default;