"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("maycur-antd/lib/list/style/css");

var _list = _interopRequireDefault(require("maycur-antd/lib/list"));

require("maycur-antd/lib/popconfirm/style/css");

var _popconfirm = _interopRequireDefault(require("maycur-antd/lib/popconfirm"));

require("maycur-antd/lib/tooltip/style/css");

var _tooltip = _interopRequireDefault(require("maycur-antd/lib/tooltip"));

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

require("maycur-antd/lib/tag/style/css");

var _tag = _interopRequireDefault(require("maycur-antd/lib/tag"));

var _react = _interopRequireDefault(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _excluded = ["title", "onSearch", "placeholder", "showSearch", "showHeader", "showAddBtn", "showImport", "showcopy", "copySubject", "listStyle", "itemIcon", "dataIndex", "current", "isEdit", "rowKey", "tipForAdd", "onClickItem", "deleteConfirmText", "addItem", "deleteItem", "dataSource", "renderItem", "renderItemOperator", "importListData"];

var UnSave = function UnSave() {
  return /*#__PURE__*/_react.default.createElement("span", {
    style: {
      color: '#FF8931',
      margin: '0 10px',
      flex: 'none'
    }
  }, "[\u672A\u4FDD\u5B58]");
};

var SharedData = function SharedData() {
  return /*#__PURE__*/_react.default.createElement("span", {
    style: {
      margin: '0 10px'
    }
  }, /*#__PURE__*/_react.default.createElement(_tag.default, {
    color: "blue",
    size: "small"
  }, "\u5171\u4EAB\u6570\u636E"));
};

var Search = _input.default.Search;
var prefix = _utils.default.prefixCls;

function EditableList(props) {
  var _this = this;

  var title = props.title,
      onSearch = props.onSearch,
      placeholder = props.placeholder,
      showSearch = props.showSearch,
      showHeader = props.showHeader,
      showAddBtn = props.showAddBtn,
      showImport = props.showImport,
      showcopy = props.showcopy,
      copySubject = props.copySubject,
      listStyle = props.listStyle,
      itemIcon = props.itemIcon,
      dataIndex = props.dataIndex,
      current = props.current,
      isEdit = props.isEdit,
      rowKey = props.rowKey,
      tipForAdd = props.tipForAdd,
      onClickItem = props.onClickItem,
      deleteConfirmText = props.deleteConfirmText,
      addItem = props.addItem,
      deleteItem = props.deleteItem,
      dataSource = props.dataSource,
      itemRender = props.renderItem,
      renderItemOperator = props.renderItemOperator,
      importListData = props.importListData,
      restProps = (0, _objectWithoutProperties2.default)(props, _excluded);

  var onClick = function onClick(item, index, e) {
    e.stopPropagation();

    if (typeof onClickItem === 'function') {
      onClickItem({
        item: item,
        index: index,
        dataSource: dataSource
      });
    }
  };

  var renderHeader = function renderHeader() {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "header"
    }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-ordered-list"
    }), /*#__PURE__*/_react.default.createElement("span", {
      className: "header-name"
    }, title)), /*#__PURE__*/_react.default.createElement("div", {
      className: "operators"
    }, showImport ? /*#__PURE__*/_react.default.createElement(_tooltip.default, {
      title: "\u6279\u91CF\u5BFC\u5165"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "item-operator"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "operator-btns",
      onClick: typeof importListData === 'function' ? importListData : null
    }, /*#__PURE__*/_react.default.createElement(_icon.default, {
      style: {
        color: '#3296FA'
      },
      type: "arrow-up"
    })))) : null, showcopy ? /*#__PURE__*/_react.default.createElement(_tooltip.default, {
      title: "\u590D\u5236\u79D1\u76EE\u8868"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "item-operator"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "operator-btns",
      onClick: typeof copySubject === 'function' ? copySubject : null
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-copy"
    })))) : null, showAddBtn ? /*#__PURE__*/_react.default.createElement(_tooltip.default, {
      title: "\u6DFB\u52A0".concat(title)
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "item-operator"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "operator-btns",
      onClick: addItem ? addItem : null
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-plus"
    })))) : null));
  };

  var renderDefaultOperator = function renderDefaultOperator(item, index) {
    return typeof deleteItem === 'function' ? /*#__PURE__*/_react.default.createElement(_popconfirm.default, {
      placement: "left",
      title: deleteConfirmText ? deleteConfirmText : '确定删除该会计科目吗？',
      onConfirm: deleteItem ? deleteItem.bind(_this, item, index) : null
    }, /*#__PURE__*/_react.default.createElement(_tooltip.default, {
      title: "\u5220\u9664".concat(title),
      onClick: function onClick(e) {
        return e.stopPropagation();
      }
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "item-operator"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "operator-btns"
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-trash"
    }))))) : null;
  };

  var renderItem = function renderItem(item, index) {
    return /*#__PURE__*/_react.default.createElement(_list.default.Item, {
      className: 'item ' + (current === index ? 'selected' : null),
      onClick: onClick.bind(_this, item, index),
      key: rowKey ? item[rowKey] : index
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "title-wrapper"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "text-wrapper"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "item-icon"
    }, itemIcon ? itemIcon : /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-paper"
    })), /*#__PURE__*/_react.default.createElement("div", {
      className: "item-name"
    }, dataIndex ? typeof dataIndex === 'string' ? item[dataIndex] : itemRender(item, index) : itemRender(item, index), item.iscache ? /*#__PURE__*/_react.default.createElement(UnSave, null) : null, isEdit && item.common ? /*#__PURE__*/_react.default.createElement(SharedData, null) : null)), /*#__PURE__*/_react.default.createElement("div", {
      className: "operator"
    }, renderItemOperator ? renderItemOperator(item, index, renderDefaultOperator(item, index)) : renderDefaultOperator(item, index))));
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-editable-list-container")
  }, showSearch ? /*#__PURE__*/_react.default.createElement("div", {
    className: "search-box"
  }, /*#__PURE__*/_react.default.createElement(Search, {
    onSearch: onSearch,
    placeholder: placeholder
  })) : null, /*#__PURE__*/_react.default.createElement("div", {
    className: "wrapper",
    style: listStyle
  }, /*#__PURE__*/_react.default.createElement(_list.default, (0, _extends2.default)({
    size: "small",
    dataSource: dataSource
  }, restProps, {
    className: "list",
    header: showHeader ? renderHeader() : null,
    renderItem: renderItem
  }))));
}

var _default = EditableList;
exports.default = _default;