"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/tree/style/css");

var _tree = _interopRequireDefault(require("maycur-antd/lib/tree"));

var _react = _interopRequireWildcard(require("react"));

var _i18next = _interopRequireDefault(require("i18next"));

var _Empty = _interopRequireDefault(require("../../../Empty"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * @Author: Jiangang LU
 * @Date: 2021-06-28 10:39:30
 * @LastEditors: Jiangang Lu
 * @LastEditTime: 2021-07-07 10:09:49
 * @Description: TreeSelect 树选择
 */
var TreeNode = _tree.default.TreeNode;
var prefixCls = _utils.default.prefixCls;

var TreeFilter = function TreeFilter(props) {
  var filtersSync = props.filtersSync,
      selectedKeys = props.selectedKeys,
      setSelectedKeys = props.setSelectedKeys,
      clearFilters = props.clearFilters,
      confirm = props.confirm;

  var _useState = (0, _react.useState)([]),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      checkedKeys = _useState2[0],
      setCheckedKeys = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      treeData = _useState4[0],
      setTreeData = _useState4[1];
  /**
   * @description: NOTE 获取筛选下拉框选项
   * @param {*} useCallback
   * @return {*}
   */


  var fetchFilters = (0, _react.useCallback)( /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
    var data;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            _context.next = 3;
            return filtersSync();

          case 3:
            data = _context.sent;
            setTreeData(data);
            _context.next = 10;
            break;

          case 7:
            _context.prev = 7;
            _context.t0 = _context["catch"](0);
            console.log(_context.t0);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[0, 7]]);
  })), [filtersSync]);
  var renderTreeNodes = (0, _react.useCallback)(function (data) {
    return data.map(function (item) {
      if (item.children) {
        return /*#__PURE__*/_react.default.createElement(TreeNode, {
          key: item.code,
          title: item.name,
          dataRef: item
        }, renderTreeNodes(item.children));
      }

      return /*#__PURE__*/_react.default.createElement(TreeNode, {
        key: item.code,
        title: item.name,
        dataRef: item
      });
    });
  }, []);
  /**
   * @description: NOTE 点击复选框和树节点触发
   * @param {Array} selectedKeys
   * @return {*}
   */

  var handleChecked = (0, _react.useCallback)(function (selectedKeys, e) {
    setCheckedKeys(selectedKeys);

    try {
      var result = e.checkedNodes.map(function (item) {
        var value = item.key,
            title = item.props.title;
        return {
          code: value,
          name: title
        };
      });
      setSelectedKeys(result);
    } catch (error) {
      console.log(error);
    }
  }, [setCheckedKeys, setSelectedKeys]);
  /**
   * @description: NOTE 重置
   */

  var reset = (0, _react.useCallback)(function () {
    setCheckedKeys([]);

    if (typeof clearFilters === 'function') {
      clearFilters();
    }
  }, [setCheckedKeys, clearFilters]);
  /**
   * @description: NOTE 确定
   */

  var onConfirm = (0, _react.useCallback)(function () {
    if (typeof confirm === 'function') {
      confirm();
    }
  }, [confirm]);
  (0, _react.useEffect)(function () {
    fetchFilters(); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  (0, _react.useEffect)(function () {
    if (Array.isArray(selectedKeys)) {
      var result = selectedKeys.map(function (item) {
        return item.code;
      });
      setCheckedKeys(result);
    } else {
      setCheckedKeys([]);
    }
  }, [selectedKeys]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefixCls, "-tree-filter")
  }, treeData && treeData.length ? /*#__PURE__*/_react.default.createElement(_tree.default, {
    checkable: true,
    checkedKeys: checkedKeys,
    onCheck: handleChecked
  }, renderTreeNodes(treeData)) : /*#__PURE__*/_react.default.createElement(_Empty.default, null), /*#__PURE__*/_react.default.createElement("div", {
    className: 'pin-footer'
  }, /*#__PURE__*/_react.default.createElement("div", {
    onClick: reset,
    className: 'footer-item weaker-item'
  }, _i18next.default.t('MK_Global:reset')), /*#__PURE__*/_react.default.createElement("div", {
    onClick: onConfirm,
    className: 'footer-item'
  }, _i18next.default.t('MK_Global:ok'))));
};

var _default = /*#__PURE__*/(0, _react.memo)(TreeFilter);

exports.default = _default;