"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _RangeCalendar = _interopRequireDefault(require("./RangeCalendar"));

var _SelectComp = _interopRequireDefault(require("./SelectComp"));

var _AmountRange = _interopRequireDefault(require("./AmountRange"));

var _DepartmentPicker = _interopRequireDefault(require("./DepartmentPicker"));

var _CustomTagSelectComp = _interopRequireDefault(require("./CustomTagSelectComp"));

var _BudgetmentPicker = _interopRequireDefault(require("./BudgetmentPicker"));

var _BudgetSubjectPicker = _interopRequireDefault(require("./BudgetSubjectPicker"));

var _OptionInputPicker = _interopRequireDefault(require("./OptionInputPicker"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

// import utils from '../../../utils/utils';
// const { prefixCls: prefix } = utils;
var typeComponentMap = {
  'dateRange': _RangeCalendar.default,
  'checkbox': _SelectComp.default,
  'department': _DepartmentPicker.default,
  'numberRange': _AmountRange.default,
  'customTagSelect': _CustomTagSelectComp.default,
  'budgetment': _BudgetmentPicker.default,
  'budgetSubject': _BudgetSubjectPicker.default,
  'option': _OptionInputPicker.default
};

var IncludeContent = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(IncludeContent, _Component);

  var _super = _createSuper(IncludeContent);

  function IncludeContent(props) {
    var _this;

    (0, _classCallCheck2.default)(this, IncludeContent);
    _this = _super.call(this, props);

    _this.open = function () {
      _this.setState({
        visible: true
      });
    };

    _this.close = function () {
      _this.setState({
        visible: false
      });
    };

    _this.switch = function (val) {
      _this.setState(function (_ref) {
        var visible = _ref.visible;
        if (visible !== val) return {
          visible: !!val
        };
      });
    };

    _this.setSelectedKeys = function (selectedKeys) {
      _this.value = selectedKeys;

      _this.setState({
        value: selectedKeys
      });
    };

    _this.confirm = function () {
      var _this$props = _this.props,
          column = _this$props.field,
          onChange = _this$props.onChange;
      var customFilterItemDto = (0, _defineProperty2.default)({}, column.key, _this.value);
      onChange(_objectSpread({}, customFilterItemDto));

      _this.close();
    };

    _this.clearFilters = function () {
      console.log('clearFilters');
    };

    _this.columnModify = function (col, changed) {
      console.log('columnModify', changed);
    };

    _this.state = {
      value: props.value,
      visible: false
    };
    _this.value = props.value;
    return _this;
  }
  /* 打开popup */


  (0, _createClass2.default)(IncludeContent, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          field = _this$props2.field,
          ModalManager = _this$props2.ModalManager,
          columns = _this$props2.columns;
      var value = this.state.value;
      var Cop = typeComponentMap[field.filterOption.type];
      return /*#__PURE__*/_react.default.createElement(Cop, (0, _extends2.default)({}, field, {
        setSelectedKeys: this.setSelectedKeys,
        selectedKeys: value,
        confirm: this.confirm,
        clearFilters: this.clearFilters,
        columnModify: this.columnModify,
        columns: columns,
        showNumberRangeOkBtn: false,
        ModalManager: ModalManager
      }));
    }
  }]);
  return IncludeContent;
}(_react.Component);

var _default = IncludeContent;
exports.default = _default;