"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _slimLodash = _interopRequireDefault(require("../../utils/slimLodash"));

var _mockTableData = _interopRequireDefault(require("./mockTableData"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * @Description: 
 * @Author: qmm
 * @Date: 2020-08-18 16:18:54
 * @LastEditors: qmm
 * @LastEditTime: 2020-09-02 11:36:27
 */
var columns = [{
  title: '名字',
  dataIndex: 'name',
  filters: [{
    text: '叶问',
    value: '叶问'
  }, {
    text: '张三丰',
    value: '张三丰'
  }]
}, {
  title: '年龄',
  dataIndex: 'age'
}, {
  title: '技能',
  dataIndex: 'skill'
}, {
  title: '门派',
  dataIndex: 'group'
}];

function dataApi() {
  var filters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return new Promise(function (resolve, reject) {
    var data = [];

    _slimLodash.default.forEach(filters, function (v, k) {
      if (k === 'name') {
        _slimLodash.default.forEach(_mockTableData.default, function (d) {
          if (v.includes(d[k])) {
            data.push(d);
          }
        });
      }
    });

    if (_slimLodash.default.isEmpty(data)) data = _mockTableData.default;
    resolve({
      code: 'success',
      data: data,
      total: data.length
    });
  });
}

function BaseTable(props) {
  var setDataFetchFn = props.setDataFetchFn,
      setColumns = props.setColumns,
      dataFetch = props.dataFetch,
      generateTable = props.generateTable,
      setSelectAble = props.setSelectAble;
  (0, _react.useEffect)(function () {
    setDataFetchFn(dataApi);
    setColumns(columns);
    dataFetch();
    setSelectAble(true);
  }, [dataFetch, setColumns, setDataFetchFn, setSelectAble]);
  return /*#__PURE__*/_react.default.createElement("div", {
    style: {
      height: 400,
      display: 'flex'
    }
  }, generateTable({
    rowKey: 'code',
    rowSelection: {
      type: 'checkout'
    }
  }));
}

var _default = BaseTable;
exports.default = _default;