"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("maycur-antd/lib/alert/style/css");

var _alert = _interopRequireDefault(require("maycur-antd/lib/alert"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/popconfirm/style/css");

var _popconfirm = _interopRequireDefault(require("maycur-antd/lib/popconfirm"));

require("maycur-antd/lib/tooltip/style/css");

var _tooltip = _interopRequireDefault(require("maycur-antd/lib/tooltip"));

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

require("maycur-antd/lib/tree/style/css");

var _tree2 = _interopRequireDefault(require("maycur-antd/lib/tree"));

var _react = _interopRequireWildcard(require("react"));

var _Loader = _interopRequireDefault(require("../Loader"));

var _Empty = _interopRequireDefault(require("../Empty"));

var _lodash = _interopRequireDefault(require("lodash"));

var _i18next = _interopRequireDefault(require("i18next"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

var _excluded = ["showSearch", "onSearch", "placeholder", "loadData", "loading", "alertInfo", "defaultExpandAll"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var TreeNode = _tree2.default.TreeNode;
var Search = _input.default.Search;

var NodeIcon = function NodeIcon(props) {
  var node = props.node;
  var icon = null;

  if (node.customIcon) {
    icon = node.customIcon;
  } else {
    if (node.isRoot) {
      icon = /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-ordered-list"
      });
    } else if (node.isLeaf) {
      icon = /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-".concat(props.leafIcon)
      });
    } else {
      icon = /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-".concat(props.folderIcon)
      });
    }
  }

  return icon;
};

var IconButton = function IconButton(props) {
  var node = /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-icon-btn ").concat(props.iconType),
    style: props.style,
    onClick: typeof props.onClick === 'function' ? props.onClick : null
  }, typeof props.icon === 'string' ? /*#__PURE__*/_react.default.createElement("span", {
    className: "fm ".concat(props.icon)
  }) : props.icon);

  var title = props.title;
  return props.showTips ? /*#__PURE__*/_react.default.createElement(_popover.default, {
    placement: "bottomRight",
    overlayClassName: "mktree-tips",
    content: /*#__PURE__*/_react.default.createElement("div", {
      style: {
        cursor: 'pointer'
      },
      onClick: props.onCloseTips
    }, /*#__PURE__*/_react.default.createElement("span", null, props.t('tips', {
      title: title
    })), /*#__PURE__*/_react.default.createElement("span", {
      style: {
        marginLeft: 16
      },
      className: "fm fm-cross"
    })),
    visible: true,
    trigger: "click"
  }, node) : /*#__PURE__*/_react.default.createElement(_tooltip.default, {
    title: props.title
  }, node);
};

var DeletePopover = function DeletePopover(props) {
  var onConfirm = props.onConfirm,
      onCancel = props.onCancel,
      node = props.node,
      t = props.t,
      title = props.title,
      delConfirmText = props.delConfirmText,
      confirmText = props.confirmText,
      isShowExtraDelConfirmText = props.isShowExtraDelConfirmText;
  return /*#__PURE__*/_react.default.createElement(_popconfirm.default, {
    overlayStyle: {
      width: '290px'
    },
    title: node.isLeaf ? confirmText : /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
      style: {
        fontSize: '13px'
      }
    }, delConfirmText), isShowExtraDelConfirmText ? /*#__PURE__*/_react.default.createElement("div", {
      style: {
        marginTop: 5,
        fontSize: '13px'
      }
    }, confirmText) : null),
    placement: "leftTop",
    onConfirm: onConfirm,
    onCancel: onCancel,
    icon: /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-question-o",
      style: {
        color: '#f5be14',
        position: 'absolute',
        top: '5px'
      }
    }),
    okType: "default",
    okButtonProps: {
      type: 'primary'
    }
  }, /*#__PURE__*/_react.default.createElement(IconButton, {
    icon: "fm-trash",
    onClick: function onClick(e) {
      return e.stopPropagation();
    },
    title: title,
    iconType: "delete-icon",
    t: t
  }));
};

var MKTree = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(MKTree, _Component);

  var _super = _createSuper(MKTree);

  function MKTree(props) {
    var _this;

    (0, _classCallCheck2.default)(this, MKTree);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_Tree').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.onExpand = function (expandedKeys) {
      _this.setState({
        expandedKeys: expandedKeys
      });
    };

    _this.onClickItem = function (node, parent) {
      var onClickItem = _this.props.onClickItem;
      if (node && node.key === _this.state.currentKey) return;
      _this.isItemChange = true;

      _this.setState({
        currentKey: node && node.key
      });

      if (typeof onClickItem === 'function') {
        _this.currentNode = node;
        onClickItem(node && node.originalData, parent);
      }
    };

    _this.mergeArr = function (oldArr, newArr) {
      // const { keyName = 'code' } = this.props;
      var res = [];
      var newArrCodes = newArr.map(function (_ref) {
        var key = _ref.key;
        return key;
      });
      var existIndex = [];
      oldArr.forEach(function (item) {
        var i = newArrCodes.indexOf(item.key);

        if (i > -1) {
          existIndex.push(i);
          res.push(newArr[i]);
        } else res.push(item);
      });
      return res.concat(newArr.filter(function (item, i) {
        return !existIndex.includes(i);
      }));
    };

    _this.onLoadData = function (treeNode) {
      return new Promise(function (resolve) {
        var _this$props = _this.props,
            loadData = _this$props.loadData,
            defaultSelect = _this$props.defaultSelect,
            pageSize = _this$props.pageSize;

        if (typeof loadData === 'function') {
          var dataRef = treeNode.props.dataRef;
          _this.props.paging && (dataRef.loading = true); // 加载更多loading

          loadData(dataRef.originalData).then(function (res) {
            var _res = _lodash.default.clone(res);

            var isAdjust = false;

            if (!_lodash.default.isArray(_res)) {
              _res = res.nodes;
              isAdjust = res.isAdjust;
            }

            if (_this.props.paging) {
              var showMore = _res && _res.length >= pageSize;
              dataRef.showMore = showMore;
              dataRef.loading = false;
            }

            if (!_lodash.default.isEmpty(_res)) {
              // dataRef.children = [...(dataRef.children || []), ...this.getTree(res)];
              dataRef.children = _this.mergeArr(dataRef.children || [], _this.getTree(_res));

              if (!isAdjust) {
                // 默认选择根目录下的第一个
                if (dataRef.originalData.isRoot && defaultSelect === 'child') {
                  if (dataRef.children && dataRef.children.length > 0) {
                    _this.onClickItem(dataRef.children[0], dataRef);
                  }
                } else if (dataRef.originalData.isRoot && defaultSelect === 'child-child') {
                  // 默认选择根目录下的第一个节点的子节点的第一个
                  if (dataRef.children && dataRef.children.length > 0 && dataRef.children[0].children && dataRef.children[0].children.length > 0) {
                    _this.onClickItem(dataRef.children[0].children[0], dataRef);
                  }
                }

                if (dataRef.originalData.isRoot && defaultSelect === 'root') {
                  _this.onClickItem(dataRef, dataRef);
                }
              }

              _this.setState(function (_ref2) {
                var loadedKeys = _ref2.loadedKeys,
                    tree = _ref2.tree;
                return {
                  tree: (0, _toConsumableArray2.default)(tree),
                  loadedKeys: _lodash.default.union(loadedKeys, [dataRef.key])
                };
              });
            } else {
              _this.setState(function (_ref3) {
                var loadedKeys = _ref3.loadedKeys;
                return {
                  loadedKeys: _lodash.default.union(loadedKeys, [dataRef.key])
                };
              });
            }

            resolve();
          });
        } else {
          resolve();
        }
      });
    };

    _this.addNode = function (_ref4, e) {
      var clickedNode = _ref4.clickedNode,
          isLeaf = _ref4.isLeaf,
          extra = _ref4.extra;
      e && e.stopPropagation(); // 添加并行子节点时 parentNode 的取值

      var parentNode = extra.isParallel ? extra.parentNode : clickedNode;

      _this.expandNodes([parentNode.key], function () {
        var _this$props2 = _this.props,
            nodeTemplate = _this$props2.nodeTemplate,
            hideUnSaved = _this$props2.hideUnSaved;

        if (typeof nodeTemplate === 'function') {
          var node = nodeTemplate(isLeaf, parentNode.originalData);

          if (!parentNode.children) {
            parentNode.children = [];

            _this.setState(function (_ref5) {
              var loadedKeys = _ref5.loadedKeys;
              return {
                loadedKeys: Array.isArray(loadedKeys) ? [].concat((0, _toConsumableArray2.default)(loadedKeys), [parentNode.key]) : [parentNode.key]
              };
            });
          }

          var newNode = {
            key: "key_".concat(_this.index++),
            unSaved: !hideUnSaved,
            isLeaf: node.isLeaf,
            hasMore: false,
            originalData: node
          }; // 添加并行子节点时，将新节点插入到被点击子节点的后面
          // 添加分类下的子节点时，将子节点添加到分类下第一位

          var clickedNodeIndex = _lodash.default.findIndex(parentNode.children, {
            key: clickedNode.key
          });

          extra.isParallel ? parentNode.children.splice(clickedNodeIndex + 1, 0, newNode) : parentNode.children = [newNode].concat((0, _toConsumableArray2.default)(parentNode.children));
          parentNode.hasChildren = true;

          _this.setState({
            value: _this.state.value
          });

          _this.onClickItem(newNode, parentNode);
        }
      });
    };

    _this.onSave = function () {
      _this.isSave = true; // NOTE 搜索后的树节点跟树中的节点不是同一个，需要在树中找出相应节点更新originalData，否则修改后，树中的数据无法更新

      var tree = _lodash.default.clone(_this.state.tree);

      var selectedNode = _this.iterateTree(tree, _this.currentNode.key); // 树没有完全展开时，可能找不到该树节点


      if (selectedNode) {
        selectedNode.originalData = _this.currentNode && _this.currentNode.originalData;

        _this.setState({
          tree: tree
        });
      }
    };

    _this.onEnableSave = function (code) {
      _this.isSave = true;

      var tree = _lodash.default.clone(_this.state.tree);

      var updatedNode = _this.iterateTree(tree, code);

      if (updatedNode) {
        updatedNode.originalData.enabled = false;

        _this.setState({
          tree: tree
        });
      }
    };

    _this.search = function (query, loadMore) {
      var tree = _this.state.tree;
      _this.searchKeyWord = query;

      if (!loadMore) {
        _this.searchList = [];
      }

      if (!query) {
        // 重置当前选择
        if (tree && tree.length) {
          if (tree[0].originalData.isRoot && tree[0].children && tree[0].children.length) {
            _this.onClickItem(tree[0].children[0], tree[0]);
          } else _this.onClickItem(tree[0]);
        }

        _this.setState({
          isSearch: false
        });

        var onSearchQueryEmpty = _this.props.onSearchQueryEmpty;

        if (typeof onSearchQueryEmpty === 'function') {
          onSearchQueryEmpty();
        }

        return;
      }

      var _this$props3 = _this.props,
          onSearch = _this$props3.onSearch,
          pageSize = _this$props3.pageSize,
          paging = _this$props3.paging;

      if (typeof onSearch === 'function') {
        _this.setState({
          loading: true
        });

        _this.lastSearchId++;
        var searchId = _this.lastSearchId;
        onSearch(query, tree, loadMore).then(function (res) {
          if (searchId !== _this.lastSearchId) return; // 保证每次处理的是最后一次返回结果
          // 重置当前选择

          _this.onClickItem({
            originalData: {}
          });

          _this.searchList = [].concat((0, _toConsumableArray2.default)(_this.searchList || []), (0, _toConsumableArray2.default)(res || []));

          _this.initSearchList();

          _this.showMoreInSearchList = paging && res && res.length >= pageSize;

          _this.setState({
            loading: false,
            isSearch: true
          });
        }, function () {
          _this.setState({
            loading: false
          });
        });
      }
    };

    _this.removeNode = function (node, parent, e) {
      e.stopPropagation();
      var _this$props4 = _this.props,
          removeRemoteNode = _this$props4.removeRemoteNode,
          keyName = _this$props4.keyName;

      var _removeNode = function _removeNode() {
        var i = parent.children.indexOf(node);
        if (i > -1) parent.children.splice(i, 1);

        if (parent.children.length === 0) {
          parent.hasChildren = false;
        }

        _this.setState({
          tree: (0, _toConsumableArray2.default)(_this.state.tree)
        });

        if (parent.originalData.isRoot) {
          _this.onClickItem(parent.children && parent.children[0], parent);
        } else {
          _this.onClickItem(parent);
        }
      };

      if (node.originalData[keyName]) {
        if (typeof removeRemoteNode === 'function') {
          _this.setState({
            loading: true
          });

          removeRemoteNode(node.originalData).then(function () {
            _removeNode();

            _this.setState({
              loading: false
            });
          }, function () {});
        }
      } else {
        _removeNode();
      }
    };

    _this.removeSearchNode = function (node, e) {
      e.stopPropagation();
      var removeRemoteNode = _this.props.removeRemoteNode;

      if (typeof removeRemoteNode === 'function') {
        _this.setState({
          loading: true
        });

        removeRemoteNode(node.originalData).then(function () {
          var key = node.key; // 先删除 searchList 中的节点

          _this.setState({
            loading: false,
            searchList: _this.state.searchList.filter(function (item) {
              return item.key !== key;
            })
          }, function () {
            // 删除节点后，默认选中第一个节点
            _this.onClickItem(_this.state.searchList.length && _this.state.searchList[0]); // tree 里面如果能够找到 该节点也要删除


            _this.removeTreeNode(node);
          });
        });
      }
    };

    _this.iterateTree = function (nodes, code) {
      var target = null;

      var _iteratee = function _iteratee(_nodes) {
        for (var i = 0; i < _nodes.length; i++) {
          var node = _nodes[i];

          if (node.key === code) {
            target = node;
            break;
          } else {
            if (node.children) {
              _iteratee(node.children);
            }
          }
        }
      };

      _iteratee(nodes);

      return target;
    };

    _this.moveTreeNode = function (currentNode, currentParentCode, targetParentCode) {
      var tree = _lodash.default.clone(_this.state.tree);

      var cNodes;
      var childrenName = _this.props.childrenName; // 在树中查找当前节点的原父节点和目标父节点

      var cParent = _this.iterateTree(tree, currentParentCode);

      var tParent = _this.iterateTree(tree, targetParentCode); // 将当前节点从原父节点中移除


      var index = _lodash.default.findIndex(cParent.children, function (child) {
        return child.key === currentNode.code;
      }); // 因为树结构会将文件夹全部请求回来，树节点是按需请求，所以有可能在parent中找不到该树节点（搜索的情况下）


      if (index > -1) {
        cNodes = cParent.children.splice(index, 1); // root 的 originalData 没有 [childrenName]

        cParent.originalData[childrenName] && cParent.originalData[childrenName].splice(index, 1); // 将当前节点加入到新的父节点中
        // TODO（bug）：若新的父节点还未展开过，则不应该将节点 push 进 children，因为点击节点展开的时候会请求子节点。push 进去会导致子节点重复。

        tParent.children = tParent.children || [];
        tParent.children.push(cNodes[0]);
        tParent.originalData[childrenName] = tParent.originalData[childrenName] || [];
        tParent.originalData[childrenName].push(currentNode); // 新增加的文件夹，将子节点添加进去后，没有可展开的箭头icon，所以增加以下代码

        if (!_this.state.expandedKeys.includes(tParent.key)) {
          _this.expandNodes([tParent.key]);
        }

        _this.setState({
          tree: tree
        });
      }
    };

    _this.expandNodes = function (keys, callback) {
      var expandedKeys = _this.state.expandedKeys;

      var cb = function cb() {
        if (typeof callback === 'function') {
          callback();
        }
      };

      if (Array.isArray(keys) && keys.length) {
        var newKeys = (0, _toConsumableArray2.default)(new Set([].concat((0, _toConsumableArray2.default)(expandedKeys), (0, _toConsumableArray2.default)(keys))));

        _this.setState({
          expandedKeys: newKeys
        }, function () {
          cb();
        });
      } else {
        cb();
      }
    };

    _this.loop = function (nodes, parent, level) {
      return nodes ? nodes.map(function (node, index) {
        return /*#__PURE__*/_react.default.createElement(TreeNode, {
          key: node.key || index,
          title: _this.renderTitle(node, parent, level, index),
          dataRef: node,
          isLeaf: node.isLeaf || !node.hasChildren,
          ref: function ref(_ref6) {
            return node.ref = _ref6;
          }
        }, !_lodash.default.isEmpty(node.children) && _this.loop(node.children, node, level + 1), node.showMore && /*#__PURE__*/_react.default.createElement(TreeNode, {
          key: node.key,
          title: /*#__PURE__*/_react.default.createElement("div", {
            className: "node__item load-more",
            onClick: function onClick() {
              return _this.onLoadData(node.ref);
            }
          }, "\u52A0\u8F7D\u66F4\u591A", node.loading && /*#__PURE__*/_react.default.createElement(_icon.default, {
            type: "loading",
            style: {
              fontSize: 18
            },
            spin: true
          })),
          dataRef: node,
          isLeaf: true
        }));
      }) : null;
    };

    _this.onCloseTips = function () {
      var pageId = _this.props.pageId;

      _this.setState({
        hasReadTips: true
      });

      var pageIds = localStorage.getItem('hasReadPageIds');
      localStorage.setItem('hasReadPageIds', pageIds ? "".concat(pageIds, ",").concat(pageId) : pageId);
    };

    _this.renderTitle = function (node, parent, level, index) {
      var _this$state = _this.state,
          currentKey = _this$state.currentKey,
          hasReadTips = _this$state.hasReadTips,
          t = _this$state.t;
      var _this$props5 = _this.props,
          titleName = _this$props5.titleName,
          needAction = _this$props5.needAction,
          leafIcon = _this$props5.leafIcon,
          folderIcon = _this$props5.folderIcon,
          keyName = _this$props5.keyName,
          maxLevel = _this$props5.maxLevel,
          renderIcon = _this$props5.renderIcon,
          renderExtra = _this$props5.renderExtra,
          addLeafTitle = _this$props5.addLeafTitle,
          deleteLeafTitle = _this$props5.deleteLeafTitle,
          deleteChildNodeTitle = _this$props5.deleteChildNodeTitle,
          addFolderTitle = _this$props5.addFolderTitle,
          addParallelLeafTitle = _this$props5.addParallelLeafTitle,
          showAddParallelLeafIcon = _this$props5.showAddParallelLeafIcon,
          needPopoverType = _this$props5.needPopoverType,
          _this$props5$confirmT = _this$props5.confirmText,
          confirmText = _this$props5$confirmT === void 0 ? t('confirm') : _this$props5$confirmT,
          _this$props5$delConfi = _this$props5.delConfirmText,
          delConfirmText = _this$props5$delConfi === void 0 ? t('delConfirm') : _this$props5$delConfi,
          _this$props5$isShowEx = _this$props5.isShowExtraDelConfirmText,
          isShowExtraDelConfirmText = _this$props5$isShowEx === void 0 ? true : _this$props5$isShowEx,
          isHideDeleteBtn = _this$props5.isHideDeleteBtn,
          hideActionBy = _this$props5.hideActionBy,
          hideDeleteBtnByChildren = _this$props5.hideDeleteBtnByChildren;
      var showTips = !parent && !hasReadTips;
      var nodeDisabled = 'enabled' in node.originalData ? node.originalData.enabled ? '' : ' disabled' : '';
      var isHideAction = node.originalData && node.originalData[hideActionBy];
      var isRoot = node.isRoot || node.originalData.isRoot;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "node__item ".concat(currentKey === node.key ? ' active' : '', " ").concat(nodeDisabled, " ").concat(isRoot ? 'root-item' : ''),
        onClick: function onClick() {
          _this.onClickItem(node, parent);
        }
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'node--title'
      }, typeof renderIcon === 'function' ? renderIcon(node ? node.originalData : {}) : /*#__PURE__*/_react.default.createElement(NodeIcon, {
        className: 'node--title__icon',
        node: node ? node.originalData : {},
        leafIcon: leafIcon,
        folderIcon: folderIcon
      }), /*#__PURE__*/_react.default.createElement("div", {
        className: 'node--title__label'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'title--label__text'
      }, node.originalData[titleName], node.originalData.totalCount ? /*#__PURE__*/_react.default.createElement("span", {
        className: "title--label__count"
      }, "(", node.originalData.totalCount, ")") : null, typeof renderExtra === 'function' && renderExtra(node ? node.originalData : {})), node.unSaved && /*#__PURE__*/_react.default.createElement("div", {
        className: 'title--label__unsaved'
      }, " [", t('unSaved'), "]"))), !isHideAction && !node.originalData.customConfig && needAction && /*#__PURE__*/_react.default.createElement("span", {
        className: "node--operator".concat(!hasReadTips && showTips ? ' show-tips' : '')
      }, !node.isLeaf && node.originalData[keyName] && (!maxLevel || maxLevel && level < maxLevel) ? /*#__PURE__*/_react.default.createElement(IconButton, {
        title: addFolderTitle,
        icon: "fm-".concat(folderIcon),
        showTips: needPopoverType === 'folder' ? showTips : false,
        onCloseTips: _this.onCloseTips,
        onClick: _this.addNode.bind((0, _assertThisInitialized2.default)(_this), {
          clickedNode: node,
          isLeaf: false,
          extra: {}
        }),
        t: t
      }) : null, (!node.isLeaf || showAddParallelLeafIcon) && node.originalData[keyName] ? /*#__PURE__*/_react.default.createElement(IconButton, {
        title: !node.isLeaf ? addLeafTitle : addParallelLeafTitle || addLeafTitle,
        icon: "fm-".concat(leafIcon),
        showTips: needPopoverType === 'file' ? showTips : false,
        onCloseTips: _this.onCloseTips,
        iconType: "add-icon",
        onClick: _this.addNode.bind((0, _assertThisInitialized2.default)(_this), {
          clickedNode: node,
          isLeaf: true,
          extra: {
            isParallel: node.isLeaf,
            index: index,
            parentNode: parent
          }
        }),
        t: t
      }) : null, !node.originalData.isRoot && !isHideDeleteBtn && (!hideDeleteBtnByChildren || !(node.children && node.children.length)) && /*#__PURE__*/_react.default.createElement(DeletePopover, {
        t: t,
        node: node,
        onConfirm: function onConfirm(e) {
          return _this.removeNode(node, parent, e);
        },
        onCancel: function onCancel(e) {
          return e.stopPropagation();
        },
        confirmText: confirmText,
        delConfirmText: delConfirmText,
        isShowExtraDelConfirmText: isShowExtraDelConfirmText,
        title: node.isLeaf ? deleteLeafTitle : deleteChildNodeTitle || deleteLeafTitle
      })), !isHideAction && node.originalData.customConfig && needAction && /*#__PURE__*/_react.default.createElement("span", {
        className: "node--operator".concat(!hasReadTips && showTips ? ' show-tips' : '')
      }, Array.isArray(node.originalData.customConfig.customIcons) && node.originalData.customConfig.customIcons.map(function (item, i) {
        return /*#__PURE__*/_react.default.createElement(IconButton, {
          onCloseTips: _this.onCloseTips,
          key: i,
          title: item.title,
          icon: item.icon,
          onClick: function onClick() {
            return item.action(node.originalData);
          },
          t: t
        });
      }), node.originalData.customConfig.isNeedAddFolder && node.originalData[keyName] && (!maxLevel || maxLevel && level < maxLevel) ? /*#__PURE__*/_react.default.createElement(IconButton, {
        title: addFolderTitle,
        showTips: needPopoverType === 'folder' ? showTips : false,
        onCloseTips: _this.onCloseTips,
        icon: "fm-".concat(folderIcon),
        onClick: _this.addNode.bind((0, _assertThisInitialized2.default)(_this), {
          clickedNode: node,
          isLeaf: false,
          extra: {
            isParallel: node.isLeaf,
            index: index,
            parentNode: parent
          }
        }),
        t: t
      }) : null, node.originalData.customConfig.isNeedAddFile && node.originalData[keyName] ? /*#__PURE__*/_react.default.createElement(IconButton, {
        title: addLeafTitle,
        iconType: "add-icon",
        icon: "fm-".concat(leafIcon),
        showTips: needPopoverType === 'file' ? showTips : false,
        onCloseTips: _this.onCloseTips,
        onClick: _this.addNode.bind((0, _assertThisInitialized2.default)(_this), {
          clickedNode: node,
          isLeaf: true,
          extra: {
            isParallel: node.isLeaf,
            index: index,
            parentNode: parent
          }
        }),
        t: t
      }) : null, node.originalData.customConfig.isNeedDelete && !isHideDeleteBtn && /*#__PURE__*/_react.default.createElement(DeletePopover, {
        t: t,
        node: node,
        onConfirm: function onConfirm(e) {
          return _this.removeNode(node, parent, e);
        },
        onCancel: function onCancel(e) {
          return e.stopPropagation();
        },
        confirmText: confirmText,
        delConfirmText: delConfirmText,
        isShowExtraDelConfirmText: isShowExtraDelConfirmText,
        title: node.isLeaf ? deleteLeafTitle : deleteChildNodeTitle || deleteLeafTitle
      })));
    };

    _this.renderSearchList = function (list) {
      var _this$props6 = _this.props,
          titleName = _this$props6.titleName,
          needAction = _this$props6.needAction,
          leafIcon = _this$props6.leafIcon,
          folderIcon = _this$props6.folderIcon,
          renderIcon = _this$props6.renderIcon,
          renderExtra = _this$props6.renderExtra,
          isHideDeleteBtn = _this$props6.isHideDeleteBtn,
          hideActionBy = _this$props6.hideActionBy,
          deleteLeafTitle = _this$props6.deleteLeafTitle,
          deleteChildNodeTitle = _this$props6.deleteChildNodeTitle;
      var _this$state2 = _this.state,
          currentKey = _this$state2.currentKey,
          loading = _this$state2.loading,
          t = _this$state2.t;
      return list instanceof Array && list.length > 0 ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, list.map(function (node) {
        var isHideAction = node.originalData && node.originalData[hideActionBy];
        var nodeDisabled = 'enabled' in node.originalData ? node.originalData.enabled ? '' : ' disabled' : '';
        return /*#__PURE__*/_react.default.createElement("div", {
          key: node.key,
          className: "".concat(nodeDisabled, " node__item search-list__item") + (currentKey === node.key ? ' active' : ''),
          onClick: function onClick() {
            _this.onClickItem(node);
          }
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: 'node--title'
        }, typeof renderIcon === 'function' ? renderIcon(node ? node.originalData : {}) : /*#__PURE__*/_react.default.createElement(NodeIcon, {
          className: 'node--title__icon',
          node: node ? node.originalData : {},
          leafIcon: leafIcon,
          folderIcon: folderIcon
        }), /*#__PURE__*/_react.default.createElement("span", {
          className: 'node--title__label'
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: 'title--label__text'
        }, node.originalData[titleName], typeof renderExtra === 'function' && renderExtra(node ? node.originalData : {})), node.unSaved && /*#__PURE__*/_react.default.createElement("span", {
          className: 'title--label__unsaved'
        }, " [", t('unSaved'), "]"))), !isHideAction && needAction && !node.originalData.isRoot && !node.originalData.customConfig && !isHideDeleteBtn && /*#__PURE__*/_react.default.createElement("span", {
          className: "node--operator"
        }, /*#__PURE__*/_react.default.createElement(DeletePopover, {
          t: t,
          node: node,
          onConfirm: function onConfirm(e) {
            return _this.removeSearchNode(node, e);
          },
          onCancel: function onCancel(e) {
            return e.stopPropagation();
          },
          title: node.isLeaf ? deleteLeafTitle : deleteChildNodeTitle || deleteLeafTitle
        })), !isHideAction && needAction && !node.originalData.isRoot && node.originalData.customConfig && node.originalData.customConfig.isNeedDelete && !isHideDeleteBtn && /*#__PURE__*/_react.default.createElement("span", {
          className: "node--operator"
        }, /*#__PURE__*/_react.default.createElement(DeletePopover, {
          t: t,
          node: node,
          onConfirm: function onConfirm(e) {
            return _this.removeSearchNode(node, e);
          },
          onCancel: function onCancel(e) {
            return e.stopPropagation();
          },
          title: node.isLeaf ? deleteLeafTitle : deleteChildNodeTitle || deleteLeafTitle
        })));
      }), _this.showMoreInSearchList && /*#__PURE__*/_react.default.createElement("div", {
        className: "node__item search-list__item load-more",
        onClick: function onClick() {
          return _this.search(_this.searchKeyWord, true);
        }
      }, t('loadMore'), loading && /*#__PURE__*/_react.default.createElement(_icon.default, {
        type: "loading",
        style: {
          fontSize: 18
        },
        spin: true
      }))) : /*#__PURE__*/_react.default.createElement(_Empty.default, null);
    };

    _this.initSearchList = function () {
      _this.setState({
        searchList: _this.getTree(_this.searchList) || []
      }, function () {
        if (!_lodash.default.isEmpty(_this.searchList)) {
          _this.onClickItem(_this.state.searchList[0]);
        }
      });
    };

    _this.initTree = function (value) {
      var defaultExpandedKeys = _this.props.defaultExpandedKeys;

      _this.setState({
        tree: _this.getTree(value)
      }, function () {
        if (defaultExpandedKeys) {
          _this.setState({
            expandedKeys: defaultExpandedKeys,
            loadedKeys: []
          });
        } else {
          var tree = _this.state.tree;

          if (tree && tree.length && tree[0].originalData.isRoot) {
            // 默认展开根节点
            _this.setState({
              expandedKeys: [tree[0].key],
              loadedKeys: []
            });

            _this.onClickItem(tree[0]);
          }
        }
      });
    };

    _this.expandedKeyPackUp = function (codes) {
      var expandedKeys = _this.state.expandedKeys;
      expandedKeys = expandedKeys.filter(function (item) {
        return !codes.includes(item);
      });

      _this.setState({
        expandedKeys: expandedKeys
      });
    };

    _this.resetCurrentLoadKey = function (codes) {
      var loadedKeys = _this.state.loadedKeys;
      loadedKeys = loadedKeys.filter(function (item) {
        return !codes.includes(item);
      });

      _this.setState({
        loadedKeys: loadedKeys
      });
    };

    var hasReadPageIds = (localStorage.getItem('hasReadPageIds') || '').split(',');
    _this.state = {
      expandedKeys: [],
      tree: [],
      currentKey: '',
      loading: false,
      isSearch: false,
      loadedKeys: [],
      needFirstTips: true,
      hasReadTips: !props.pageId || hasReadPageIds.includes(props.pageId),
      t: _mkTranslate.default.noop()
    };
    _this.index = 0;
    _this.isItemChange = false;
    _this.isSave = false;
    _this.currentNode = props.currentNode;
    _this.isInit = false;
    _this.lastSearchId = 0;
    _this.onSearchQueryChange = (0, _debounce.default)(_this.search, 800);
    _this.onSearch = (0, _debounce.default)(_this.search, 800, {
      leading: true,
      trailing: false
    });

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(MKTree, [{
    key: "removeTreeNode",
    value: function removeTreeNode(node) {
      var key = node.key;

      var _removeNode = function _removeNode(tree) {
        for (var i = 0; i < tree.length; i++) {
          var _node = tree[i];

          if (_node.key === key) {
            tree.splice(i, 1);
            return true;
          }

          if (!_lodash.default.isEmpty(_node.children)) {
            if (_removeNode(_node.children)) return true;
          }
        }
      };

      var tree = this.state.tree;

      _removeNode(tree);

      this.setState({
        tree: (0, _toConsumableArray2.default)(tree)
      });
    } // 在树中找出指定code的节点

  }, {
    key: "getTree",
    value:
    /* 将数据转化为内部格式 */
    function getTree(value) {
      var _this2 = this;

      if (!value) return;
      var _this$props7 = this.props,
          keyName = _this$props7.keyName,
          childrenName = _this$props7.childrenName,
          isSync = _this$props7.isSync;

      var _getTree = function _getTree(tree) {
        var _tree = [];
        tree.forEach(function (item) {
          var key = item[keyName] || "key_".concat(_this2.index++);
          var children = item[childrenName];
          var _hasChildren = true; // 有些后端接口还没有返回hasChildren

          if (!item.isRoot) {
            if (isSync) {
              _hasChildren = children && children.length > 0;
            } else {
              if ('hasChildren' in item) {
                _hasChildren = item.hasChildren;
              }
            }
          }

          var node = {
            key: key,
            isLeaf: !!item.isLeaf,
            hasChildren: _hasChildren,
            originalData: item
          };

          if (!_lodash.default.isEmpty(children)) {
            node.children = _getTree(children);
          }

          _tree.push(node);
        });
        return _tree;
      };

      return _getTree(value);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(props) {
      var outerNode = props.currentNode,
          preValue = props.value,
          hideUnSaved = props.hideUnSaved;

      if (!this.isInit && !_lodash.default.isEmpty(preValue)) {
        this.initTree((0, _toConsumableArray2.default)(preValue));
        this.isInit = true;
      } else {
        if (preValue !== this.props.value) {
          var tree = this.state.tree;

          if (tree && tree[0]) {
            tree[0].originalData.name = preValue[0].name;
            this.setState({
              tree: tree
            });
          }
        }

        if (outerNode !== this.props.currentNode) {
          if (!this.isItemChange) {
            var currentNode = this.currentNode,
                isSave = this.isSave;
            if (!hideUnSaved) currentNode.unSaved = !isSave;
            currentNode.originalData = outerNode;
            if (outerNode.code) currentNode.key = outerNode.code;

            if (isSave) {
              this.isSave = false; // 如果是save 且 是文件夹节点 则需更新 loadedKeys
              // if (!currentNode.isLeaf) {
              //     if (currentNode.isNew) {
              //         currentNode.isNew = false;
              //         this.setState(({ loadedKeys }) => ({ loadedKeys: [...loadedKeys, currentNode.key] }))
              //     } 
              // }
            }

            var isSearch = this.state.isSearch;
            var originData = isSearch ? 'searchList' : 'tree';
            this.setState((0, _defineProperty2.default)({}, originData, (0, _toConsumableArray2.default)(this.state[originData])));
          } else {
            this.isItemChange = false;
          }
        }
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      if (!this.isInit && !_lodash.default.isEmpty(this.props.value)) {
        this.initTree((0, _toConsumableArray2.default)(this.props.value));
        this.isInit = true;
      }
    } // 收起已展开的节点

  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props8 = this.props,
          showSearch = _this$props8.showSearch,
          onSearch = _this$props8.onSearch,
          placeholder = _this$props8.placeholder,
          loadData = _this$props8.loadData,
          loading = _this$props8.loading,
          alertInfo = _this$props8.alertInfo,
          defaultExpandAll = _this$props8.defaultExpandAll,
          restProps = (0, _objectWithoutProperties2.default)(_this$props8, _excluded);
      var _this$state3 = this.state,
          tree = _this$state3.tree,
          isSearch = _this$state3.isSearch,
          searchList = _this$state3.searchList,
          loadedKeys = _this$state3.loadedKeys;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-mktree-container")
      }, showSearch ? /*#__PURE__*/_react.default.createElement("div", {
        className: "search-box"
      }, /*#__PURE__*/_react.default.createElement(Search, {
        onSearch: function onSearch(value) {
          return _this3.onSearch(value);
        },
        onChange: function onChange(e) {
          _this3.onSearchQueryChange(e.target.value);
        },
        placeholder: placeholder
      })) : null, !_lodash.default.isEmpty(alertInfo) ? /*#__PURE__*/_react.default.createElement("div", {
        className: 'alert-box'
      }, /*#__PURE__*/_react.default.createElement(_alert.default, alertInfo)) : null, /*#__PURE__*/_react.default.createElement("div", {
        className: "directory-wrapper"
      }, isSearch ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, this.renderSearchList(searchList)) : /*#__PURE__*/_react.default.createElement(_tree2.default, (0, _extends2.default)({}, restProps, {
        defaultExpandAll: defaultExpandAll,
        expandedKeys: this.state.expandedKeys,
        onExpand: this.onExpand,
        loadData: this.onLoadData,
        loadedKeys: loadedKeys
      }), this.loop(tree, null, 1))), loading ? /*#__PURE__*/_react.default.createElement("div", {
        className: "loading-wrapper"
      }, /*#__PURE__*/_react.default.createElement(_Loader.default, {
        active: true,
        mask: true
      })) : null);
    }
  }]);
  return MKTree;
}(_react.Component);

MKTree.defaultProps = {
  keyName: 'code',
  childrenName: 'children',
  titleName: 'title',
  needAction: true,
  leafIcon: 'paper',
  folderIcon: 'folde-open',
  alertInfo: {},
  addLeafTitle: _i18next.default.t('MK_Tree:add'),
  //操作按钮中添加子节点的tooltip文字
  addFolderTitle: _i18next.default.t('MK_Tree:add'),
  //操作按钮中添加分类的tooltip文字
  needPopoverType: 'folder',
  paging: false //是否分页

};
var _default = MKTree;
exports.default = _default;