"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _reactI18next = require("react-i18next");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Option = _select.default.Option;

var CityInput = function CityInput(props) {
  var disabled = props.disabled;

  var _useState = (0, _react.useState)(props.cities || []),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      cities = _useState2[0],
      setCities = _useState2[1];

  var _useTranslation = (0, _reactI18next.useTranslation)(['MK_PaymentAccountModal']),
      t = _useTranslation.t;

  var searchCity = (0, _debounce.default)(function (inputValue) {
    var cities = props.cities;
    inputValue = _lodash.default.trim(inputValue);
    var results = inputValue ? _lodash.default.filter(cities, function (city) {
      return (city.fuzzy || '').indexOf(inputValue) !== -1;
    }) : cities;
    setCities(results);
  }, 800);
  (0, _react.useEffect)(function () {
    var cities = props.cities,
        fetchCities = props.fetchCities;

    if (_lodash.default.isEmpty(cities) && typeof fetchCities === 'function') {
      fetchCities().then(function (cities) {
        setCities(cities);
      });
    }
  }, [props]);
  return /*#__PURE__*/_react.default.createElement(_select.default, (0, _extends2.default)({}, props, {
    filterOption: false,
    onSearch: searchCity,
    notFoundContent: !cities.length ? t('cityInput.placeholder') : t('cityInput.notFoundContent'),
    showSearch: true,
    disabled: disabled
  }), cities.map(function (city) {
    return /*#__PURE__*/_react.default.createElement(Option, {
      key: city.hairCode,
      value: city.hairCode,
      title: city.fuzzy
    }, city.hairName);
  }));
};

var _default = CityInput;
exports.default = _default;