"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function invoiceAutoFill(invoiceData) {
  var expenseData = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var formFields = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  // let ticketInvoiceTypes = [
  //     '-5',//火车票
  //     '-3',//长途汽车票
  //     '-4',//出租车票
  //     '507',//通行费发票
  //     '506'//机票行程单
  // ];
  var formData = {};

  if (invoiceData && invoiceData.length > 0) {
    var lastOne = _lodash.default.last(invoiceData);

    if (lastOne && !lastOne.identityFlag) {
      // 已被导入过的发票不带出值
      return formData;
    }

    var consumeTimeField, consumeLocationField, trainSeatField, airClassField, airlineCompanyField, hotelField, expenseTypeCodeField;

    _lodash.default.forEach(formFields, function (field) {
      switch (field.identifier) {
        case 'consumeTime':
          consumeTimeField = field;
          break;

        case 'consumeLocation':
          consumeLocationField = field;
          break;

        case 'trainSeat':
          trainSeatField = field;
          break;

        case 'airClass':
          airClassField = field;
          break;

        case 'airlineCompany':
          airlineCompanyField = field;
          break;

        case 'hotel':
          hotelField = field;
          break;

        case 'expenseTypeCode':
          expenseTypeCodeField = field;
          break;

        default:
          break;
      }
    });

    var singleCity = '',
        pairCity = {},
        airClass = {}; //日期填充

    if (consumeTimeField && consumeTimeField.property.valueDefault === 'ISSUE_DATE') {
      var currentConsumeTime = expenseData['consumeTime'];

      switch (consumeTimeField.property.selectionModule) {
        case 'SINGLE':
          formData['consumeTime'] = {
            currentTime: lastOne.ticketData && lastOne.ticketData.consumeTime
          };
          break;

        case 'PAIR':
          //区间的情况有值不填充
          if ((!currentConsumeTime || currentConsumeTime && !currentConsumeTime.timeRange) && lastOne.ticketData) {
            formData['consumeTime'] = {
              timeRange: {
                startDate: lastOne.ticketData.consumeStartDate,
                endDate: lastOne.ticketData.consumeEndDate
              }
            };
          }

          break;

        default:
          break;
      }
    } // 费用类型填充 已有则不填充


    if (expenseTypeCodeField && !expenseTypeCodeField.formCode) {
      formData['expenseTypeCode'] = lastOne['expenseType'];
    } //票面信息处理
    // if (ticketInvoiceTypes.includes(lastOne.type) && lastOne.ticketData) {


    if (lastOne.ticketData) {
      var ticketData = lastOne.ticketData;
      /* 火车票 */

      if (lastOne.type === '-5') {
        //城市信息
        if (ticketData.departureCity) {
          singleCity = ticketData.departureCity;
          pairCity.departure = ticketData.departureCity;
        }

        if (ticketData.arrivalCity) {
          singleCity = ticketData.arrivalCity;
          pairCity.destination = ticketData.arrivalCity;
        }

        if (trainSeatField && trainSeatField.property.manualItems && ticketData.seatType) {
          //火车座位填充
          var matchedSeat = _lodash.default.find(trainSeatField.property.manualItems, {
            name: ticketData.seatType
          });

          if (matchedSeat) formData['trainSeat'] = matchedSeat;
        }
        /* 飞机票 */

      } else if (lastOne.type === '506' && ticketData.flights && ticketData.flights.length > 0) {
        var flight = ticketData.flights[0]; //城市信息

        if (flight.departureCity) {
          singleCity = flight.departureCity;
          pairCity.departure = flight.departureCity;
        }

        if (flight.arrivalCity) {
          singleCity = flight.arrivalCity;
          pairCity.destination = flight.arrivalCity;
        }

        if (ticketData.seatClassCode && ticketData.seatClassName && airClassField) {
          airClass = {
            code: ticketData.seatClassCode,
            name: ticketData.seatClassName
          };
          formData['airClass'] = airClass;
        }

        if (ticketData.airLineName && airlineCompanyField) {
          formData['airlineCompany'] = ticketData.airLineName;
        }
      } else {
        //城市信息
        //单个城市取location，location不存在就取到达城市
        singleCity = ticketData.location || ticketData.arrivalCity; //区间城市取departure，departureCity，不存在就取location

        pairCity.departure = ticketData.departureCity || ticketData.location;
        pairCity.destination = ticketData.arrivalCity || ticketData.location;
      }
      /* TODO 长途汽车票(目前除了日期，没有多余信息可映射) */


      if (consumeLocationField) {
        //城市填充
        var currentConsumeLocation = expenseData['consumeLocation'] || {};

        switch (consumeLocationField.property.selectionModule) {
          case 'SINGLE':
            if (singleCity) formData['consumeLocation'] = {
              location: singleCity
            };
            break;

          case 'PAIR':
            if (!_lodash.default.isEmpty(pairCity)) formData['consumeLocation'] = {
              cityPair: _objectSpread(_objectSpread({}, currentConsumeLocation.cityPair), pairCity)
            };
            break;

          default:
            break;
        }
      } // 带入酒店名称


      if (hotelField && hotelField.property.valueDefault === 'SUPPLIER_NAME') {
        var hotelNames = [];
        invoiceData.forEach(function (invoice) {
          if (invoice.ticketData && invoice.ticketData.hotel) {
            hotelNames.push(invoice.ticketData.hotel);
          }
        }); // 如果多张发票取第一张带酒店名称的

        if (hotelNames[0]) {
          formData['hotel'] = hotelNames[0];
        }
      }
    }
  }

  return formData;
}

var _default = invoiceAutoFill;
exports.default = _default;