"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

/************  地址库数据通用处理方法，原各项目utils中的将会删除 **************/
var placesHashMap = {},
    bankPlacesHashMap = {};
var zh_locationNodes = []; // let locationNodes = [];// eslint-disable-line no-unused-vars
// 预设热门城市
// 北京(ZH1_0_00)、上海(ZH4_0_00)、广州(ZH9_4_01)、深圳(ZH9_15_01)、杭州(ZH32_1_01)、
// 天津(ZH2_0_00)、成都(ZH28_3_01)、重庆(ZH33_0_00)、哈尔滨(ZH15_3_01)、南京(ZH19_4_01)
// 武汉(ZH16_9_01)、南昌(ZH20_6_01)、西安(ZH27_7_01)、合肥(ZH3_8_01)、长沙(ZH17_1_01)、
// 大连(ZH21_4_01)、石家庄(ZH13_8_01)、济南(ZH25_5_01)

var hotCity = ['ZH1_0_00', 'ZH4_0_00', 'ZH9_4_01', 'ZH9_15_01', 'ZH32_1_01', 'ZH2_0_00', 'ZH28_3_01', 'ZH33_0_00' // 'ZH15_3_01', 'ZH19_4_01',
// 'ZH16_9_01',
// 'ZH20_6_01', 'ZH27_7_01', 'ZH3_8_01', 'ZH17_1_01', 'ZH21_4_01', 'ZH13_8_01', 'ZH25_5_01'
];

function formatPlaceData(locationData, type) {
  var nodes = [];
  Object.keys(locationData).forEach(function (key) {
    nodes.push(_convertNode(locationData[key], type === 'expense' ? placesHashMap : bankPlacesHashMap));
  });
  return nodes;
} // 存储中文地址数据数据，定位地址的需要根据中文查对应code匹配地址带入费用


function formatPlaceDataZh(locationData, type) {
  var nodes = [];
  var placesHashMap = {};
  Object.keys(locationData).forEach(function (key) {
    nodes.push(_convertNode(locationData[key], placesHashMap));
  });
  zh_locationNodes = nodes;
}

function _convertNode(source, placesHashMap) {
  var parentName = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  var res = {};
  var childrenProp = ['countries', 'provinces', 'cities', 'regions'];
  var prefix = ['country', 'province', 'city', 'region'];
  var isRoot = ['domestic', 'abroad'].includes(source.code);

  if (isRoot) {
    res.code = source.code;
    res.name = source.name;
  } else {
    var _iterator = _createForOfIteratorHelper(prefix),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var k = _step.value;
        var key = "".concat(k, "Code");

        if (source[key]) {
          res.code = source[key];
          res.name = source["".concat(k, "Name")];
          break;
        }
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }

  var mapObj = {
    code: res.code,
    name: res.name,
    fullName: "".concat(parentName).concat(res.name),
    fullCode: source.fullCode
  };
  res.fullCode = mapObj.fullCode;
  res.fullName = mapObj.fullName;
  placesHashMap[res.code] = mapObj;
  var i = childrenProp.findIndex(function (k) {
    return !!source[k];
  });

  if (i > -1) {
    res.children = source[childrenProp[i]].map(function (cd) {
      return _convertNode(cd, placesHashMap, isRoot ? '' : "".concat(mapObj.fullName, "-"));
    });
    mapObj.children = res.children;
  } else {
    mapObj.isLeaf = true;
    mapObj.fuzzy = source.fuzzy;
  }

  return res;
}

function getCityName(locationCode, type) {
  var locationName = '';

  if (locationCode) {
    var lastStrikethroughIndex = locationCode.lastIndexOf('-'),
        slashIndex,
        placeCode = locationCode.substr(lastStrikethroughIndex + 1),
        locationFullName,
        hashMap = type === 'expense' ? placesHashMap : bankPlacesHashMap;
    var place = hashMap[placeCode];

    if (place) {
      locationFullName = place.fullName;
      slashIndex = locationFullName.indexOf('/');
      locationName = locationFullName.substr(slashIndex + 1);
    }
  }

  return locationName;
}

function getSimpleCityName(location, type) {
  type = type ? type : 'expense';

  var getLocationName = function getLocationName(locationCode) {
    var locationName = '';

    if (locationCode) {
      var lastStrikethroughIndex = locationCode.lastIndexOf('-'),
          placeCode = locationCode.substr(lastStrikethroughIndex + 1),
          hashMap = type === 'expense' ? placesHashMap : bankPlacesHashMap;
      var place = hashMap[placeCode];

      if (place) {
        locationName = place.name;
      }
    }

    return locationName;
  };

  if (_lodash.default.isArray(location)) {
    return _lodash.default.map(location, function (locationCode) {
      return getLocationName(locationCode);
    }).join('，');
  }

  return getLocationName(location);
}

function getPlaceDataByCode(code, type) {
  type = type || 'expense';

  if (type === 'expense') {
    return placesHashMap && placesHashMap[code];
  } else {
    return bankPlacesHashMap && bankPlacesHashMap[code];
  }
}

function getPlaceDataByCodes(codes, type) {
  type = type || 'expense';
  var places = [];

  _lodash.default.each(codes, function (code) {
    if (code) {
      if (type === 'expense') {
        if (placesHashMap[code]) places.push(placesHashMap[code]);
      } else {
        if (bankPlacesHashMap[code]) places.push(bankPlacesHashMap[code]);
      }
    }
  });

  return places;
}

function getPlacesHashMap() {
  return placesHashMap;
}

function getBankPlacesHashMap() {
  return bankPlacesHashMap;
}

function getPlaceDataByFullCode(locationCode) {
  var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'expense';
  var place = {};

  if (locationCode) {
    var lastStrikethroughIndex = locationCode.lastIndexOf('-'),
        placeCode = locationCode.substr(lastStrikethroughIndex + 1),
        hashMap = type === 'expense' ? placesHashMap : bankPlacesHashMap;
    place = hashMap[placeCode];
  }

  return place;
}

var getConsumeLocation = function getConsumeLocation(value) {
  var pairValue = value && value.cityPair;
  var showPairValue = '';

  if (pairValue) {
    showPairValue += pairValue.departure && getSimpleCityName(pairValue.departure, 'expense') || '无';
    showPairValue += ' ~ ' + (pairValue.destination && getSimpleCityName(pairValue.destination, 'expense') || '无');
  }

  return showPairValue ? showPairValue : getSimpleCityName(value && value.location, 'expense');
}; // 将定位到的地理位置转换为系统内的地址


function getCurrentLocationData(province, city, district) {
  // var domestic = locationNodes[0];
  var domestic = zh_locationNodes[0];
  var errorResult = {
    code: 'error',
    name: '定位出错'
  };

  if (!domestic) {
    return errorResult;
  }

  var filter = function filter(str) {
    if (!str) return null;
    var result = str.replace(/(市|省|县|壮族自治区|回族自治区|维吾尔自治区|自治区|区)/, '');
    return result;
  };

  province = filter(province);
  city = filter(city);
  district = filter(district);
  var matchedProvice, matchedCity, matchedDistrict;

  if (province) {
    matchedProvice = _lodash.default.find(domestic.children, function (provinceNode) {
      if (province && provinceNode.name.indexOf(province) >= 0) {
        return true;
      }
    });
  }

  if (matchedProvice && city) {
    matchedCity = _lodash.default.find(matchedProvice.children, function (cityNode) {
      if (city && cityNode.name.indexOf(city) >= 0) {
        return true;
      }
    });
  }

  if (matchedCity && district) {
    matchedDistrict = _lodash.default.find(matchedCity.children, function (districtNode) {
      if (districtNode.name.indexOf(district) >= 0) {
        return true;
      }
    });
  }

  if (matchedDistrict) {
    return placesHashMap[matchedDistrict.code];
  } else if (matchedCity) {
    return placesHashMap[matchedCity.children && matchedCity.children.length ? matchedCity.children[0].code : matchedCity.code];
  } else {
    return errorResult;
  }
}
/*********** 
 * formatAddressData 
 * _convertAddressNode 
 * setAddressPlacesHashMap 
 * 为常驻地及费控地址选择所需要的地址数据处理函数 
*************/


function formatAddressData(locationData, type) {
  var nodes = [];
  Object.keys(locationData).forEach(function (key) {
    type === 'expense' ? nodes.push(_convertAddressNode(locationData[key], key, placesHashMap)) : nodes.push(_convertAddressNode(locationData[key], key, bankPlacesHashMap));
  }); // if (type === 'expense') {
  //     locationNodes = nodes;
  // }

  return nodes;
}

function _convertAddressNode(source, countryType, placesHashMap) {
  var childrenProp = ['countries', 'provinces', 'cities', 'regions'];
  var prefix = ['country', 'province', 'city', 'region'];
  var children = null;

  for (var i = 0; i < childrenProp.length; i += 1) {
    var property = childrenProp[i];
    children = source[property];

    if (children) {
      source.children = source[property];
      break;
    }
  }

  var _loop = function _loop(j) {
    var p = prefix[j];

    if ((source.code === countryType || source[p + 'Code']) && children) {
      if (countryType === 'domestic') {
        _lodash.default.each(children, function (child) {
          child.code = source.code + '-' + child[prefix[j + 1] + 'Code'];
          child.name = child[prefix[j + 1] + 'Name'];
        });

        return "break";
      } else {
        _lodash.default.each(children, function (child) {
          if (source.code === countryType) {
            child.code = source.code + '-' + child[prefix[j] + 'Code'];
            child.name = child[prefix[j] + 'Name'];
          } else {
            child.code = source.code + '-' + child[prefix[j + 1] + 'Code'];
            child.name = child[prefix[j + 1] + 'Name'];
          }
        });

        return "break";
      }
    }
  };

  for (var j = 0; j < prefix.length; j += 1) {
    var _ret = _loop(j);

    if (_ret === "break") break;
  }

  setAddressPlacesHashMap(source, placesHashMap);

  if (children) {
    for (var k = 0; k < children.length; k += 1) {
      var child = children[k];

      _convertAddressNode(child, countryType, placesHashMap);
    }
  } else {
    placesHashMap[source.code].fuzzy = source.fuzzy;
    placesHashMap[source.code].isLeaf = true;
  }

  return source;
}

function setAddressPlacesHashMap(source, placesHashMap) {
  if (source.code) {
    placesHashMap[source.code] = {
      code: source.code,
      name: source.name,
      children: source.children,
      fuzzy: source.fuzzy
    };
  }
}

function isHidden(sourceData) {
  var hide = false; // INACTIVE 为不可见状态

  if (sourceData.status === 'INACTIVE') {
    hide = true;
  } // allowList 为该地址可见企业entCode
  // if (sourceData.allowList && !sourceData.allowList.includes(entCode)) {
  //     hide = true;
  // }
  // blockList 为该地址不可见企业entCode
  // if (sourceData.blockList && sourceData.blockList.includes(entCode)) {
  //     hide = true;
  // }


  return hide;
} // 过滤掉不符合可见性的地区


function filterPlaceData(locationDatas) {
  // const entCode = JSON.parse(window.localStorage.getItem('mkApp.personalInfo')).entCode;
  var _provinces = [];
  var _countries = [];
  locationDatas['domestic'].provinces.forEach(function (prov) {
    if (!isHidden(prov)) {
      _provinces.push(prov);
    }
  });

  _provinces.forEach(function (prov) {
    var _cities = [];
    prov.cities && prov.cities.forEach(function (city) {
      if (!isHidden(city)) {
        _cities.push(city);
      }
    });

    if (_cities.length) {
      prov.cities = _cities;
    }
  });

  _provinces.forEach(function (prov) {
    prov.cities && prov.cities.forEach(function (city) {
      var _regions = [];
      city.regions && city.regions.forEach(function (region) {
        if (!isHidden(region)) {
          _regions.push(region);
        }
      });

      if (_regions.length) {
        city.regions = _regions;
      }
    });
  });

  locationDatas['abroad'].countries.forEach(function (country) {
    if (!isHidden(country)) {
      _countries.push(country);
    }
  });

  _countries.forEach(function (country) {
    var _provinces = [];
    country.provinces && country.provinces.forEach(function (prov) {
      if (!isHidden(prov)) {
        _provinces.push(prov);
      }
    });

    if (_provinces.length) {
      country.provinces = _provinces;
    }
  });

  _countries.forEach(function (country) {
    country.provinces && country.provinces.forEach(function (prov) {
      var _cities = [];
      prov.cities && prov.cities.forEach(function (city) {
        if (!isHidden(city)) {
          _cities.push(city);
        }
      });

      if (_cities.length) {
        prov.cities = _cities;
      }
    });
  });

  _countries.forEach(function (country) {
    country.provinces && country.provinces.forEach(function (prov) {
      prov.cities && prov.cities.forEach(function (city) {
        var _regions = [];
        city.regions && city.regions.forEach(function (region) {
          if (!isHidden(region)) {
            _regions.push(region);
          }
        });

        if (_regions.length) {
          city.regions = _regions;
        }
      });
    });
  });

  return {
    domestic: _objectSpread(_objectSpread({}, locationDatas.domestic), {}, {
      provinces: _provinces
    }),
    abroad: _objectSpread(_objectSpread({}, locationDatas.abroad), {}, {
      countries: _countries
    })
  };
}

var _default = {
  hotCity: hotCity,
  formatPlaceData: formatPlaceData,
  getCityName: getCityName,
  getSimpleCityName: getSimpleCityName,
  getPlaceDataByCode: getPlaceDataByCode,
  getPlaceDataByCodes: getPlaceDataByCodes,
  getPlacesHashMap: getPlacesHashMap,
  getBankPlacesHashMap: getBankPlacesHashMap,
  getPlaceDataByFullCode: getPlaceDataByFullCode,
  getConsumeLocation: getConsumeLocation,
  getCurrentLocationData: getCurrentLocationData,
  formatAddressData: formatAddressData,
  filterPlaceData: filterPlaceData,
  formatPlaceDataZh: formatPlaceDataZh
};
exports.default = _default;