"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = removeTitle;

/**
* Removes the title from the tooltipped element, setting `data-original-title`
* appropriately
* @param {Element} el
*/
function removeTitle(el) {
  var title = el.getAttribute('title'); // Only set `data-original-title` attr if there is a title

  if (title) {
    el.setAttribute('data-original-title', title);
  }

  el.removeAttribute('title');
}