"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/tooltip/style/css");

var _tooltip = _interopRequireDefault(require("maycur-antd/lib/tooltip"));

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _hooks = require("./hooks");

var _this = void 0;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var TextArea = _input.default.TextArea;
var prefix = _utils.default.prefixCls;
var TransTextArea = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var _props$disabled = props.disabled,
      disabled = _props$disabled === void 0 ? false : _props$disabled,
      placeholder = props.placeholder,
      _props$autosize = props.autosize,
      autosize = _props$autosize === void 0 ? {
    minRows: 2,
    maxRows: 6
  } : _props$autosize,
      onFieldBlur = props.onFieldBlur;

  var _useFormChange = (0, _hooks.useFormChange)(props),
      _useFormChange2 = (0, _slicedToArray2.default)(_useFormChange, 2),
      value = _useFormChange2[0],
      _useFormChange2$ = _useFormChange2[1],
      setValue = _useFormChange2$.setValue,
      handleEvent = _useFormChange2$.handleEvent,
      handleChange = _useFormChange2$.handleChange;

  var inputRef = (0, _hooks.useInputRef)(ref);
  var initialProps = (0, _hooks.useInitialProps)(props);

  var _useLangModal = (0, _hooks.useLangModal)(_objectSpread(_objectSpread({}, props), {}, {
    setValue: setValue
  })),
      _useLangModal2 = (0, _slicedToArray2.default)(_useLangModal, 2),
      openModal = _useLangModal2[1].openModal;

  var _useTransInput = (0, _hooks.useTransInput)(props),
      _useTransInput2 = (0, _slicedToArray2.default)(_useTransInput, 1),
      showI18n = _useTransInput2[0];

  var t = (0, _hooks.useTranslate)('MK_TransInput');
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(TextArea, (0, _extends2.default)({
    ref: inputRef
  }, initialProps, {
    className: showI18n ? "".concat(prefix, "-trans-textarea") : '',
    autosize: autosize,
    value: value,
    disabled: disabled,
    placeholder: placeholder,
    onBlur: handleEvent.bind(_this, onFieldBlur),
    onChange: handleChange
  })), showI18n && /*#__PURE__*/_react.default.createElement(_tooltip.default, {
    placement: "top",
    title: t('多语言设置')
  }, /*#__PURE__*/_react.default.createElement(_icon.default, {
    className: "".concat(prefix, "-textarea-suffix"),
    type: "global",
    onClick: openModal.bind(_this, 'label', _this)
  })));
});
TransTextArea.displayName = 'TransTextArea';
TransTextArea.defaultProps = {
  i18n: false,
  modalManager: function modalManager() {}
};
var _default = TransTextArea;
exports.default = _default;