"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

var _useLocalStorageLang = _interopRequireDefault(require("./useLocalStorageLang"));

var _utils = require("../utils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var useFormChange = function useFormChange(_ref) {
  var data = _ref.data,
      identifier = _ref.identifier,
      onFieldsChange = _ref.onFieldsChange;

  var _useState = (0, _react.useState)(data === null || data === void 0 ? void 0 : data[identifier]),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var lang = (0, _useLocalStorageLang.default)();
  (0, _react.useEffect)(function () {
    setValue(function () {
      return data === null || data === void 0 ? void 0 : data[identifier];
    });
  }, [setValue, data, identifier]);
  var handleEvent = (0, _react.useCallback)(function (fn, e) {
    var _objectSpread2;

    if (typeof fn !== 'function') return;

    var params = _objectSpread(_objectSpread({}, data), {}, (_objectSpread2 = {}, (0, _defineProperty2.default)(_objectSpread2, identifier, e.target.value), (0, _defineProperty2.default)(_objectSpread2, "".concat(identifier).concat((0, _utils.toUpperCase)(lang)), e.target.value), _objectSpread2));

    var result = (0, _utils.getChangedFields)(params, identifier);
    fn(result, (0, _utils.formatChangedFields)(result));
  }, [data, identifier, lang]);
  var handleChange = (0, _react.useCallback)(function (e) {
    setValue(e.target.value);
    handleEvent(onFieldsChange, e);
  }, [setValue, handleEvent, onFieldsChange]);
  return [value, {
    setValue: setValue,
    handleEvent: handleEvent,
    handleChange: handleChange
  }];
};

var _default = useFormChange;
exports.default = _default;