"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/tree/style/css");

var _tree = _interopRequireDefault(require("maycur-antd/lib/tree"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var TreeNode = _tree.default.TreeNode;

var SelectableTree = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(SelectableTree, _Component);

  var _super = _createSuper(SelectableTree);

  function SelectableTree(props) {
    var _this;

    (0, _classCallCheck2.default)(this, SelectableTree);
    _this = _super.call(this, props);

    _this.setTreeDate = function (input, dataRef, pageSize) {
      _this.buildMap(input);

      if (_this.props.paging) {
        var showMore = input && input.length >= pageSize;
        dataRef.showMore = showMore;
        dataRef.loading = false;
      }

      if (_lodash.default.isArray(dataRef.children)) {
        dataRef.children = [].concat((0, _toConsumableArray2.default)(dataRef.children), (0, _toConsumableArray2.default)(input));
      } else {
        dataRef.children = input;
      }

      _this.setState({
        treeData: (0, _toConsumableArray2.default)(_this.state.treeData)
      });
    };

    _this.onLoadData = function (treeNode) {
      var _this$props = _this.props,
          fetchChildren = _this$props.fetchChildren,
          pageSize = _this$props.pageSize,
          dataSourceSync = _this$props.dataSourceSync;
      var dataRef = treeNode.props.dataRef;
      return new Promise(function (resolve, reject) {
        _this.props.paging && (dataRef.loading = true);

        if (dataRef.code === 'root') {
          if (typeof dataSourceSync === 'function') {
            dataSourceSync(_this.props.paging).then(function (input) {
              _this.setTreeDate(input, dataRef, pageSize);

              resolve();
            }).catch(function (error) {
              return reject();
            });
          }
        } else if (typeof fetchChildren === 'function') {
          fetchChildren(dataRef, _this.props.paging).then(function (children) {
            _this.setTreeDate(children, dataRef, pageSize);

            resolve();
          }).catch(function (error) {
            return reject();
          });
        } else {
          reject();
        }
      });
    };

    _this.buildMap = function (data) {
      var onBuildMap = _this.props.onBuildMap;

      if (typeof onBuildMap === 'function') {
        onBuildMap(data);
      }
    };

    _this.onCheck = function (checkedKeys, e) {
      var _this$props2 = _this.props,
          onChange = _this$props2.onChange,
          checkStrictly = _this$props2.checkStrictly;

      if (typeof onChange === 'function') {
        if (checkStrictly) {
          onChange(checkedKeys.checked);
        } else {
          onChange(checkedKeys);
        }
      }
    };

    _this.renderTreeNodes = function (nodes) {
      var renderItemExtra = _this.props.renderItemExtra;
      return _lodash.default.isArray(nodes) && nodes.length > 0 ? nodes.map(function (item) {
        var nodeClass = (0, _classnames.default)('node', {
          'disabled': item.enabled === false,
          'leaf': item._type === 'LEAF',
          'category': item._type === 'CATEGORY'
        });
        return /*#__PURE__*/_react.default.createElement(TreeNode, {
          blockNode: true,
          selectable: false,
          className: nodeClass,
          key: item.code,
          value: item.code,
          disableCheckbox: item.disableCheckbox,
          isLeaf: item._type === 'LEAF',
          dataRef: item,
          ref: function ref(_ref) {
            return item.ref = _ref;
          },
          title: item._type === 'LEAF' ? /*#__PURE__*/_react.default.createElement("span", {
            className: 'node-label'
          }, /*#__PURE__*/_react.default.createElement("span", {
            className: "fm fm-paper"
          }), item.name, typeof renderItemExtra === 'function' ? /*#__PURE__*/_react.default.createElement("span", null, renderItemExtra(item)) : null) : /*#__PURE__*/_react.default.createElement("span", {
            className: 'node-label'
          }, item._type === 'root' ? /*#__PURE__*/_react.default.createElement("span", {
            className: "fm fm-ordered-list"
          }) : /*#__PURE__*/_react.default.createElement("span", {
            className: "fm fm-folder-o"
          }), item.name)
        }, _lodash.default.isArray(item.children) && item.children.length > 0 ? _this.renderTreeNodes(item.children) : null, item.showMore && /*#__PURE__*/_react.default.createElement(TreeNode, {
          disableCheckbox: true,
          key: item.key,
          title: /*#__PURE__*/_react.default.createElement("div", {
            className: 'load-more',
            onClick: function onClick() {
              return _this.onLoadData(item.ref);
            }
          }, "\u52A0\u8F7D\u66F4\u591A", item.loading && /*#__PURE__*/_react.default.createElement(_icon.default, {
            type: "loading",
            style: {
              fontSize: 18
            },
            spin: true
          })),
          dataRef: item,
          isLeaf: true
        }));
      }) : null;
    };

    _this.state = {
      treeData: props.dataSource ? props.dataSource : null
    };
    return _this;
  }

  (0, _createClass2.default)(SelectableTree, [{
    key: "render",
    value: // UNSAFE_componentWillReceiveProps(nextProps) {
    //     if (!_.isEqual(nextProps.dataSource, this.props.dataSource) && nextProps.paging) {
    //         this.setState({ treeData: nextProps.dataSource });
    //     }
    // }
    function render() {
      var _this$props3 = this.props,
          checkedKeys = _this$props3.checkedKeys,
          checkStrictly = _this$props3.checkStrictly;
      var treeData = this.state.treeData;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-selectable-tree-view")
      }, treeData ? /*#__PURE__*/_react.default.createElement(_tree.default, {
        checkable: true,
        blockNode: true,
        defaultExpandedKeys: ['root'],
        checkStrictly: checkStrictly,
        checkedKeys: checkedKeys,
        loadData: this.onLoadData,
        onCheck: this.onCheck
      }, this.renderTreeNodes(treeData)) : 'loading tree');
    }
  }]);
  return SelectableTree;
}(_react.Component);

SelectableTree.defaultProps = {
  checkStrictly: true
};
var _default = SelectableTree;
exports.default = _default;