"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var ReactDOM = _interopRequireWildcard(require("react-dom"));

var _ViewerCore = _interopRequireDefault(require("./js/ViewerCore"));

var _LegacyCore = _interopRequireDefault(require("./js/LegacyCore"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = _interopRequireDefault(require("../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var Viewer = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(Viewer, _React$Component);

  var _super = _createSuper(Viewer);

  function Viewer(props) {
    var _this;

    (0, _classCallCheck2.default)(this, Viewer);
    _this = _super.call(this, props);
    _this.container = props.container ? props.container : null;
    _this.defaultContainer = document.createElement('div');
    _this.component = null;
    return _this;
  }

  (0, _createClass2.default)(Viewer, [{
    key: "renderViewer",
    value: function renderViewer() {
      if (!this.container) {
        if (this.props.container) {
          this.container = this.props.container;
        } else {
          this.container = this.defaultContainer;
          document.body.appendChild(this.container);
        }
      }
    }
  }, {
    key: "removeViewer",
    value: function removeViewer() {
      if (this.container) {
        var container = this.container;
        ReactDOM.unmountComponentAtNode(container);

        if (container.parentNode) {
          container.parentNode.removeChild(container);
        }

        this.container = null;
        this.component = null;
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.props.visible && this.props.onClose) {
        this.props.onClose();
      } // this.removeViewer();

    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (this.props.container !== nextProps.container) {
        this.component = null;

        if (nextProps.container) {
          if (this.container) {
            document.body.removeChild(this.container);
          }

          this.container = nextProps.container;
        } else {
          this.container = this.defaultContainer;
          document.body.appendChild(this.container);
        }
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.renderViewer();
    }
  }, {
    key: "render",
    value: function render() {
      var node;

      if (_utils.default.isWindows7() || _utils.default.getBrowserVersion() && _utils.default.getBrowserVersion() < 71) {
        node = this.container ? /*#__PURE__*/ReactDOM.createPortal( /*#__PURE__*/React.createElement(_LegacyCore.default, this.props), this.container) : null;
      } else {
        node = this.container ? /*#__PURE__*/ReactDOM.createPortal( /*#__PURE__*/React.createElement(_ViewerCore.default, this.props), this.container) : null;
      }

      return node;
    }
  }]);
  return Viewer;
}(React.Component);

exports.default = Viewer;
Viewer.propTypes = {
  type: _propTypes.default.oneOf(['img', 'ofd', 'pdf']) //type类型目前只支持三种 img ofd pdf 判断上传的发票文件格式

};