"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = require("react");

function useCrossPage() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$rowKey = _ref.rowKey,
      rowKey = _ref$rowKey === void 0 ? 'code' : _ref$rowKey,
      defaultSelectRows = _ref.defaultSelectRows,
      isRadio = _ref.isRadio;

  var selectRows = (0, _react.useRef)([]); // 选中行

  var _useState = (0, _react.useState)([]),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      selectRowKeys = _useState2[0],
      setSelectRowKeys = _useState2[1]; // 选中行的key


  var curPageKeys = (0, _react.useRef)([]); // 当前页的key
  // dataSource 发生改变重新存 curPageKeys

  var onDataSourceChange = (0, _react.useCallback)(function (dataSource) {
    if (isRadio) return;
    curPageKeys.current = dataSource.map(function (_ref2) {
      var key = _ref2[rowKey];
      return key;
    });
  }, [rowKey, isRadio]); // 当前选中发生改变

  var updateSelect = (0, _react.useCallback)(function (keys, rows) {
    if (!isRadio) {
      var _curKeys = curPageKeys.current;
      var _selectRows = selectRows.current;
      selectRows.current = [].concat((0, _toConsumableArray2.default)(_selectRows.filter(function (_ref3) {
        var key = _ref3[rowKey];
        return !_curKeys.includes(key);
      })), (0, _toConsumableArray2.default)(rows));
    } else selectRows.current = rows;

    setSelectRowKeys(keys);
  }, [rowKey, isRadio]);
  var onRowClick = (0, _react.useCallback)(function (record) {
    var _key = record[rowKey];
    var isIn = selectRowKeys.includes(_key);

    if (isRadio) {
      if (isIn) return;else {
        selectRows.current = [record];
        setSelectRowKeys([_key]);
      }
    } else {
      if (isIn) {
        selectRows.current = selectRows.current.filter(function (_ref4) {
          var key = _ref4[rowKey];
          return key !== _key;
        });
        setSelectRowKeys(function (_keys) {
          return _keys.filter(function (_k) {
            return _k !== _key;
          });
        });
      } else {
        selectRows.current.push(record);
        setSelectRowKeys(function (_keys) {
          return [].concat((0, _toConsumableArray2.default)(_keys), [_key]);
        });
      }
    }
  }, [rowKey, selectRowKeys, isRadio]); // 需要特殊过滤 filterFn 外部传入item是否需要过滤判断函数

  var filterSelectRows = (0, _react.useCallback)(function (filterFn) {
    var filterCodes = [];
    selectRows.current = selectRows.current.filter(function (item) {
      var needFilter = filterFn(item);
      if (needFilter) filterCodes.push(item[rowKey]);
      return !needFilter;
    });

    if (filterCodes.length) {
      setSelectRowKeys(function (_keys) {
        return _keys.filter(function (_k) {
          return !filterCodes.includes(_k);
        });
      });
    }
  }, [rowKey]);
  var crossPageData = (0, _react.useMemo)(function () {
    return {
      selectRows: selectRows.current,
      selectRowKeys: selectRowKeys,
      onDataSourceChange: onDataSourceChange,
      updateSelect: updateSelect,
      onRowClick: onRowClick,
      filterSelectRows: filterSelectRows
    };
  }, [selectRowKeys]); // eslint-disable-line
  // 只有初始化的时候调用

  (0, _react.useEffect)(function () {
    if (Array.isArray(defaultSelectRows)) {
      selectRows.current = defaultSelectRows; // 如果有初始选中行，处理默认 selectRowKeys

      var _selectRowKeys = defaultSelectRows.map(function (_ref5) {
        var key = _ref5[rowKey];
        return key;
      });

      setSelectRowKeys(_selectRowKeys);
    }
  }, []); // eslint-disable-line

  return crossPageData;
}

var _default = useCrossPage;
exports.default = _default;