"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2020-06-01 14:43:19
 * @LastEditors: Please set LastEditors
 * @LastEditTime: 2021-07-01 16:44:53
 */
function calculateSurplusAmount(_ref) {
  var value = _ref.value,
      record = _ref.record,
      totalAmount = _ref.totalAmount,
      _ref$targetKey = _ref.targetKey,
      targetKey = _ref$targetKey === void 0 ? 'allocationBase' : _ref$targetKey,
      _ref$key = _ref.key,
      key = _ref$key === void 0 ? 'key' : _ref$key;

  var valueExceptSelf = _lodash.default.filter(value, function (_value) {
    return _value[key] !== record[key];
  });

  var totalAmountExceptSelf = _lodash.default.sumBy(valueExceptSelf, function (value) {
    var _value$targetKey, _value$targetKey$amou;

    return ((_value$targetKey = value[targetKey]) === null || _value$targetKey === void 0 ? void 0 : (_value$targetKey$amou = _value$targetKey.amount) === null || _value$targetKey$amou === void 0 ? void 0 : _value$targetKey$amou.amount) || 0;
  }) || 0;
  var totalPercentExceptSelf = _lodash.default.sumBy(valueExceptSelf, function (value) {
    var _value$targetKey2;

    if (_lodash.default.isNumber(value[targetKey])) {
      // 分摊方案中会将承担比例存在allocationBase中
      return value[targetKey];
    }

    return ((_value$targetKey2 = value[targetKey]) === null || _value$targetKey2 === void 0 ? void 0 : _value$targetKey2.ratio) || 0;
  }) || 0;
  var surplusAmount = totalAmount && _lodash.default.round(totalAmount - totalAmountExceptSelf, 2) || 0;

  var surplusPercent = _lodash.default.round(100 - totalPercentExceptSelf, 2);

  return {
    surplusAmount: surplusAmount,
    surplusPercent: surplusPercent
  };
}

var _default = {
  calculateSurplusAmount: calculateSurplusAmount
};
exports.default = _default;