"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _lodash = _interopRequireDefault(require("lodash"));

var _windowOrGlobal = _interopRequireDefault(require("window-or-global"));

var _numeral = _interopRequireDefault(require("numeral"));

var _moment = _interopRequireDefault(require("moment"));

var _cookie = _interopRequireDefault(require("./cookie"));

var placesHashMap = {},
    bankPlacesHashMap = {},
    locationNodes = [];
var history = undefined;
var mobile = {
  isAndroid: function isAndroid() {
    return navigator.userAgent.match(/Android/i);
  },
  isBlackBerry: function isBlackBerry() {
    return navigator.userAgent.match(/BlackBerry/i);
  },
  isIOS: function isIOS() {
    return navigator.userAgent.match(/iPhone|iPad|iPod/i);
  },
  isOpera: function isOpera() {
    return navigator.userAgent.match(/Opera Mini/i);
  },
  isWindows: function isWindows() {
    return navigator.userAgent.match(/IEMobile/i);
  }
};
var prefixCls = 'mkbs'; // 预设热门城市
// 北京(ZH1_0_00)、上海(ZH4_0_00)、广州(ZH9_4_01)、深圳(ZH9_15_01)、杭州(ZH32_1_01)、
// 天津(ZH2_0_00)、成都(ZH28_3_01)、重庆(ZH33_0_00)、哈尔滨(ZH15_3_01)、南京(ZH19_4_01)
// 武汉(ZH16_9_01)、南昌(ZH20_6_01)、西安(ZH27_7_01)、合肥(ZH3_8_01)、长沙(ZH17_1_01)、
// 大连(ZH21_4_01)、石家庄(ZH13_8_01)、济南(ZH25_5_01)

var hotCity = ['ZH1_0_00', 'ZH4_0_00', 'ZH9_4_01', 'ZH9_15_01', 'ZH32_1_01', 'ZH2_0_00', 'ZH28_3_01', 'ZH33_0_00' // 'ZH15_3_01', 'ZH19_4_01',
// 'ZH16_9_01',
// 'ZH20_6_01', 'ZH27_7_01', 'ZH3_8_01', 'ZH17_1_01', 'ZH21_4_01', 'ZH13_8_01', 'ZH25_5_01'
]; //resetNumeral();
//设置numeral组件为floor模式

/*function resetNumeral() {
    numeral.fn._format = numeral.fn.format;
    numeral.fn.format = function (a, b) { return numeral.fn._format.call(this, a, b || numeral._.defaultRoundingFunction); };
    numeral._.defaultRoundingFunction = Math.round;
    numeral.setDefaultRoundingFunction = (fn) => { numeral._.defaultRoundingFunction = fn || numeral._.defaultRoundingFunction; }
    numeral.setDefaultRoundingFunction(Math.floor);
}*/

function formatPlaceData(locationData, type) {
  var nodes = [];
  Object.keys(locationData).forEach(function (key) {
    type === 'fee' ? nodes.push(_convertNode(locationData[key], key, placesHashMap)) : nodes.push(_convertNode(locationData[key], key, bankPlacesHashMap));
  });

  if (type === 'fee') {
    locationNodes = nodes;
  }

  return nodes;
}

function _convertNode(source, countryType, placesHashMap) {
  var childrenProp = ['countries', 'provinces', 'cities', 'regions'];
  var prefix = ['country', 'province', 'city', 'region'];
  var children = null;

  for (var i = 0; i < childrenProp.length; i += 1) {
    var property = childrenProp[i];
    children = source[property];

    if (children) {
      source.children = source[property];
      break;
    }
  }

  for (var j = 0; j < prefix.length; j += 1) {
    var p = prefix[j];

    if (source.code) {
      // source.code = source.code;
      // source.name = source.name;
      break;
    } else if (source[p + 'Code']) {
      source.code = source[p + 'Code'];
      source.name = source[p + 'Name'];
      break;
    }
  }

  setPlacesHashMap(source, countryType, placesHashMap);

  if (children) {
    for (var k = 0; k < children.length; k += 1) {
      var child = children[k];

      _convertNode(child, countryType, placesHashMap);
    }
  } else {
    placesHashMap[source.code].fuzzy = source.fuzzy;
    placesHashMap[source.code].isLeaf = true;
  }

  return source;
}

function getCityName(locationCode, type) {
  var locationName = '';

  if (locationCode) {
    var lastStrikethroughIndex = locationCode.lastIndexOf('-'),
        slashIndex,
        placeCode = locationCode.substr(lastStrikethroughIndex + 1),
        locationFullName,
        hashMap = type === 'fee' ? placesHashMap : bankPlacesHashMap;
    var place = hashMap[placeCode];

    if (place) {
      locationFullName = place.fullName;
      slashIndex = locationFullName.indexOf('/');
      locationName = locationFullName.substr(slashIndex + 1);
    }
  }

  return locationName;
}

function getSimpleCityName(locationCode, type) {
  type = type ? type : 'fee';
  var locationName = '';

  if (locationCode) {
    var lastStrikethroughIndex = locationCode.lastIndexOf('-'),
        placeCode = locationCode.substr(lastStrikethroughIndex + 1),
        hashMap = type === 'fee' ? placesHashMap : bankPlacesHashMap;
    var place = hashMap[placeCode];

    if (place) {
      locationName = place.name;
    }
  }

  return locationName;
}

function getPlaceDataByCode(code, type) {
  type = type || 'fee';

  if (type === 'fee') {
    return placesHashMap && placesHashMap[code];
  } else {
    return bankPlacesHashMap && bankPlacesHashMap[code];
  }
}

function getPlaceDataByCodes(codes, type) {
  type = type || 'fee';
  var places = [];

  _lodash.default.each(codes, function (code) {
    if (code) {
      if (type === 'fee') {
        places.push(placesHashMap[code]);
      } else {
        places.push(bankPlacesHashMap[code]);
      }
    }
  });

  return places;
}

function setPlacesHashMap(source, countryType, placesHashMap) {
  var fullName = '',
      fullCode = '';

  if (source.code) {
    placesHashMap[source.code] = {
      code: source.code,
      name: source.name,
      children: source.children
    };
    var lastIndex = source.code.lastIndexOf('_');

    if (lastIndex === -1) {
      if (source.code === countryType) {
        fullName = '';
        fullCode = source.code;
      } else {
        var countryFullName = placesHashMap[countryType].fullName,
            countryFullCode = placesHashMap[countryType].fullCode;
        fullName = countryFullName ? countryFullName + '-' + source.name : source.name;
        fullCode = countryFullCode ? countryFullCode + '-' + source.code : source.code;
      }
    } else {
      fullName = placesHashMap[source.code.substring(0, lastIndex)].fullName + '-' + source.name;
      fullCode = placesHashMap[source.code.substring(0, lastIndex)].fullCode + '-' + source.code;
    }

    placesHashMap[source.code].fullName = fullName;
    placesHashMap[source.code].fullCode = fullCode;
  }
}

function getPlacesHashMap() {
  return placesHashMap;
}

function getBankPlacesHashMap() {
  return bankPlacesHashMap;
} // 将定位到的地理位置转换为系统内的地址


function getCurrentLocationData(province, city, district) {
  var domestic = locationNodes[0];

  var filter = function filter(str) {
    var result = str.replace('市', '');
    result = result.replace('省', '');
    result = result.replace('县', '');
    result = result.replace('区', '');
    return result;
  };

  province = filter(province);
  city = filter(city);
  district = filter(district);

  for (var i in domestic.children) {
    var provinceNode = domestic.children[i];

    if (provinceNode.name.indexOf(province) >= 0) {
      for (var j in provinceNode.children) {
        var cityNode = provinceNode.children[j];

        if (cityNode.name.indexOf(city) >= 0) {
          for (var k in cityNode.children) {
            var districtNode = cityNode.children[k];

            if (districtNode.name.indexOf(district) >= 0) {
              return placesHashMap[districtNode.code];
            }
          }

          return placesHashMap[cityNode.children[0].code];
        }
      }
    }
  }

  return {
    code: 'error',
    name: '定位出错'
  };
}
/* 多余字段替换为...方法 */


function extractText(_ref) {
  var maxWidth = _ref.maxWidth,
      text = _ref.text,
      replaceText = _ref.replaceText;
  var replaceString = replaceText ? replaceText : '…';

  if (text && maxWidth && text.length > maxWidth) {
    return text.substr(0, maxWidth) + replaceString;
  } else {
    return text;
  }
}
/* 获取url参数 */


function getUrlArgs(name) {
  var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");

  var r = _windowOrGlobal.default.location.search.substr(1).match(reg);

  if (r != null) return unescape(r[2]);
  return null;
}

function hashCode(str) {
  str = str || '';

  if (Array.prototype.reduce) {
    return str.split('').reduce(function (a, b) {
      a = (a << 5) - a + b.charCodeAt(0);
      return a & a;
    }, 0);
  }

  var hash = 0;
  if (str.length === 0) return hash;

  for (var i = 0; i < str.length; i++) {
    var character = str.charCodeAt(i);
    hash = (hash << 5) - hash + character;
    hash = hash & hash; // Convert to 32bit integer
  }

  return hash;
}

function setHistory(parameter) {
  history = parameter;
}
/* 银行卡显示 */


function bankCardNumDisplay(bankCardCode) {
  return bankCardCode.substring(0, 4) + ' **** **** ' + bankCardCode.substr(-4);
}

var ScrollHandle = function ScrollHandle() {
  var _this = this;

  (0, _classCallCheck2.default)(this, ScrollHandle);
  var keys = {
    37: 1,
    38: 1,
    39: 1,
    40: 1
  };

  var preventDefault = function preventDefault(e) {
    e = e || _windowOrGlobal.default.event;
    if (e.preventDefault) e.preventDefault();
    e.returnValue = false;
  };

  var preventDefaultForScrollKeys = function preventDefaultForScrollKeys(e) {
    if (keys[e.keyCode]) {
      _this.preventDefault(e);

      return false;
    }
  };

  this.disableScroll = function () {
    if (_windowOrGlobal.default.addEventListener) // older FF
      _windowOrGlobal.default.addEventListener('DOMMouseScroll', preventDefault, false);
    _windowOrGlobal.default.onwheel = preventDefault; // modern standard

    _windowOrGlobal.default.onmousewheel = document.onmousewheel = preventDefault; // older browsers, IE

    _windowOrGlobal.default.ontouchmove = preventDefault; // mobile

    document.onkeydown = preventDefaultForScrollKeys;
  };

  this.enableScroll = function () {
    if (_windowOrGlobal.default.removeEventListener) _windowOrGlobal.default.removeEventListener('DOMMouseScroll', preventDefault, false);
    _windowOrGlobal.default.onmousewheel = document.onmousewheel = null;
    _windowOrGlobal.default.onwheel = null;
    _windowOrGlobal.default.ontouchmove = null;
    document.onkeydown = null;
  };
};

function getFileType(name) {
  if (name) {
    return name.slice(name.lastIndexOf('.') + 1).toLowerCase();
  }

  return '';
}

function getFileSize(size) {
  if (size) {
    if (size / 1024 / 1024 >= 1) {
      return parseFloat(size / 1024 / 1024).toFixed(2) + 'M';
    }

    if (size / 1024 >= 1) {
      return parseFloat(size / 1024).toFixed(2) + 'KB';
    } else {
      return size + 'B';
    }
  }

  return null;
}

function isImage(name) {
  var type = getFileType(name);
  var imgRegex = /^jpg|png|jpeg|bmp|gif+$/;
  return imgRegex.test(type);
}

function isZip(name) {
  var type = getFileType(name);
  var zipRegex = /^zip|rar+$/;
  return zipRegex.test(type);
}

function makeId() {
  var text = "";
  var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

  for (var i = 0; i < 5; i++) {
    text += possible.charAt(Math.floor(Math.random() * possible.length));
  }

  return text;
}

function getUUID() {
  var d = new Date().getTime();

  if (_windowOrGlobal.default.performance && typeof _windowOrGlobal.default.performance.now === "function") {
    d += performance.now(); //use high-precision timer if available
  }

  var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = (d + Math.random() * 16) % 16 | 0;
    d = Math.floor(d / 16);
    return (c === 'x' ? r : r & 0x3 | 0x8).toString(16);
  });
  return uuid;
}

function formatCurrency(value) {
  var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '0,0.00';
  var symbol = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '￥';
  return symbol + (0, _numeral.default)(value).format(format);
}

function handleCurrencyOperation(currencyCode) {
  var currencyCache = _cookie.default.get('latestCurrencys') || [];

  if (!currencyCache.includes(currencyCode)) {
    if (currencyCache && currencyCache.length >= 5) {
      currencyCache.shift();
    }

    currencyCache.push(currencyCode);

    _cookie.default.set('latestCurrencys', currencyCache);
  }
}

function removeLoadPage() {
  var loadPage = document.getElementById('load-page');
  /* 移除load page */

  if (loadPage) {
    loadPage.remove(1);
  }
}

function getLocationOrigin() {
  if (_windowOrGlobal.default.location.hostname === 'localhost') {
    return '*';
  } else {
    return _windowOrGlobal.default.location.origin;
  }
}

function apiOK(data) {
  return data && data.code === 'ACK';
}

function isEmpty(str) {
  if (typeof str === 'string') {
    str = str.trim();
    return str === "";
  } else {
    console.warn('not validate type');
  }
}

function generateRows(formFields) {
  var weight = 0;
  var rowChild = [];
  var rows = [];

  _lodash.default.forEach(formFields, function (field, index) {
    if (!field.property.isFieldHide) {
      var _ref2 = field.property || {},
          _ref2$webSize = _ref2.webSize,
          webSize = _ref2$webSize === void 0 ? 0.5 : _ref2$webSize;

      var fieldWeight = webSize === 0.5 ? 1 : 2;

      if (fieldWeight === 2 && weight % 2 !== 0) {
        /* 当出现100%占行的时候，前面累积的field都必须成行 */
        rows.push({
          fieldList: rowChild
        });
        rowChild = [];
        weight += 1;
      }

      rowChild.push(field);
      weight += fieldWeight;
    }

    if ((weight % 2 === 0 || index === formFields.length - 1) && rowChild.length > 0) {
      /* 当权重为模2为0或者是最后一个field元素的时候 */
      rows.push({
        fieldList: rowChild
      });
      rowChild = [];
    }
  });

  return rows;
}

function getAbbrName(name) {
  var chineseReg = new RegExp("[\u4E00-\uFA29\uE7C7-\uE7F3]+", 'g');
  var wordReg = new RegExp('[A-Za-z]{1,4}');
  var result = '';
  var m = (name || '').match(chineseReg);

  if (m && m.length !== 0) {
    result = m[0];

    if (result && result.length > 2) {
      result = result.substring(result.length - 2, result.length);
    }
  }

  if (!result) {
    m = (name || '').match(wordReg);

    if (m && m.length !== 0) {
      result = m[0];
    }
  }

  if (!result && name) {
    result = name.substr(0, 1);
  }

  return result;
}

function getAvatarClass(name) {
  var colors = ['c1', 'c2', 'c3', 'c4', 'c5', 'c6', 'c7', 'c8', 'c9', 'c10', 'c11', 'c12', 'c13', 'c14', 'c15', 'c16'];
  var idx = Math.abs(hashCode(name)) % colors.length;
  return colors[idx];
}

var bizEquals = function bizEquals(o1, o2) {
  return o1.code === o2.code;
};

var formatBankAcctNumber = function formatBankAcctNumber(str) {
  return str && str.replace(/(\d{4})/g, '$1 ').replace(/\s*$/, '');
};

var getConsumeLocation = function getConsumeLocation(value) {
  var pairValue = value && value.cityPair;
  var showPairValue = '';

  if (pairValue) {
    showPairValue += pairValue.departure && getSimpleCityName(pairValue.departure, 'fee') || '无';
    showPairValue += ' ~ ' + (pairValue.destination && getSimpleCityName(pairValue.destination, 'fee') || '无');
  }

  return showPairValue ? showPairValue : getSimpleCityName(value && value.location, 'fee');
};

var getConsumeTime = function getConsumeTime(value) {
  var pairValue = value && value.timeRange;
  var showPairValue = '';

  if (pairValue) {
    showPairValue += pairValue.startDate && (0, _moment.default)(pairValue.startDate).format('YYYY/MM/DD') || '无';
    showPairValue += ' ~ ' + (pairValue.endDate && (0, _moment.default)(pairValue.endDate).format('YYYY/MM/DD') || '无');
  }

  return showPairValue ? showPairValue : (0, _moment.default)(value.currentTime).format('YYYY/MM/DD');
};

var emailMosaic = function emailMosaic() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var reg = /(\S{0,3})\S*(@\S)/;
  return str.replace(reg, '$1***$2');
};

var mobileMosaic = function mobileMosaic() {
  var str = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var reg = /(\d{3})\d*(\d{2})/;
  return str.replace(reg, '$1******$2');
};

var isEmail = function isEmail(str) {
  var pattern = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
  return pattern.test(str);
};

function asyncForEach() {
  return _asyncForEach.apply(this, arguments);
}

function _asyncForEach() {
  _asyncForEach = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
    var array,
        callback,
        index,
        _args = arguments;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            array = _args.length > 0 && _args[0] !== undefined ? _args[0] : [];
            callback = _args.length > 1 ? _args[1] : undefined;

            if (array) {
              _context.next = 4;
              break;
            }

            return _context.abrupt("return");

          case 4:
            index = 0;

          case 5:
            if (!(index < array.length)) {
              _context.next = 11;
              break;
            }

            _context.next = 8;
            return callback(array[index], index, array);

          case 8:
            index++;
            _context.next = 5;
            break;

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _asyncForEach.apply(this, arguments);
}

function dateRemoveTime(d) {
  return d.setHours(0, 0, 0, 0);
}

function isDeskTop() {
  var check = false;

  (function (a) {
    if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(a) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4))) check = true;
  })(navigator.userAgent || navigator.vendor || _windowOrGlobal.default.opera);

  return !check;
}

;

function formatAddressData(locationData, type) {
  var nodes = [];
  Object.keys(locationData).forEach(function (key) {
    type === 'expense' ? nodes.push(_convertAddressNode(locationData[key], key, placesHashMap)) : nodes.push(_convertAddressNode(locationData[key], key, bankPlacesHashMap));
  });

  if (type === 'expense') {
    locationNodes = nodes;
  }

  return nodes;
}

function _convertAddressNode(source, countryType, placesHashMap) {
  var childrenProp = ['countries', 'provinces', 'cities', 'regions'];
  var prefix = ['country', 'province', 'city', 'region'];
  var children = null;

  for (var i = 0; i < childrenProp.length; i += 1) {
    var property = childrenProp[i];
    children = source[property];

    if (children) {
      source.children = source[property];
      break;
    }
  }

  var _loop = function _loop(j) {
    var p = prefix[j];

    if ((source.code === countryType || source[p + 'Code']) && children) {
      if (countryType === 'domestic') {
        _lodash.default.each(children, function (child) {
          child.code = source.code + '-' + child[prefix[j + 1] + 'Code'];
          child.name = child[prefix[j + 1] + 'Name'];
        });

        return "break";
      } else {
        _lodash.default.each(children, function (child) {
          if (source.code === countryType) {
            child.code = source.code + '-' + child[prefix[j] + 'Code'];
            child.name = child[prefix[j] + 'Name'];
          } else {
            child.code = source.code + '-' + child[prefix[j + 1] + 'Code'];
            child.name = child[prefix[j + 1] + 'Name'];
          }
        });

        return "break";
      }
    }
  };

  for (var j = 0; j < prefix.length; j += 1) {
    var _ret = _loop(j);

    if (_ret === "break") break;
  }

  setAddressPlacesHashMap(source, placesHashMap);

  if (children) {
    for (var k = 0; k < children.length; k += 1) {
      var child = children[k];

      _convertAddressNode(child, countryType, placesHashMap);
    }
  } else {
    placesHashMap[source.code].fuzzy = source.fuzzy;
    placesHashMap[source.code].isLeaf = true;
  }

  return source;
}

function setAddressPlacesHashMap(source, placesHashMap) {
  if (source.code) {
    placesHashMap[source.code] = {
      code: source.code,
      name: source.name,
      children: source.children,
      fuzzy: source.fuzzy
    };
  }
}

var isRecycle = function isRecycle(arr, triggerCollection) {
  var nodeMap = {},
      keyName = "field",
      referKeyName = "referFields",
      result = false;

  var twig = function twig(node, topNodeNames) {
    if (node && Array.isArray(node[referKeyName]) && node[referKeyName].length > 0) {
      // 循环该节点的依赖项
      for (var i = 0; i < node[referKeyName].length; i++) {
        var item = node[referKeyName][i];

        if (nodeMap[item]) {
          // 该依赖的节点已经在上层，说明出现循环依赖了
          if (topNodeNames.includes(item)) {
            result = true;
            break;
          } else {
            twig(nodeMap[item], [].concat((0, _toConsumableArray2.default)(topNodeNames), [item]));
          }
        }
      }
    }
  };

  var makeTree = function makeTree(arr) {
    if (Array.isArray(arr) && arr.length > 0) {
      arr.forEach(function (ele) {
        // nodeMap[ele[keyName]] = ele;
        if (Array.isArray(ele[referKeyName]) && ele[referKeyName].length > 0) {
          ele[referKeyName].forEach(function (item) {
            if (nodeMap[item]) {
              nodeMap[item] = (0, _defineProperty2.default)({}, referKeyName, [].concat((0, _toConsumableArray2.default)(nodeMap[item][referKeyName]), [ele[keyName]]));
            } else {
              nodeMap[item] = (0, _defineProperty2.default)({}, referKeyName, [ele[keyName]]);
            }
          });
        }
      });

      if (triggerCollection) {
        triggerCollection.forEach(function (ele) {
          // 访问它的依赖节点
          twig(nodeMap[ele], [ele]);
        });
      } else {
        arr.forEach(function (ele) {
          if (!nodeMap[ele[keyName]].slashed) {
            // 标记该节点已经被访问过（修剪过）了
            nodeMap[ele[keyName]].slashed = true; // 访问它的依赖节点

            twig(nodeMap[ele[keyName]], [ele[keyName]]);
          }
        });
      }
    }
  };

  makeTree(arr);
  return result;
};

function escapeRegExp(string) {
  return string.replace(/[.*+\-?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
} //自定义筛选项排序，默认的放第一个


function sortList(list) {
  var result = [];
  var defalutItem = null;

  _lodash.default.forEach(list, function (item) {
    if (item.isDefault) {
      defalutItem = item;
    } else {
      result.push(item);
    }
  });

  if (defalutItem) {
    result.unshift(defalutItem);
  }

  return result;
}

function getBrowserVersion() {
  var arr = navigator.userAgent.split(' ');
  var version = '';

  for (var i = 0; i < arr.length; i++) {
    if (/chrome/i.test(arr[i])) version = arr[i];
  }

  if (version) {
    return Number(version.split('/')[1].split('.')[0]);
  } else {
    return false;
  }
}

function isWindows7() {
  var version = navigator.userAgent;
  return version.includes('Windows NT 7');
}

var _default = {
  prefixCls: prefixCls,
  hotCity: hotCity,
  getCityName: getCityName,
  getSimpleCityName: getSimpleCityName,
  formatPlaceData: formatPlaceData,
  getPlaceDataByCode: getPlaceDataByCode,
  getPlaceDataByCodes: getPlaceDataByCodes,
  getPlacesHashMap: getPlacesHashMap,
  getBankPlacesHashMap: getBankPlacesHashMap,
  extractText: extractText,
  getUrlArgs: getUrlArgs,
  hashCode: hashCode,
  setHistory: setHistory,
  history: history,
  bankCardNumDisplay: bankCardNumDisplay,
  getCurrentLocationData: getCurrentLocationData,
  ScrollHandle: ScrollHandle,
  getFileType: getFileType,
  getFileSize: getFileSize,
  isImage: isImage,
  isZip: isZip,
  mobile: mobile,
  makeId: makeId,
  getUUID: getUUID,
  formatCurrency: formatCurrency,
  handleCurrencyOperation: handleCurrencyOperation,
  removeLoadPage: removeLoadPage,
  getLocationOrigin: getLocationOrigin,
  apiOK: apiOK,
  isEmpty: isEmpty,
  generateRows: generateRows,
  getAbbrName: getAbbrName,
  getAvatarClass: getAvatarClass,
  bizEquals: bizEquals,
  formatBankAcctNumber: formatBankAcctNumber,
  getConsumeLocation: getConsumeLocation,
  getConsumeTime: getConsumeTime,
  emailMosaic: emailMosaic,
  mobileMosaic: mobileMosaic,
  isEmail: isEmail,
  asyncForEach: asyncForEach,
  dateRemoveTime: dateRemoveTime,
  isDeskTop: isDeskTop,
  formatAddressData: formatAddressData,
  isRecycle: isRecycle,
  escapeRegExp: escapeRegExp,
  sortList: sortList,
  getBrowserVersion: getBrowserVersion,
  isWindows7: isWindows7,
  noop: function noop() {}
};
exports.default = _default;