"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _Toast = _interopRequireDefault(require("./Toast"));

function createNotification() {
  var div = document.createElement("div");
  document.body.appendChild(div);

  var notification = _reactDom.default.render( /*#__PURE__*/_react.default.createElement(_Toast.default, null), div);

  return {
    addNotice: function addNotice(notice) {
      return notification.addNotice(notice);
    },
    destroy: function destroy() {
      _reactDom.default.unmountComponentAtNode(div);

      document.body.removeChild(div);
    }
  };
}

var notification;

var notice = function notice(type, content) {
  var duration = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 2000;
  var onClose = arguments.length > 3 ? arguments[3] : undefined;
  if (!notification) notification = createNotification();
  return notification.addNotice({
    type: type,
    content: content,
    duration: duration,
    onClose: onClose
  });
};

var _default = {
  info: function info(content, duration, onClose) {
    return notice("info", content, duration, onClose);
  }
};
exports.default = _default;