"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _conditionTree = _interopRequireDefault(require("./conditionTree"));

var _conditionForm = _interopRequireDefault(require("./conditionForm"));

var C = _interopRequireWildcard(require("./constants"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var _lodash = _interopRequireDefault(require("lodash"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

var _classnames = _interopRequireDefault(require("classnames"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var View = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(View, _Component);

  var _super = _createSuper(View);

  function View(props) {
    var _this;

    (0, _classCallCheck2.default)(this, View);
    _this = _super.call(this, props);

    _this.onAddParentNode = function () {
      var _this$state = _this.state,
          selectedNodeId = _this$state.selectedNodeId,
          treeMap = _this$state.treeMap;
      if (!_this.isParentNode(selectedNodeId)) return;
      var node = {
        code: _utils.default.getUUID(),
        opType: '',
        conditionType: C.FORM_RELATION,
        children: [],
        active: true,
        selected: true
      }; //更新树结构

      var nodeInCdtData = _this.findNodeData(_this.cdtData, selectedNodeId, 'GET_NODE', _this.cdtData),
          children = nodeInCdtData.children || [];

      children.push({
        code: node.code,
        children: []
      }); //更新节点详情map和选中节点

      _this.setState({
        treeMap: _objectSpread(_objectSpread({}, treeMap), {}, (0, _defineProperty2.default)({}, node.code, node)),
        selectedNodeId: node.code
      });
    };

    _this.onAddChildNode = function (conditionSource) {
      var _this$state2 = _this.state,
          selectedNodeId = _this$state2.selectedNodeId,
          treeMap = _this$state2.treeMap;
      if (!selectedNodeId) return;
      var selectedNode = treeMap[selectedNodeId] || {},
          nodeInCdtData = null;

      if (selectedNode.conditionType !== C.FORM_RELATION) {
        nodeInCdtData = _this.findNodeData(_this.cdtData, selectedNodeId, 'GET_PARENT', _this.cdtData);
      } else {
        nodeInCdtData = _this.findNodeData(_this.cdtData, selectedNodeId, 'GET_NODE', _this.cdtData);

        if (!nodeInCdtData.children) {
          nodeInCdtData.children = [];
        }

        nodeInCdtData = nodeInCdtData.children;
      }

      var node = {
        code: _utils.default.getUUID(),
        conditionType: C.FORM_EXPRESSION,
        selected: true,
        conditionSource: conditionSource
      }; //更新树结构

      nodeInCdtData && nodeInCdtData.push({
        code: node.code
      }); //更新节点详情map和选中节点

      _this.setState({
        treeMap: _objectSpread(_objectSpread({}, treeMap), {}, (0, _defineProperty2.default)({}, node.code, node)),
        selectedNodeId: node.code
      });
    };

    _this.onDeleteNode = function (code) {
      var _this$state3 = _this.state,
          selectedNodeId = _this$state3.selectedNodeId,
          treeMap = _this$state3.treeMap,
          treeMapCopy = _objectSpread({}, treeMap);

      _this.findNodeData(_this.cdtData, code, 'DELETE_NODE', _this.cdtData);

      var selectedNode = _this.findNodeData(_this.cdtData, selectedNodeId, 'GET_NODE', _this.cdtData); //选中节点为删除的节点或删除的节点的子节点


      if (!selectedNode) {
        _this.setState({
          selectedNodeId: _this.cdtData.code
        });
      }

      delete treeMapCopy[code];

      _this.setState({
        treeMap: treeMapCopy
      });
    };

    _this.onSelectNode = function (node) {
      _this.setState({
        selectedNodeId: node.code
      });
    };

    _this.onToggleNode = function (node, toggle) {
      var treeMap = _this.state.treeMap;

      _this.setState({
        treeMap: _objectSpread(_objectSpread({}, treeMap), {}, (0, _defineProperty2.default)({}, node.code, _objectSpread(_objectSpread({}, treeMap[node.code]), {}, {
          active: toggle
        })))
      });
    };

    _this.onFormTypeChange = function (value) {
      var extra = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var _this$state4 = _this.state,
          selectedNodeId = _this$state4.selectedNodeId,
          treeMap = _this$state4.treeMap;
      var data = {};

      if (treeMap[selectedNodeId].conditionSource === 'CUSTOM') {
        data.key = value;
        data.field = extra === null || extra === void 0 ? void 0 : extra.type;
      } else {
        data.field = value;
      }

      _this.setState({
        treeMap: _objectSpread(_objectSpread({}, treeMap), {}, (0, _defineProperty2.default)({}, selectedNodeId, _objectSpread(_objectSpread({
          // ...treeMap[selectedNodeId],
          code: selectedNodeId,
          conditionType: treeMap[selectedNodeId].conditionType,
          conditionSource: treeMap[selectedNodeId].conditionSource,
          formCategory: extra === null || extra === void 0 ? void 0 : extra.formCategory
        }, data), {}, {
          opType: '',
          value1: '',
          value2: '',
          temp: {
            fieldConfig: extra
          }
        })))
      });
    };

    _this.onFieldChange = function (value, key) {
      var _this$state5 = _this.state,
          selectedNodeId = _this$state5.selectedNodeId,
          treeMap = _this$state5.treeMap;

      _this.setState({
        treeMap: _objectSpread(_objectSpread({}, treeMap), {}, (0, _defineProperty2.default)({}, selectedNodeId, _objectSpread(_objectSpread({}, treeMap[selectedNodeId]), {}, (0, _defineProperty2.default)({}, key, value))))
      });
    };

    _this.handleTempChange = function (list, field) {
      var _objectSpread9;

      var key = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'value1';
      var _this$state6 = _this.state,
          selectedNodeId = _this$state6.selectedNodeId,
          treeMap = _this$state6.treeMap;
      var value = list.map(function (d) {
        return d[field];
      }).join(',');

      _this.setState({
        treeMap: _objectSpread(_objectSpread({}, treeMap), {}, (0, _defineProperty2.default)({}, selectedNodeId, _objectSpread(_objectSpread({}, treeMap[selectedNodeId]), {}, (_objectSpread9 = {}, (0, _defineProperty2.default)(_objectSpread9, key, value), (0, _defineProperty2.default)(_objectSpread9, "temp", _objectSpread(_objectSpread({}, treeMap[selectedNodeId]['temp']), {}, (0, _defineProperty2.default)({}, key, list || []))), _objectSpread9))))
      });
    };

    _this.formatData = function (data) {
      var i;
      if (!data) return;
      Object.assign(data, data.children ? _objectSpread(_objectSpread({}, _this.state.treeMap[data.code]), {}, {
        children: data.children
      }) : _objectSpread({}, _this.state.treeMap[data.code]));
      var children = data.children || [];

      for (i = 0; i < children.length; i++) {
        _this.formatData(children[i]);
      }
    };

    _this.getData = function () {
      var error = _this.validata();

      var cdtDataCopy = _lodash.default.cloneDeep(_this.cdtData);

      _this.formatData(cdtDataCopy);

      return {
        error: error,
        value: cdtDataCopy
      };
    };

    _this.state = {
      selected: {},
      selectedNodeId: '',
      treeMap: {}
    };
    _this.cdtData = null;
    _this.t = _mkTranslate.default.getLocalNs('MK_ConditionSetting', (0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(View, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props = this.props,
          conditionGroupCode = _this$props.conditionGroupCode,
          onAfterMount = _this$props.onAfterMount,
          conditionData = _this$props.conditionData,
          apis = _this$props.apis;
      var initConditon = {
        name: '未命名节点',
        code: '1',
        opType: C.AND,
        conditionType: C.FORM_RELATION,
        children: [],
        active: true,
        selected: true,
        isRoot: true
      };
      this.treeMap = {};

      if (conditionGroupCode) {
        //编辑数据 请求初始数据

        /* api.getCondition(conditionGroupCode).then((resp) => {
            if (resp.code === 'ACK') {
                const data = resp?.data?.condition;
                data.isRoot = true;
                this.resolveData(data);
                this.cdtData = data;
                this.setState({
                    selectedNodeId: data.code,
                    treeMap: this.treeMap
                })
            }
        }) */
        apis.fetchConditionDetail(conditionGroupCode).then(function (resp) {
          if (resp.code === 'ACK') {
            var _resp$data;

            var data = resp === null || resp === void 0 ? void 0 : (_resp$data = resp.data) === null || _resp$data === void 0 ? void 0 : _resp$data.condition;
            data.isRoot = true;

            _this2.resolveData(data);

            _this2.cdtData = data;

            _this2.setState({
              selectedNodeId: data.code,
              treeMap: _this2.treeMap
            });
          }
        });
      } else if (conditionData) {
        this.resolveData(conditionData);
        this.cdtData = conditionData;
        this.setState({
          selectedNodeId: conditionData.code,
          treeMap: this.treeMap
        });
      } else {
        this.cdtData = initConditon;
        this.setState({
          selectedNodeId: initConditon.code,
          treeMap: (0, _defineProperty2.default)({}, initConditon.code, initConditon)
        });
      }

      if (onAfterMount && typeof onAfterMount === 'function') {
        onAfterMount();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var conditionData = this.props.conditionData;

      if (conditionData !== prevProps.conditionData) {
        this.resolveData(conditionData);
        this.cdtData = conditionData;
        this.setState({
          selectedNodeId: conditionData.code,
          treeMap: this.treeMap
        });
      }
    }
  }, {
    key: "resolveData",
    value: function resolveData(data) {
      var i;
      if (!data) return;

      if (data.conditionType === 'RELATION') {
        data.active = true;
      }

      this.treeMap[data.code] = _objectSpread(_objectSpread({}, data), {}, {
        children: null
      });
      var children = data.children || [];

      for (i = 0; i < children.length; i++) {
        this.resolveData(children[i]);
      }
    }
  }, {
    key: "findNodeData",
    value: function findNodeData(root, code, action, parent) {
      var result, i;
      if (!root) return false;

      if (root.code === code) {
        if (action === 'GET_PARENT') {
          return parent;
        } else if (action === 'GET_NODE') {
          return root;
        } else if (action === 'DELETE_NODE') {
          _lodash.default.remove(parent, function (d) {
            return d.code === code;
          });
        }
      } else {
        var children = root.children || [];

        for (i = 0; i < children.length; i++) {
          result = this.findNodeData(children[i], code, action, children);

          if (result) {
            return result;
          }
        }

        return false;
      }
    }
  }, {
    key: "isParentNode",
    value: function isParentNode(nodeId) {
      var treeMap = this.state.treeMap;
      return nodeId && treeMap[nodeId].conditionType === C.FORM_RELATION;
    }
  }, {
    key: "emptySelectedField",
    value: function emptySelectedField(code) {
      var treeMap = this.state.treeMap;
      this.setState({
        treeMap: _objectSpread(_objectSpread({}, treeMap), {}, (0, _defineProperty2.default)({}, code, _objectSpread(_objectSpread({}, treeMap[code]), {}, {
          opType: '',
          value1: '',
          temp: ''
        })))
      });
    }
  }, {
    key: "validata",
    value: function validata() {
      var _this3 = this;

      var treeMap = this.state.treeMap;
      var isValid = true; //只有在树里面存在的节点才会做校验，过滤出树里面的节点

      _lodash.default.forEach(treeMap, function (value, key) {
        var node = _this3.findNodeData(_this3.cdtData, key, 'GET_NODE', _this3.cdtData);

        if (!node) {
          delete treeMap[key];
        }
      });

      if (Object.keys(treeMap).length === 1) {
        isValid = false;
      }

      for (var key in treeMap) {
        var node = this.findNodeData(this.cdtData, key, 'GET_NODE', this.cdtData); //只有在树里面存在的节点才会做校验

        if (node) {
          var item = treeMap[key];

          if (item.conditionType === 'EXPRESSION') {
            if (item.opType === 'IS_EMPTY') {
              isValid = true;
              return;
            } //“批准金额是否等于消费金额”这个条件没有value1


            if (item.field === 'APPROVED_AMOUNT_COMPARE_APPLY_AMOUNT' || item.field === 'EXISTED_EXTERNAL_VALIDATION_RESULT' || item.field === 'IS_COVER_DEPARTMENT_PRINCIPLE') {
              if (!item.opType) {
                isValid = false;
                break;
              }
            } else if (!item.opType || !item.value1) {
              isValid = false;
              break;
            }

            if (item.field === 'SINGLE_EXPENSE_TYPE_MAX_AMOUNT' || item.field === 'AGGREGATED_EXPENSE_TYPE_AMOUNT' || item.field === 'BUDGET_OCCUPY_PERCENT') {
              if (!item.value2) {
                isValid = false;
                break;
              }
            }
          } else if (item.conditionType === 'RELATION') {
            if (!item.opType) {
              isValid = false;
              break;
            }
          }
        }
      }

      if (!isValid) return this.t('conditionNotComplete');
      return null;
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
          _this4 = this;

      var _this$state7 = this.state,
          treeMap = _this$state7.treeMap,
          selectedNodeId = _this$state7.selectedNodeId,
          _this$props2 = this.props,
          entrance = _this$props2.entrance,
          mode = _this$props2.mode,
          initData = _this$props2.initData,
          conditionOptions = _this$props2.conditionOptions,
          apis = _this$props2.apis,
          ModalManager = _this$props2.ModalManager,
          extraFormMap = _this$props2.extraFormMap,
          conditionBuilder = _this$props2.conditionBuilder,
          hideCustom = _this$props2.hideCustom,
          selectedNode = treeMap[selectedNodeId] || [];
      var wrapClass = (0, _classnames.default)((_classNames = {}, (0, _defineProperty2.default)(_classNames, "".concat(prefix, "-config-wrap"), true), (0, _defineProperty2.default)(_classNames, "preview-mode", mode === 'PREVIEW'), _classNames));
      return /*#__PURE__*/_react.default.createElement("div", {
        className: wrapClass
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "ct-wrap"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "ope-btn-wrap"
      }, /*#__PURE__*/_react.default.createElement("a", {
        onClick: function onClick() {
          _this4.onAddChildNode('PREDEFINED');
        },
        className: "single"
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "fm-plus fm"
      }), this.t('condition')), !hideCustom && /*#__PURE__*/_react.default.createElement("a", {
        onClick: function onClick() {
          _this4.onAddChildNode('CUSTOM');
        },
        className: "single"
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "fm-plus fm"
      }), this.t('advanceCondition')), /*#__PURE__*/_react.default.createElement("a", {
        onClick: this.onAddParentNode,
        className: "group ".concat(this.isParentNode(selectedNodeId) ? "" : "disabled")
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "fm-plus fm"
      }), this.t('setOfConditions'))), /*#__PURE__*/_react.default.createElement("div", {
        className: "condition-tree-wrap"
      }, /*#__PURE__*/_react.default.createElement(_conditionTree.default, {
        mode: mode,
        cdtData: this.cdtData,
        treeMap: treeMap,
        selectedNode: selectedNode,
        conditionBuilder: conditionBuilder,
        onToggle: this.onToggleNode,
        onDeleteNode: this.onDeleteNode,
        onSelected: this.onSelectNode,
        initData: initData
      }))), /*#__PURE__*/_react.default.createElement("div", {
        className: "cf-wrap"
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "ope-btn-wrap"
      }, this.t('conditionConfiguration1')), /*#__PURE__*/_react.default.createElement(_conditionForm.default, {
        conditionOptions: conditionOptions,
        initData: initData,
        apis: apis,
        ModalManager: ModalManager,
        extraFormMap: extraFormMap,
        conditionBuilder: conditionBuilder,
        treeMap: treeMap,
        selectedNode: selectedNode,
        entrance: entrance,
        onFormTypeChange: this.onFormTypeChange,
        onFieldChange: this.onFieldChange,
        handleTempChange: this.handleTempChange
      })));
    }
  }]);
  return View;
}(_react.Component);

var _default = View;
exports.default = _default;