"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _mkSelect = _interopRequireDefault(require("../../Process/mkSelect"));

var _popSelector = _interopRequireDefault(require("../../Process/popSelector"));

var C = _interopRequireWildcard(require("../constants"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var LegalEntity = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(LegalEntity, _Component);

  var _super = _createSuper(LegalEntity);

  function LegalEntity(props) {
    var _this;

    (0, _classCallCheck2.default)(this, LegalEntity);
    _this = _super.call(this, props);

    _this.checkItem = function (list) {
      _this.props.handleTempChange(list, 'code');
    };

    _this.deleteItem = function (code, e) {
      var _this$props = _this.props,
          selectedNode = _this$props.selectedNode,
          handleTempChange = _this$props.handleTempChange;
      var list = selectedNode.temp.value1;
      list = list.filter(function (d) {
        return d.code !== code;
      });
      handleTempChange(list, 'code');
      e.stopPropagation();
    };

    _this.fetchLegalEntities = function () {
      var apis = _this.props.apis;
      apis.getLegalEntities({
        start: 0,
        length: 50
      }).then(function (res) {
        if (res && res.code === 'ACK') {
          _this.setState({
            legalEntities: res.data.data,
            total: res.data.recordsTotal
          });
        }
      }).catch(function () {});
    };

    _this.loadMore = function (_ref) {
      var current = _ref.current,
          pageSize = _ref.pageSize;
      var apis = _this.props.apis;
      var value = _this.state.legalEntities || [];
      return new Promise(function (resolve, reject) {
        apis.getLegalEntities({
          start: (current - 1) * pageSize,
          length: pageSize
        }).then(function (res) {
          if (res && res.code === 'ACK' && res.data && Array.isArray(res.data.data) && res.data.data.length > 0) {
            _this.setState({
              legalEntities: [].concat((0, _toConsumableArray2.default)(value), (0, _toConsumableArray2.default)(res.data.data))
            });

            resolve([].concat((0, _toConsumableArray2.default)(value), (0, _toConsumableArray2.default)(res.data.data)));
          } else {
            reject();
          }
        }).catch(function () {
          reject();
        });
      });
    };

    _this.searchLegalEntities = function (keyword) {
      var apis = _this.props.apis;
      return new Promise(function (resolve, reject) {
        apis.searchLegalEntities({
          invoiceTitleKeyWords: keyword,
          start: 0,
          length: 100
        }).then(function (res) {
          if (res && res.code === 'ACK') {
            resolve({
              code: 'ACK',
              data: res.data.data
            });
          } else {
            reject();
          }
        }).catch(function () {
          reject();
        });
      });
    };

    _this.togglePopover = function (e) {
      if (!_this.now || Date.now() - _this.now > 400) {
        _this.setState({
          visible: !_this.state.visible
        });

        _this.now = Date.now();
      }
    };

    _this.state = {
      legalEntities: null,
      total: 0,
      visible: false
    };
    _this.t = _mkTranslate.default.getLocalNs('MK_ConditionSetting', (0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(LegalEntity, [{
    key: "parentTemplate",
    value: function parentTemplate(node) {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", null, " ", node.invoiceTitle, " "));
    }
  }, {
    key: "childrenTemplate",
    value: function childrenTemplate(node) {
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
        id: node.code,
        className: "main-name text-ellipsis",
        style: {
          paddingTop: '4px'
        }
      }, node.invoiceTitle));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.fetchLegalEntities();
    }
  }, {
    key: "render",
    value: function render() {
      var _React$createElement,
          _this2 = this;

      var visible = this.state.visible;
      var _this$props2 = this.props,
          selectedNode = _this$props2.selectedNode,
          handleOpChange = _this$props2.handleOpChange,
          togglePopover = _this$props2.togglePopover,
          fieldConfig = _this$props2.fieldConfig,
          defaultChecked = selectedNode.temp && selectedNode.temp.value1;

      var _ref2 = fieldConfig || {},
          opTypes = _ref2.opTypes;

      return /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("div", {
        className: "popover-selected-item-wrap"
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "label-obj"
      }, this.t('object')), this.state.legalEntities ? /*#__PURE__*/_react.default.createElement(_popSelector.default, (_React$createElement = {
        treeData: this.state.legalEntities,
        searchApi: this.searchLegalEntities,
        code: "code",
        name: "invoiceTitle" // localSearch={true}
        ,
        searchField: "invoiceTitle",
        visible: visible,
        loadMore: true,
        pageSize: 50,
        defaultChecked: defaultChecked,
        onVisibleChange: this.togglePopover,
        childrenTemplate: this.childrenTemplate,
        placeholder: this.t('legalEntitySearch'),
        onCheckItem: this.checkItem
      }, (0, _defineProperty2.default)(_React$createElement, "loadMore", this.loadMore), (0, _defineProperty2.default)(_React$createElement, "total", this.state.total), _React$createElement), /*#__PURE__*/_react.default.createElement("button", {
        onClick: this.togglePopover,
        className: "rect-add-btn"
      }, /*#__PURE__*/_react.default.createElement("i", {
        className: "fm fm-plus"
      }))) : null, selectedNode.temp && selectedNode.temp.value1 && selectedNode.temp.value1.map(function (d) {
        return /*#__PURE__*/_react.default.createElement("a", {
          key: d.code,
          className: "popover-selected-item-rect",
          onClick: togglePopover
        }, d.invoiceTitle, /*#__PURE__*/_react.default.createElement("span", {
          className: "close-icon-wrap",
          code: d.code,
          onClick: function onClick(e) {
            _this2.deleteItem(d.code, e);
          }
        }, /*#__PURE__*/_react.default.createElement("i", {
          className: "fm fm-cross"
        })));
      })));
    }
  }]);
  return LegalEntity;
}(_react.Component);

LegalEntity.defaultProps = {
  fieldConfig: {
    opTypes: [{
      name: C.WORD_MAP[C.IN],
      value: C.IN
    }, {
      name: C.WORD_MAP[C.NOT_IN],
      value: C.NOT_IN
    }]
  }
};
var _default = LegalEntity;
exports.default = _default;