"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _CityList = _interopRequireDefault(require("./CityList"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _reactI18next = require("react-i18next");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-city-field");
var defaultAlignConfig = {
  points: ['tl', 'bl'],
  offset: [0, -58],
  overflow: {
    adjustX: true,
    adjustY: true
  }
};
var popHeight = 300;
/* 获取每刻城市简称 by code */

function getSimpleCityName(code) {
  var placesHashMap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var locationName = '';

  if (code) {
    var lastStrikethroughIndex = code.lastIndexOf('-'),
        placeCode = code.substr(lastStrikethroughIndex + 1);
    var place = placesHashMap[placeCode];

    if (place) {
      locationName = place.name;
    }
  }

  return locationName;
}
/**
 * @visibleName     🍳-CityField  
 * @author  刀马
 */


function CityField(props, ref) {
  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      showDropDown = _useState2[0],
      setShowDropDown = _useState2[1];

  var _useTranslation = (0, _reactI18next.useTranslation)('MK_FormFields'),
      t = _useTranslation.t;

  var cityList = (0, _react.useRef)();
  var cityRef = (0, _react.useRef)();

  var hideDropDown = function hideDropDown() {
    var readOnly = props.readOnly;

    if (readOnly) {
      return;
    } // 打开面板时，获取最新的最近使用城市


    setShowDropDown(false);
  };

  var showDropDownFn = function showDropDownFn(e) {
    var readOnly = props.readOnly;

    if (readOnly) {
      return;
    }

    setShowDropDown(true);
  };

  var onDelete = function onDelete(fullCode) {
    if (cityList) {
      cityList.current.onDelete(fullCode);
    }
  };

  var getCityNames = function getCityNames(value, isDelete) {
    var mode = props.fieldProperties.mode,
        placesHashMap = props.placesHashMap;
    var data;
    isDelete = mode === 'MULTI' && isDelete;

    if (!_lodash.default.isArray(value) && _lodash.default.isObject(value)) {
      value = value.location;
    }

    if (_lodash.default.isEmpty(value)) return null;

    if (_lodash.default.isArray(value)) {
      data = value;
    } else {
      data = [value];
    }

    return _lodash.default.map(data, function (vm, index) {
      return /*#__PURE__*/_react.default.createElement("div", {
        key: index
      }, getSimpleCityName(vm, placesHashMap) || '', isDelete ? /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-huaban1",
        onClick: function onClick() {
          return onDelete(vm);
        }
      }) : index !== data.length - 1 ? /*#__PURE__*/_react.default.createElement("span", null, "\u3001") : null);
    });
  };

  var clearValue = function clearValue(e) {
    e.preventDefault();
    e.stopPropagation();
    var onChange = props.onChange;
    onChange && onChange(null);
  };

  (0, _react.useEffect)(function () {
    if (props.value && cityList !== null && cityList !== void 0 && cityList.current) {
      //为解决Trigger中的popup值没有更新问题
      cityList.current.updateValue(props.value);
    }
  }, [props]);
  (0, _react.useImperativeHandle)(ref, function () {
    return {
      showDropDownFn: showDropDownFn
    };
  });
  var value = props.value,
      readOnly = props.readOnly,
      fieldProperties = props.fieldProperties,
      isPair = props.isPair,
      _props$extraProps = props.extraProps,
      fieldStyleCategory = _props$extraProps.fieldStyleCategory,
      align = _props$extraProps.align,
      children = props.children,
      _props$wrapClassName = props.wrapClassName,
      wrapClassName = _props$wrapClassName === void 0 ? '' : _props$wrapClassName;
  var placeholder = fieldProperties.placeholder,
      Ismodify = fieldProperties.Ismodify,
      required = fieldProperties.required;
  var readOnlyClass = readOnly ? 'readonly' : '';
  var fieldStyleCategoryClass = fieldStyleCategory === 'origin' ? cmName + '-cell' : null;
  var cityNames = getCityNames(value);

  var alignConfig = _objectSpread(_objectSpread({}, defaultAlignConfig), align);

  var cityPopType = 'down';

  if (cityRef.current) {
    var domRect = cityRef.current.getBoundingClientRect();
    var toBottom = document.documentElement.clientHeight - domRect.bottom;

    if (toBottom < popHeight && domRect.top >= popHeight) {
      alignConfig = _objectSpread(_objectSpread({}, alignConfig), {}, {
        offset: [0, 0]
      });
      cityPopType = 'up';
    }
  }

  return /*#__PURE__*/_react.default.createElement("div", {
    ref: cityRef,
    className: "".concat(cmName, "-wrapper ").concat(wrapClassName)
  }, /*#__PURE__*/_react.default.createElement(_rcTrigger.default, {
    action: ['click'],
    popupVisible: showDropDown,
    popupAlign: alignConfig,
    popupClassName: cmName,
    popupStyle: {
      width: cityRef !== null && cityRef !== void 0 && cityRef.current ? cityRef.current.clientWidth : 400
    },
    popup: /*#__PURE__*/_react.default.createElement(_CityList.default, (0, _extends2.default)({}, props, {
      ref: cityList,
      showDropDown: showDropDown,
      getCityNames: getCityNames,
      hideDropDown: hideDropDown,
      popType: cityPopType,
      isPair: isPair
    }))
  }, /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, children ? children === null || children === void 0 ? void 0 : children(cityNames) : /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(cmName, "-display-value ").concat(readOnlyClass, " ").concat(fieldStyleCategoryClass),
    onClick: showDropDownFn
  }, !_lodash.default.isEmpty(cityNames) ? /*#__PURE__*/_react.default.createElement("span", {
    className: "city-names"
  }, cityNames) : /*#__PURE__*/_react.default.createElement("span", {
    className: "placeholder"
  }, readOnly ? t('empty') : placeholder)), !readOnly && !_lodash.default.isEmpty(cityNames) && !required && /*#__PURE__*/_react.default.createElement(_icon.default, {
    type: "close",
    onClick: function onClick(event) {
      return clearValue(event);
    }
  }))), Ismodify ? /*#__PURE__*/_react.default.createElement("span", {
    className: "fm fm-revised"
  }) : null);
}

var _default = /*#__PURE__*/(0, _react.forwardRef)(CityField);

exports.default = _default;