"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _CityField = _interopRequireDefault(require("../CityField"));

var _reactI18next = require("react-i18next");

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var cmName = "".concat(_utils.default.prefixCls, "-city-pair-field");

var CityPairField = function CityPairField(props) {
  var value = props.value,
      isTravel = props.fieldProperties.isTravel;
  var departure = value && value.cityPair && value.cityPair.departure;
  var destination = value && value.cityPair && value.cityPair.destination ? value.cityPair.destination : !isTravel ? '' : [];

  var _useTranslation = (0, _reactI18next.useTranslation)('MK_FormFields'),
      t = _useTranslation.t;

  var destinationChange = function destinationChange(obj) {
    var isTravel = props.fieldProperties.isTravel; //行程的结束城市结构是数组，无论选择多少城市，其他是字符串

    var data = _lodash.default.isArray(obj) || !isTravel ? obj : [obj];

    if (data !== destination) {
      destination = data;
      setValue(departure, data);
    }
  };

  var setValue = (0, _react.useCallback)(function (departure, destination) {
    var onChange = props.onChange;

    if (onChange && typeof onChange === 'function') {
      onChange({
        cityPair: {
          departure: departure,
          destination: destination
        },
        location: null
      });
    }
  }, [props]);
  var departureChange = (0, _react.useCallback)(function (obj) {
    if (obj !== destination) {
      setValue(obj, destination);
    }
  }, [setValue, destination]);

  var clearValue = function clearValue(e) {
    e.preventDefault();
    e.stopPropagation();
    var onChange = props.onChange;
    onChange && onChange(null);
  };

  (0, _react.useEffect)(function () {
    var _value$cityPair;

    var _props$fieldPropertie = props.fieldProperties,
        fieldProperties = _props$fieldPropertie === void 0 ? {} : _props$fieldPropertie,
        value = props.value;
    var valueDefault = fieldProperties.valueDefault,
        defaultDepartureCity = fieldProperties.defaultDepartureCity;

    if (!(value !== null && value !== void 0 && (_value$cityPair = value.cityPair) !== null && _value$cityPair !== void 0 && _value$cityPair.departure) && valueDefault === 'DEPARTURE_CITY' && defaultDepartureCity) {
      departureChange(defaultDepartureCity);
    }
  }, [props, departureChange]);
  var extraProps = props.extraProps,
      readOnly = props.readOnly,
      placesHashMap = props.placesHashMap,
      expensePlaces = props.expensePlaces,
      bankPlaces = props.bankPlaces,
      travelTrip = props.extraProps.travelTrip,
      _props$fieldPropertie2 = props.fieldProperties,
      mode = _props$fieldPropertie2.mode,
      required = _props$fieldPropertie2.required;
  var ClassName = (0, _classnames.default)(cmName, 'city-pair', {
    'readonly': readOnly,
    'table-cell': extraProps.fieldStyleCategory === 'origin'
  });
  var startProps = {
    readOnly: readOnly,
    placesHashMap: placesHashMap,
    expensePlaces: expensePlaces,
    bankPlaces: bankPlaces,
    fieldProperties: {
      placeholder: t('cityField.from'),
      mode: mode,
      required: true // 是为了不让 CityField 显示清除按钮

    },
    extraProps: {
      origin: "from",
      travelTrip: travelTrip
    },
    onChange: departureChange
  };
  var endProps = {
    readOnly: readOnly,
    placesHashMap: placesHashMap,
    expensePlaces: expensePlaces,
    bankPlaces: bankPlaces,
    fieldProperties: {
      placeholder: t('cityField.to'),
      mode: mode,
      required: true // 是为了不让 CityField 显示清除按钮

    },
    extraProps: {
      origin: "to",
      travelTrip: travelTrip
    },
    onChange: destinationChange
  };
  return /*#__PURE__*/_react.default.createElement("div", {
    className: ClassName
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(cmName, "_departure")
  }, /*#__PURE__*/_react.default.createElement(_CityField.default, (0, _extends2.default)({
    value: departure
  }, startProps, {
    isPair: true
  }))), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(cmName, "_range-picker-separator")
  }, "~"), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(cmName, "_destination")
  }, /*#__PURE__*/_react.default.createElement(_CityField.default, (0, _extends2.default)({
    value: destination
  }, endProps, {
    isPair: true
  }))), !readOnly && (departure || destination) && !required && /*#__PURE__*/_react.default.createElement(_icon.default, {
    type: "close",
    onClick: function onClick(event) {
      return clearValue(event);
    }
  }));
};

var _default = CityPairField;
exports.default = _default;