"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _CurrencySelector = _interopRequireDefault(require("../../CurrencySelector"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _cookie = _interopRequireDefault(require("../../utils/cookie"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefix = _utils.default.prefixCls;
var confirm = _modal.default.confirm;

function CurrencyField(props) {
  var value = props.value,
      readOnly = props.readOnly,
      getAllCurrencys = props.getAllCurrencys,
      fieldProperties = props.fieldProperties,
      onChange = props.onChange,
      extraProps = props.extraProps;
  var placeholder = fieldProperties.placeholder;
  var needConfirm = extraProps.needConfirm,
      confirmTitle = extraProps.confirmTitle;
  var wrapperRef = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(_cookie.default.get('latestCurrencys') || []),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      latestCurrencys = _useState2[0],
      setLatestCurrencys = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      allCurrencys = _useState4[0],
      setAllCurrencys = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      currencyLoading = _useState6[0],
      setCurrencyLoading = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      selectorVisible = _useState8[0],
      setSetelectorVisible = _useState8[1];

  var handleCurrencyChange = function handleCurrencyChange(currency) {
    _utils.default.handleCurrencyOperation(currency.code);

    if (typeof onChange === 'function') {
      onChange(currency.code);
    }
  };

  (0, _react.useEffect)(function () {
    if ((0, _lodash.isEmpty)(allCurrencys) && typeof getAllCurrencys === 'function') {
      setCurrencyLoading(true);
      getAllCurrencys().then(function (data) {
        setAllCurrencys(data);
        setCurrencyLoading(false);
      }).catch(function () {
        return setCurrencyLoading(false);
      });
    }
  }, [allCurrencys, getAllCurrencys]);
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: wrapperRef
  }, /*#__PURE__*/_react.default.createElement(_CurrencySelector.default, {
    latestCurrencys: latestCurrencys,
    data: allCurrencys,
    loading: currencyLoading,
    disabled: readOnly,
    onChange: function onChange(currency) {
      if (needConfirm) {
        confirm({
          title: confirmTitle,
          content: '',
          cancelText: '取消',
          okText: '确认',
          onOk: function onOk() {
            handleCurrencyChange(currency);
          }
        });
      } else {
        handleCurrencyChange(currency);
      }
    },
    popWidth: wrapperRef.current ? wrapperRef.current.clientWidth : 300,
    visibleChange: function visibleChange(visible) {
      setSetelectorVisible(visible);

      if (visible) {
        setLatestCurrencys(_cookie.default.get('latestCurrencys') || []);
      }
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-currency-wrapper")
  }, /*#__PURE__*/_react.default.createElement(_input.default, {
    placeholder: placeholder,
    value: value,
    disabled: readOnly
  }), !readOnly ? /*#__PURE__*/_react.default.createElement(_icon.default, {
    type: "down",
    className: "select-arrow currency-down ".concat(selectorVisible ? 'currency-up' : '')
  }) : null)));
}

var _default = CurrencyField;
exports.default = _default;