"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

require("maycur-antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("maycur-antd/lib/radio"));

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var prefix = _utils.default.prefixCls;
var cmName = "".concat(prefix, "-radio-field");

function RadioField(props) {
  var value = props.value,
      options = props.options,
      onChange = props.onChange,
      readOnly = props.readOnly,
      direction = props.direction;

  var onRadioChange = function onRadioChange(e) {
    onChange && onChange(e.target.value);
  };

  var style = (0, _react.useMemo)(function () {
    return direction === 'vertical' ? {
      display: 'block'
    } : {
      display: 'inline-block'
    };
  }, [direction]);
  return /*#__PURE__*/_react.default.createElement(_radio.default.Group, {
    onChange: onRadioChange,
    value: value,
    disabled: readOnly,
    className: cmName
  }, options.map(function (option) {
    return /*#__PURE__*/_react.default.createElement(_radio.default, {
      key: option.value,
      value: option.value,
      style: style,
      disabled: option.disabled
    }, option.text, option.popoverText && /*#__PURE__*/_react.default.createElement(_popover.default, {
      content: option.popoverText,
      placement: "bottom",
      overlayClassName: "".concat(cmName, "-popover")
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: "fm fm-question"
    })));
  }));
}

RadioField.defaultProps = {
  direction: 'vertical'
};

function WrapRadio(props) {
  var _props$extraProps = props.extraProps,
      extraProps = _props$extraProps === void 0 ? {} : _props$extraProps,
      _props$fieldPropertie = props.fieldProperties,
      fieldProperties = _props$fieldPropertie === void 0 ? {} : _props$fieldPropertie,
      _props$fieldProps = props.fieldProps,
      fieldProps = _props$fieldProps === void 0 ? {} : _props$fieldProps,
      onChange = props.onChange,
      value = props.value,
      readOnly = props.readOnly;

  var _props = _objectSpread(_objectSpread(_objectSpread({
    onChange: onChange,
    value: value,
    readOnly: readOnly
  }, extraProps), fieldProperties), fieldProps);

  return /*#__PURE__*/_react.default.createElement(RadioField, _props);
}

;
var _default = WrapRadio;
exports.default = _default;