"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = require("lodash");

var _NameCard = _interopRequireDefault(require("../../NameCard"));

var _DepartmentSelectionModal = _interopRequireDefault(require("../../DepartmentSelectionModal"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var cmName = "".concat(_utils.default.prefixCls, "-staff-field");
var DEPARTMENT_PICKER = {
  SCOPE_ALL: 'ALL',
  SCOPE_DEPARTMENT: 'DEPARTMENT',
  SCOPE_STAFF: 'STAFF',
  DEPARTMENT: 'DEPARTMENT',
  STAFF: 'STAFF',
  SOURCE_LIST: 'DEPARTMENT_PICKER_SOURCE_LIST',
  SEARCH_LIST: 'DEPARTMENT_PICKER_SEARCH_LIST'
}; // 默认传进组件的value是数组，不再处理数据转换的问题

var StaffField = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(StaffField, _Component);

  var _super = _createSuper(StaffField);

  function StaffField(props) {
    var _this;

    (0, _classCallCheck2.default)(this, StaffField);
    _this = _super.call(this, props);

    _this.formatValue = function (value) {
      if (value && value.length > 3) {
        return value.slice(0, 2).map(function (val) {
          return val && val.userName;
        }).join(' 、 ') + '......等' + value.length + '人';
      } else {
        return value && value.map(function (val) {
          return val && val.userName;
        }).join(' , ');
      }
    };

    _this.switchModal = function () {
      var readOnly = _this.props.readOnly;
      if (readOnly) return;

      _this.setState(function (_ref) {
        var modalVisible = _ref.modalVisible;
        return {
          modalVisible: !modalVisible
        };
      });
    };

    _this.handleChange = function (selectList) {
      var onChange = _this.props.onChange;
      if (typeof onChange === 'function') onChange(_this.convertFormValue(selectList));

      _this.setState(function (_ref2) {
        var modalVisible = _ref2.modalVisible;
        return {
          modalVisible: !modalVisible
        };
      });
    };

    _this.convertFormValue = function (data) {
      var _data = data.map(function (d) {
        return {
          userCode: d.code,
          userName: d.name,
          userEmployeeNo: d.userEmployeeId || ''
        };
      });

      return _data;
    };

    _this.reverseFormValue = function (data) {
      return (data || []).map(function (d) {
        return {
          code: d ? d.userCode : null,
          name: d ? d.userName : null,
          userEmployeeId: d.userEmployeeNo,
          type: DEPARTMENT_PICKER.SCOPE_STAFF
        };
      });
    };

    _this.onLegalEntityChange = function () {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          personalInfo = _this$props.personalInfo; // 抬头改变时，默认填充自己

      onChange([{
        userCode: personalInfo.userCode,
        userName: personalInfo.name
      }]);
    };

    _this.state = {
      modalVisible: false
    };
    return _this;
  } // 因支持单选、多选，value为数组


  (0, _createClass2.default)(StaffField, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(nextProps) {
      var limitByEntity = this.props.fieldProperties.limitByEntity; // 公司抬头改变时
      // 明细表单中员工重置

      if (this.props.legalEntity && nextProps.legalEntity && !(0, _lodash.isEqual)(nextProps.legalEntity, this.props.legalEntity) && limitByEntity) {
        this.onLegalEntityChange();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props2 = this.props,
          _this$props2$fieldFor = _this$props2.fieldForm,
          setWatch = _this$props2$fieldFor.setWatch,
          getFormFieldByName = _this$props2$fieldFor.getFormFieldByName,
          getFieldValue = _this$props2$fieldFor.getFieldValue,
          limitByEntity = _this$props2.fieldProperties.limitByEntity;
      var legalEntityField = getFormFieldByName ? getFormFieldByName('legalEntity') : getFieldValue ? getFieldValue('legalEntity') : undefined;

      if (legalEntityField && limitByEntity) {
        setWatch && setWatch('legalEntity', function () {
          _this2.onLegalEntityChange();
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          value = _this$props3.value,
          readOnly = _this$props3.readOnly,
          getFieldValue = _this$props3.fieldForm.getFieldValue,
          _this$props3$fieldPro = _this$props3.fieldProperties,
          placeholder = _this$props3$fieldPro.placeholder,
          optionMode = _this$props3$fieldPro.optionMode,
          maxSelectLength = _this$props3$fieldPro.maxSelectLength,
          limitByEntity = _this$props3$fieldPro.limitByEntity,
          _this$props3$extraPro = _this$props3.extraProps,
          fieldStyleCategory = _this$props3$extraPro.fieldStyleCategory,
          extraClassName = _this$props3$extraPro.extraClassName,
          privateReadOnly = _this$props3$extraPro.privateReadOnly,
          fetchUserDepartment = _this$props3.fetchUserDepartment,
          fetchStaff = _this$props3.fetchStaff,
          searchStaff = _this$props3.searchStaff,
          fetchUserGroup = _this$props3.fetchUserGroup,
          fetchUserInfo = _this$props3.fetchUserInfo,
          hideHelp = _this$props3.hideHelp,
          legalEntity = _this$props3.legalEntity,
          bg1 = _this$props3.bg1,
          bg2 = _this$props3.bg2,
          outerPermit = _this$props3.outerPermit;
      var modalVisible = this.state.modalVisible;
      var displayValue = this.formatValue(value);

      var _value = this.reverseFormValue(value);

      var showUserInfo = value instanceof Array && value.length === 1;
      var modalProps = {
        visible: modalVisible,
        modalCallBack: this.handleChange,
        onCancel: this.switchModal,
        hideHelp: hideHelp
      };
      var pickerProps = {
        selectList: _value,
        scope: DEPARTMENT_PICKER.SCOPE_STAFF,
        maxSelectLength: optionMode === 'SINGLE' ? 1 : maxSelectLength,
        fetchUserDepartment: fetchUserDepartment,
        fetch: fetchStaff,
        search: searchStaff,
        fetchUserGroup: fetchUserGroup,
        outerPermit: outerPermit
      };

      if (limitByEntity) {
        pickerProps.legalEntity = getFieldValue('legalEntity') || legalEntity || null;
      }

      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(cmName, "-select ").concat(extraClassName)
      }, readOnly ? /*#__PURE__*/_react.default.createElement("div", {
        className: "user-info"
      }, /*#__PURE__*/_react.default.createElement("span", null, displayValue), showUserInfo && /*#__PURE__*/_react.default.createElement(_popover.default, {
        overlayClassName: "name-card",
        placement: "right",
        content: /*#__PURE__*/_react.default.createElement(_NameCard.default, {
          key: value[0].userCode,
          title: "header",
          userCode: value[0].userCode,
          fetchUserInfo: fetchUserInfo,
          bg1: bg1,
          bg2: bg2
        })
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'icon-circle'
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-more-o"
      })))) : /*#__PURE__*/_react.default.createElement("div", {
        onClick: this.switchModal
      }, /*#__PURE__*/_react.default.createElement(_input.default, {
        value: displayValue,
        placeholder: placeholder,
        onChange: function onChange() {},
        disabled: readOnly || privateReadOnly,
        readOnly: true,
        category: fieldStyleCategory
      }), /*#__PURE__*/_react.default.createElement(_icon.default, {
        type: 'down',
        className: 'select-down',
        style: fieldStyleCategory === 'origin' ? {
          right: 12
        } : null
      })), modalVisible && /*#__PURE__*/_react.default.createElement(_DepartmentSelectionModal.default, {
        modalProps: modalProps,
        pickerProps: pickerProps
      }));
    }
  }]);
  return StaffField;
}(_react.Component);

StaffField.propTypes = {
  fetchStaff: _propTypes.default.func,
  searchStaff: _propTypes.default.func,
  fetchUserGroup: _propTypes.default.func
};
StaffField.defaultProps = {
  disabled: false
};
var _default = StaffField;
exports.default = _default;