"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.WebTombStone = exports.TombStone = void 0;

require("maycur-antd/lib/row/style/css");

var _row = _interopRequireDefault(require("maycur-antd/lib/row"));

require("maycur-antd/lib/col/style/css");

var _col = _interopRequireDefault(require("maycur-antd/lib/col"));

require("maycur-antd/lib/skeleton/style/css");

var _skeleton = _interopRequireDefault(require("maycur-antd/lib/skeleton"));

var _react = _interopRequireDefault(require("react"));

var _utils = _interopRequireDefault(require("../utils/utils"));

var prefix = _utils.default.prefixCls;
var mainCls = "".concat(prefix, "-formtomb");

function FromTombstoneItem(props) {
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-tombstone-line")
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: 'tombstone-label'
  }));
}

function WebTombStoneItem() {
  return /*#__PURE__*/_react.default.createElement(_skeleton.default, {
    paragraph: {
      rows: 1,
      width: '100%'
    },
    title: {
      width: '100px'
    },
    active: true
  });
}

function WhiteSpace() {
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-white-space")
  });
}

function WebTombLine(props) {
  var _props$size = props.size,
      size = _props$size === void 0 ? 1 : _props$size;

  if (size === 2) {
    return /*#__PURE__*/_react.default.createElement(_row.default, {
      key: 1,
      gutter: 24
    }, /*#__PURE__*/_react.default.createElement(_col.default, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(_skeleton.default, {
      paragraph: {
        rows: 1,
        width: '100%'
      },
      title: {
        width: '100px'
      },
      active: true
    })), /*#__PURE__*/_react.default.createElement(_col.default, {
      span: 12
    }, /*#__PURE__*/_react.default.createElement(_skeleton.default, {
      paragraph: {
        rows: 1,
        width: '100%'
      },
      title: {
        width: '100px'
      },
      active: true
    })));
  } else {
    return /*#__PURE__*/_react.default.createElement(_row.default, {
      key: 1,
      gutter: 24
    }, /*#__PURE__*/_react.default.createElement(_col.default, {
      span: 24
    }, /*#__PURE__*/_react.default.createElement(_skeleton.default, {
      paragraph: {
        rows: 1,
        width: '100%'
      },
      title: {
        width: '200px'
      },
      active: true
    })));
  }
}

function FromTombstone(props) {
  var platform = props.platform;
  var node = null;

  if (platform === 'WEB') {
    node = /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(WebTombLine, {
      size: 2
    }), /*#__PURE__*/_react.default.createElement(WebTombLine, {
      size: 2
    }), /*#__PURE__*/_react.default.createElement(WebTombLine, {
      size: 2
    }), /*#__PURE__*/_react.default.createElement(WebTombLine, {
      size: 2
    }), /*#__PURE__*/_react.default.createElement(WebTombLine, {
      size: 1
    }), /*#__PURE__*/_react.default.createElement(WebTombLine, {
      size: 1
    }), /*#__PURE__*/_react.default.createElement(WebTombLine, {
      size: 1
    }));
  } else {
    node = /*#__PURE__*/_react.default.createElement("div", {
      className: mainCls
    }, /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(WhiteSpace, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(WhiteSpace, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null), /*#__PURE__*/_react.default.createElement(FromTombstoneItem, null));
  }

  return node;
}

var TombStone = FromTombstoneItem;
exports.TombStone = TombStone;
var WebTombStone = WebTombStoneItem;
exports.WebTombStone = WebTombStone;
var _default = FromTombstone;
exports.default = _default;