"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _ListPicker = _interopRequireDefault(require("../ListPicker"));

var _lodash = require("lodash");

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var LegalEntityPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(LegalEntityPicker, _Component);

  var _super = _createSuper(LegalEntityPicker);

  function LegalEntityPicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, LegalEntityPicker);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace(['MK_PaymentAccountModal', 'MK_LegalEntityPicker']).then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.fetchEntities = function (pagination, keyword) {
      return new Promise(function (resolve, reject) {
        _this.props.fetchEntities({
          start: pagination ? (pagination.current - 1) * pagination.pageSize : 0,
          length: pagination ? pagination.pageSize : _this.pageSize,
          invoiceTitleKeyWords: keyword,
          usable: true
        }).then(function (res) {
          if (res && res.code === 'ACK' && Array.isArray(res.data.data) && res.data.data.length > 0) {
            var _res = [];
            _res = res.data.data.map(function (item) {
              return _objectSpread(_objectSpread({}, item), {}, {
                name: item.invoiceTitle
              });
            });
            resolve({
              dataSource: _res,
              total: res.data.recordsTotal
            });
          } else {
            resolve({
              dataSource: []
            });
          }
        }).catch(function () {
          _this.setState({
            loading: false
          });

          reject();
        });
      });
    };

    _this.onSearch = function (key) {
      return _this.fetchEntities({
        current: 1,
        pageSize: _this.pageSize
      }, key);
    };

    _this.state = {
      value: props.value ? props.value : [],
      dataSource: [],
      t: _mkTranslate.default.noop()
    };
    _this.onChange = _this.onChange.bind((0, _assertThisInitialized2.default)(_this));

    _this.localeProcess();

    _this.pageSize = 50;
    return _this;
  }

  (0, _createClass2.default)(LegalEntityPicker, [{
    key: "onChange",
    value: function onChange(value) {
      var onChange = this.props.onChange;

      if (typeof onChange === 'function') {
        onChange(value);
      }
    } // 获取帐套可用的公司抬头

  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: // rc-form组件契约：接受value属性成为受控组件
    function UNSAFE_componentWillReceiveProps(nextProps) {
      if (!(0, _lodash.isEqual)(nextProps.value, this.props.value)) {
        var value = nextProps.value;
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var value = this.props.value;

      if (value) {
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          emptyText = _this$props.emptyText,
          modalManager = _this$props.modalManager,
          maxTagLength = _this$props.maxTagLength;
      var _this$state = this.state,
          value = _this$state.value,
          t = _this$state.t;
      return /*#__PURE__*/_react.default.createElement(_ListPicker.default, {
        dataIndex: "code",
        title: t("MK_LegalEntityPicker:LegalEntity"),
        tabname: t("MK_LegalEntityPicker:LegalEntity"),
        loadMore: true,
        isShowSearch: true,
        searchPlaceholder: t('MK_LegalEntityPicker:KeywordToSearch'),
        emptyText: emptyText ? emptyText : t('MK_LegalEntityPicker:Select'),
        modalManager: modalManager,
        maxTagLength: maxTagLength,
        value: value,
        dataSourceSync: this.fetchEntities,
        onSearch: this.onSearch,
        onChange: this.onChange,
        pageSize: this.pageSize
      });
    }
  }]);
  return LegalEntityPicker;
}(_react.Component);

var _default = LegalEntityPicker;
exports.default = _default;