### Loader

> 页面加载，组件加载，内联式加载

| 参数 | 说明 | position | 类型 | 默认值 |
| --- | --- | --- | --- | --- |
| active | 控制该组件是否显示 | - | Boolean | false | -
| size | 加载图标的宽高 | - | Number | 30 | -
| embed | 是否内联显示 | relative | Boolean | false | -
| mask | 是否相对父元素显示 | absolute | Boolean | false | -

##### 如何使用：

1.覆盖整个页面视图的70%透明度白底加载组件。
```jsx static
import React from 'react';
import { Loader } from 'maycur-business';

// 覆盖整个页面视图的70%透明度白底加载组件。
function FixedLoader  {
    return (
        <Loader active />
    )
}
```

2.覆盖父元素的白底加载组件。
```jsx static
...
// 覆盖父元素的白底加载组件。
function AbsoluteLoader  {
    return (
        <Loader active mask />
    )
}
```

3.内联在文档流中的透明底加载组件
```jsx static
...
// 内联在文档流中的透明底加载组件
function RelativeLoader  {
    return (
        <Loader active embed />
    )
}
```