"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/message/style/css");

var _message2 = _interopRequireDefault(require("maycur-antd/lib/message"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _reactDnd = require("react-dnd");

var _utils = _interopRequireDefault(require("../../../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefix = _utils.default.prefixCls;

function ColumnSetPanelItem(props) {
  var _canDrag = props.canDrag,
      endDrag = props.endDrag,
      movePanel = props.movePanel,
      panel = props.panel,
      index = props.index,
      id = props.id,
      checked = props.checked,
      onCheck = props.onCheck,
      canCancel = props.canCancel;
  var ref = (0, _react.useRef)(null);

  var _useDrop = (0, _reactDnd.useDrop)({
    accept: 'column',
    hover: function hover(item, monitor) {
      if (!ref.current) {
        return;
      }

      var dragIndex = item.index;
      var hoverIndex = index;

      if (dragIndex === hoverIndex) {
        return;
      }

      var hoverBoundingRect = ref.current.getBoundingClientRect();
      var hoverMiddleY = (hoverBoundingRect.bottom - hoverBoundingRect.top) / 2;
      var clientOffset = monitor.getClientOffset();
      var hoverClientY = clientOffset.y - hoverBoundingRect.top;

      if (dragIndex < hoverIndex && hoverClientY < hoverMiddleY) {
        return;
      } // Dragging upwards


      // Dragging upwards
      if (dragIndex > hoverIndex && hoverClientY > hoverMiddleY) {
        return;
      }

      movePanel(dragIndex, hoverIndex);
      item.index = hoverIndex;
    }
  }),
      _useDrop2 = (0, _slicedToArray2.default)(_useDrop, 2),
      drop = _useDrop2[1];

  var _useDrag = (0, _reactDnd.useDrag)({
    item: {
      type: 'column',
      index: index,
      id: id
    },
    canDrag: function canDrag(monitor) {
      return !!_canDrag;
    },
    collect: function collect(monitor) {
      return {
        isDragging: monitor.isDragging()
      };
    },
    end: function end(item, monitor) {
      endDrag();
    }
  }),
      _useDrag2 = (0, _slicedToArray2.default)(_useDrag, 2),
      isDragging = _useDrag2[0].isDragging,
      drag = _useDrag2[1];

  var _onCheck = function _onCheck() {
    if (typeof onCheck === 'function') {
      if (!canCancel && checked) {
        _message2.default.warning('需至少选择一个字段展示');

        return;
      }

      onCheck(index, !checked);
    }
  };

  var opacity = isDragging ? 0 : 1;
  drag(drop(ref));
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-column-set-panel-item-wrapper ").concat(checked ? 'checked' : ''),
    style: {
      opacity: opacity
    },
    onClick: _onCheck,
    ref: ref
  }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("span", {
    className: "fm fm-list",
    style: {
      cursor: 'move'
    }
  }), /*#__PURE__*/_react.default.createElement("span", {
    style: {
      marginLeft: 10
    }
  }, typeof panel.label === 'string' || /*#__PURE__*/_react.default.isValidElement(panel.label) ? panel.label : null)), /*#__PURE__*/_react.default.createElement("span", {
    className: "fm fm-check"
  }));
}

var _default = ColumnSetPanelItem;
exports.default = _default;