"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/radio/style/css");

var _radio = _interopRequireDefault(require("maycur-antd/lib/radio"));

require("maycur-antd/lib/checkbox/style/css");

var _checkbox = _interopRequireDefault(require("maycur-antd/lib/checkbox"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

require("maycur-antd/lib/input/style/css");

var _input = _interopRequireDefault(require("maycur-antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _i18next = _interopRequireDefault(require("i18next"));

var _lodash = _interopRequireDefault(require("lodash"));

var _Empty = _interopRequireDefault(require("../../../Empty"));

var _Loader = _interopRequireDefault(require("../../../Loader"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;
var Search = _input.default.Search;

var CheckFilter = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(CheckFilter, _Component);

  var _super = _createSuper(CheckFilter);

  function CheckFilter(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CheckFilter);
    _this = _super.call(this, props);

    _this.fetchFilters = function () {
      var _this$props = _this.props,
          filtersSync = _this$props.filtersSync,
          checkNeedRefreshFilter = _this$props.checkNeedRefreshFilter;

      if (typeof checkNeedRefreshFilter === 'function') {
        // 配合needRefreshFilters一起使用避免发起不必要的重复请求
        if (!checkNeedRefreshFilter()) return;
      }

      if (typeof filtersSync === 'function') {
        _this.setState({
          loading: true
        });

        filtersSync().then(function (res) {
          _this.filtersSource = res;

          _this.setState({
            filters: res,
            loading: false
          });
        }, function () {
          _this.setState({
            loading: false
          });
        });
      }
    };

    _this.onChange = function (value) {
      var _this$props2 = _this.props,
          setSelectedKeys = _this$props2.setSelectedKeys,
          filterOption = _this$props2.filterOption;
      var withOption = filterOption.withOption;

      _this.setMap(value);

      if (withOption) {
        setSelectedKeys(value.map(function (item) {
          return {
            value: item,
            text: _this.nameMap[item]
          };
        }));
      } else {
        setSelectedKeys(value);
      }
    };

    _this.setMap = function (value) {
      if (typeof _this.props.filtersSync !== 'function') return;
      _this.checkedValue = value || [];

      if (value && value.length) {
        var _assertThisInitialize = (0, _assertThisInitialized2.default)(_this),
            nameMap = _assertThisInitialize.nameMap,
            filtersSource = _assertThisInitialize.filtersSource;

        filtersSource.forEach(function (_ref) {
          var key = _ref.value,
              text = _ref.text;

          if (!(key in nameMap) && value.includes(key)) {
            nameMap[key] = text;
          }
        });
      }
    };

    _this.onSearch = function (value) {
      var search = _this.props.search;
      var filtered;

      if (typeof search === 'function') {
        _this.setState({
          loading: true
        });

        search(value).then(function (res) {
          _this.filtersSource = res;

          _this.setState({
            filters: res,
            loading: false
          });
        }, function () {
          _this.setState({
            loading: false
          });
        });
      } else {
        if (value) {
          filtered = _lodash.default.filter(_this.filtersSource, function (o) {
            return _lodash.default.includes(o.text, value);
          });

          _this.setState({
            filters: filtered
          });
        } else {
          filtered = _this.filtersSource;

          _this.setState({
            filters: filtered
          });
        }
      }
    };

    _this.onChangeSearchKey = function (e) {
      _this.setState({
        searchKey: e.target.value
      });
    };

    _this.selectAll = function (e) {
      var setSelectedKeys = _this.props.setSelectedKeys;
      var filters = _this.state.filters;

      if (e.target.checked) {
        var all = _lodash.default.map(filters, 'value');

        setSelectedKeys(all);
      } else {
        setSelectedKeys();
      }
    };

    _this.onConfirm = function () {
      var _this$props3 = _this.props,
          confirm = _this$props3.confirm,
          filtersSync = _this$props3.filtersSync;

      if (typeof filtersSync === 'function') {
        _this.setFiltersMap();
      }

      confirm();
    };

    _this.reset = function () {
      var setSelectedKeys = _this.props.setSelectedKeys;
      setSelectedKeys();

      _this.setState({
        searchKey: null
      }, function () {
        _this.onSearch(_this.state.searchKey);
      });
    };

    _this.valueAdapter = function (value) {
      var filterMultiple = _this.props.filterMultiple;

      if (!filterMultiple) {
        if (value instanceof Array) {
          return value[0];
        } else {
          return value;
        }
      } else if (value instanceof Array && value.length > 0) {
        return value.map(function (item) {
          return typeof item === 'string' ? item : item.value;
        });
      }
    };

    _this.state = {
      filters: props.filters,
      searchKey: null,
      loading: false
    };
    _this.nameMap = {};
    _this.checkedValue = [];
    _this.filtersSource = props.filters || [];
    return _this;
  }

  (0, _createClass2.default)(CheckFilter, [{
    key: "setFiltersMap",
    value: function setFiltersMap() {
      var _this$props4 = this.props,
          setFiltersMap = _this$props4.setFiltersMap,
          dataIndex = _this$props4.dataIndex,
          title = _this$props4.title,
          filterMultiple = _this$props4.filterMultiple;

      if (dataIndex && typeof setFiltersMap === 'function') {
        var checkedValue = this.checkedValue,
            nameMap = this.nameMap;
        setFiltersMap(dataIndex, {
          filters: filterMultiple ? checkedValue.map(function (value) {
            return {
              value: value,
              text: nameMap[value]
            };
          }) : [{
            value: checkedValue,
            text: nameMap[checkedValue]
          }],
          title: title,
          filterOption: {
            type: 'checkbox'
          }
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(preProps, preState) {
      if (preProps.filters.length !== this.props.filters.length || preProps.filters !== this.props.filters || preProps.needUpdate !== this.props.needUpdate) {
        this.filtersSource = this.props.filters;
        this.setState({
          filters: this.props.filters
        });
      }

      if (preProps.filtersSync !== this.props.filtersSync) {
        this.fetchFilters();
      } else if (this.props.needRefreshFilters && this.props !== preProps) {
        // 展开收起重发请求
        this.fetchFilters();
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.fetchFilters();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          placeholder = _this$props5.placeholder,
          selectedKeys = _this$props5.selectedKeys,
          filterMultiple = _this$props5.filterMultiple,
          _this$props5$showSear = _this$props5.showSearch,
          showSearch = _this$props5$showSear === void 0 ? true : _this$props5$showSear,
          filterWidth = _this$props5.filterWidth,
          sauron = _this$props5.sauron,
          customerRender = _this$props5.customerRender;
      var _this$state = this.state,
          filters = _this$state.filters,
          searchKey = _this$state.searchKey,
          loading = _this$state.loading;
      var style = {};

      if (filterWidth) {
        style = {
          width: filterWidth
        };
      }

      var _selectedKeys = this.valueAdapter(selectedKeys);

      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-check-filter"),
        style: style
      }, /*#__PURE__*/_react.default.createElement(_Loader.default, {
        active: loading,
        mask: true
      }), typeof customerRender === 'function' && customerRender(this.fetchFilters), showSearch ? /*#__PURE__*/_react.default.createElement("div", {
        className: 'pin-search'
      }, /*#__PURE__*/_react.default.createElement(Search, {
        value: searchKey,
        onSearch: this.onSearch,
        onChange: this.onChangeSearchKey,
        placeholder: placeholder
      })) : null, filterMultiple ? /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-check-filter_pin-box")
      }, /*#__PURE__*/_react.default.createElement(_checkbox.default.Group, {
        onChange: this.onChange,
        value: _selectedKeys
      }, filters && filters.length > 0 ? filters.map(function (item, index) {
        return /*#__PURE__*/_react.default.createElement(_checkbox.default, {
          value: item.value,
          className: 'pin-item',
          key: index
        }, item.text);
      }) : /*#__PURE__*/_react.default.createElement(_Empty.default, null))) : /*#__PURE__*/_react.default.createElement("div", {
        className: 'pin-radio-box'
      }, /*#__PURE__*/_react.default.createElement(_radio.default.Group, {
        onChange: function onChange(e) {
          _this2.onChange(e.target.value);

          if (sauron) {
            sauron.seeTheTarget('optionGroupFilter', e.target.value);
          }
        },
        value: _selectedKeys
      }, filters && filters.length > 0 ? filters.map(function (item, index) {
        return /*#__PURE__*/_react.default.createElement(_radio.default, {
          className: 'pin-item',
          value: item.value,
          key: index
        }, item.text);
      }) : /*#__PURE__*/_react.default.createElement(_Empty.default, null))), /*#__PURE__*/_react.default.createElement("div", {
        className: 'pin-footer'
      }, /*#__PURE__*/_react.default.createElement("div", {
        onClick: this.reset,
        className: 'footer-item weaker-item'
      }, _i18next.default.t('MK_Global:reset')), /*#__PURE__*/_react.default.createElement("div", {
        onClick: this.onConfirm,
        className: 'footer-item'
      }, _i18next.default.t('MK_Global:ok'))));
    }
  }]);
  return CheckFilter;
}(_react.Component);

CheckFilter.defaultProps = {
  filters: [],
  filterMultiple: false
};
var _default = CheckFilter;
exports.default = _default;