"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _TreeTransfer = _interopRequireDefault(require("../../../TreeTransfer/TreeTransfer"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _i18next = _interopRequireDefault(require("i18next"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

var _excluded = ["confirm", "setSelectedKeys", "selectedKeys", "columnModify", "columns"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var TradingPartnerFilter = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(TradingPartnerFilter, _Component);

  var _super = _createSuper(TradingPartnerFilter);

  function TradingPartnerFilter(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TradingPartnerFilter);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_Table').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.onChange = function (selectList) {
      _this.setState({
        selectedKeys: selectList
      });
    };

    _this.onOk = function () {
      var _this$props = _this.props,
          confirm = _this$props.confirm,
          setSelectedKeys = _this$props.setSelectedKeys,
          selectedKeys = _this$props.selectedKeys,
          columnModify = _this$props.columnModify,
          columns = _this$props.columns,
          col = (0, _objectWithoutProperties2.default)(_this$props, _excluded);
      var colCopy = (0, _lodash.cloneDeep)(col);
      colCopy.key = colCopy.dataIndex;

      var selectedList = _this.state.selectedKeys.map(function (item) {
        return item.name;
      });

      if (colCopy) {
        columnModify(colCopy, {
          key: 'selectedList',
          value: selectedList
        }, true);
      }

      setSelectedKeys((0, _toConsumableArray2.default)(_this.state.selectedKeys));
      confirm();
    };

    _this.fetchTradingPartner = function (category) {
      return new Promise(function (resolve, reject) {
        var dataSourceSync = _this.props.dataSourceSync;

        if (dataSourceSync) {
          dataSourceSync({
            parentCode: category ? 'root' : category && category.code,
            partnerType: ['SUPPLIER', 'CUSTOMER']
          }).then(function (res) {
            if (res && res.code === 'ACK') {
              var result = res.data.map(function (item) {
                return {
                  code: item.code,
                  name: item.name,
                  hasChildren: item.hasChildren,
                  _type: item.isLeaf ? 'LEAF' : 'CATEGORY'
                };
              });
              resolve(result);
            } else {
              reject();
            }
          }).catch(function () {
            return reject();
          });
        } else {
          reject();
        }
      });
    };

    _this.fetchTradingPartnerChildren = function (category) {
      return _this.fetchTradingPartner(category);
    };

    _this.search = function (keywords) {
      return new Promise(function (resolve, reject) {
        var search = _this.props.search;

        if (search) {
          search({
            keywords: keywords,
            partnerType: ['SUPPLIER', 'CUSTOMER']
          }).then(function (res) {
            if (res && res.code === 'ACK') {
              var result = res.data.map(function (item) {
                return {
                  code: item.code,
                  name: item.name,
                  hasChildren: item.hasChildren,
                  _type: item.isLeaf ? 'LEAF' : 'CATEGORY'
                };
              });
              resolve(result);
            } else {
              reject();
            }
          }).catch(function () {
            return reject();
          });
        }
      });
    };

    _this.state = {
      t: _mkTranslate.default.noop()
    };

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(TradingPartnerFilter, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (!(0, _lodash.isEqual)(nextProps.selectedKeys, this.props.selectedKeys)) {
        this.setState({
          selectedKeys: nextProps.selectedKeys
        });
      }
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setState({
        selectedKeys: this.props.selectedKeys
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$state = this.state,
          selectedKeys = _this$state.selectedKeys,
          t = _this$state.t;
      var clearFilters = this.props.clearFilters;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-option-filter-dropdown")
      }, /*#__PURE__*/_react.default.createElement(_TreeTransfer.default, (0, _extends2.default)({}, this.props, {
        dataSourceSync: this.fetchTradingPartner,
        onChange: this.onChange,
        value: selectedKeys,
        fetchChildren: this.fetchTradingPartnerChildren,
        search: this.search,
        placeholder: t('tradingPartnerFilter.placeholder')
      })), /*#__PURE__*/_react.default.createElement("div", {
        className: 'footer'
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: 'btn'
      }, /*#__PURE__*/_react.default.createElement(_button.default, {
        key: "back",
        type: "info",
        size: "large",
        onClick: function onClick() {
          return clearFilters();
        },
        style: {
          marginRight: 20
        }
      }, _i18next.default.t('MK_Global:cancel')), /*#__PURE__*/_react.default.createElement(_button.default, {
        key: "submit",
        type: "primary",
        size: "large",
        onClick: this.onOk
      }, _i18next.default.t('MK_Global:ok')))));
    }
  }]);
  return TradingPartnerFilter;
}(_react.Component);

var _default = TradingPartnerFilter;
exports.default = _default;