"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("maycur-antd/lib/breadcrumb/style/css");

var _breadcrumb = _interopRequireDefault(require("maycur-antd/lib/breadcrumb"));

require("maycur-antd/lib/popover/style/css");

var _popover = _interopRequireDefault(require("maycur-antd/lib/popover"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _ConfirmModal = _interopRequireDefault(require("../../ConfirmModal"));

var _Panel = require("./Panel");

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _excluded = ["filterConfig", "ModalManager"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var FilterSettingModal = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(FilterSettingModal, _Component);

  var _super = _createSuper(FilterSettingModal);

  function FilterSettingModal(props) {
    var _props$filterConfig;

    var _this;

    (0, _classCallCheck2.default)(this, FilterSettingModal);
    _this = _super.call(this, props);

    _this.localeProcess = function () {
      _mkTranslate.default.getNameSpace('MK_Table').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.addItem = function () {
      _this.setState({
        panel: 'setting',
        data: {
          filterName: '',
          customFilterItemList: [{
            code: new Date().valueOf()
          }]
        }
      }, function () {
        _this.filterColumns();
      });
    };

    _this.editItem = function (item) {
      _this.setState({
        panel: 'setting',
        data: _lodash.default.cloneDeep(item)
      }, function () {
        _this.filterColumns();
      });
    };

    _this.deleteItem = function (item) {
      var _this$props = _this.props,
          deleteFn = _this$props.filterConfig.deleteFn,
          ModalManager = _this$props.ModalManager;
      var t = _this.state.t;
      ModalManager.open({
        component: _ConfirmModal.default,
        componentProps: {
          title: t('MK_Global:tips'),
          subTitle: t('filterSettingModal.subTitle'),
          iconType: 'question-circle',
          size: 'sm',
          afterSubmit: function afterSubmit(promise) {
            deleteFn && deleteFn(item.code).then(function (resp) {
              if (resp && resp.code === 'ACK') {
                promise.resolve();

                _this.updateFilter(item, 'delete');
              }
            }).catch(function () {});
          }
        }
      }).then().catch();
    };

    _this.handleFormChange = function (changedFields) {
      _this.setState(function (_ref) {
        var data = _ref.data,
            fields = _ref.fields;
        var customFilterItemList = data.customFilterItemList,
            filterName = data.filterName;
        var customFilterItemListField = fields.customFilterItemList || [],
            filterNameField = fields.filterName || {};

        if ('customFilterItemList' in changedFields) {
          _lodash.default.each(changedFields.customFilterItemList, function (item, index) {
            for (var key in item) {
              customFilterItemList[index][key] = item[key].value;
              customFilterItemListField[index] = customFilterItemListField[index] || {};
              customFilterItemListField[index][key] = _objectSpread(_objectSpread({}, customFilterItemListField[index][key]), item[key]);
            }
          });
        } else if ('filterName' in changedFields) {
          filterName = changedFields.filterName.value;
          filterNameField = _objectSpread(_objectSpread({}, filterNameField), changedFields.filterName);
        }

        return {
          data: _objectSpread(_objectSpread({}, data), {}, {
            customFilterItemList: customFilterItemList,
            filterName: filterName
          }),
          fields: _objectSpread(_objectSpread({}, fields), {}, {
            customFilterItemList: customFilterItemListField,
            filterName: filterNameField
          })
        };
      }, function () {
        _this.filterColumns();
      });
    };

    _this.addFilterCondition = function () {
      _this.setState(function (_ref2) {
        var data = _ref2.data,
            fields = _ref2.fields;
        var customFilterItemList = [].concat((0, _toConsumableArray2.default)(data.customFilterItemList), [{
          code: new Date().valueOf()
        }]);

        var newData = _objectSpread(_objectSpread({}, data), {}, {
          customFilterItemList: customFilterItemList
        });

        return {
          data: newData
        };
      });
    };

    _this.deleteFilterCondition = function (index) {
      _this.setState(function (_ref3) {
        var data = _ref3.data,
            fields = _ref3.fields;
        var customFilterItemList = (0, _toConsumableArray2.default)(data.customFilterItemList);
        customFilterItemList.splice(index, 1);
        var customFilterItemListField = (0, _toConsumableArray2.default)(fields.customFilterItemList);
        customFilterItemListField.splice(index, 1);

        var newData = _objectSpread(_objectSpread({}, data), {}, {
          customFilterItemList: customFilterItemList
        });

        var newFields = _objectSpread(_objectSpread({}, fields), {}, {
          customFilterItemList: customFilterItemListField
        });

        return {
          data: newData,
          fields: newFields
        };
      }, function () {
        _this.filterColumns();
      });
    };

    _this.handleOk = function () {
      var _this$state = _this.state,
          panel = _this$state.panel,
          list = _this$state.list;
      var promise = _this.props.promise;

      var defaultFilterData = _lodash.default.find(list, {
        isDefault: true
      });

      if (panel === 'setting') {
        _this.save();
      } else {
        promise.resolve(defaultFilterData);
      }
    };

    _this.save = function () {
      var saveFn = _this.props.filterConfig.saveFn;
      var data = _this.state.data;
      var form = _this.formRef.props.form;
      form.validateFields(function (err, values) {
        if (!err) {
          var _data = _objectSpread(_objectSpread({}, data), values);

          saveFn && saveFn(_data).then(function (resp) {
            if (resp && resp.code === 'ACK') {
              _this.updateFilter(_objectSpread(_objectSpread({}, _data), {}, {
                code: resp.data
              }), 'edit');

              _this.goBack();
            }
          }).catch(function () {});
        }
      });
    };

    _this.setDefaultFilter = function (data, isCancel) {
      var saveFn = _this.props.filterConfig.saveFn;
      var list = _this.state.list;

      var _list = _lodash.default.clone(list);

      _lodash.default.forEach(_list, function (item) {
        item.isDefault = false;

        if (item.code === data.code) {
          item.isDefault = true;
        }
      });

      data.isDefault = true; //新增取消默认

      if (isCancel) {
        data.isDefault = false;
      }

      saveFn && saveFn(data);

      _this.setState({
        list: _list
      });
    };

    _this.updateFilter = function (item, opt) {
      var updateFilterFn = _this.props.filterConfig.updateFilterFn;
      var currentFilter = (0, _toConsumableArray2.default)(_this.state.list);

      var index = _lodash.default.findIndex(currentFilter, {
        code: item.code
      });

      if (opt === 'delete' && index > -1) {
        currentFilter.splice(index, 1);
      } else if (opt === 'edit') {
        index > -1 ? currentFilter.splice(index, 1, item) : currentFilter.push(item);
      }

      updateFilterFn(currentFilter);

      _this.setState({
        list: currentFilter
      });
    };

    _this.goBack = function (e) {
      _this.setState({
        panel: 'list',
        data: null,
        fields: {}
      });
    };

    _this.filterColumns = function () {
      var _this$state2 = _this.state,
          customFilterItemList = _this$state2.data.customFilterItemList,
          filterColumns = _this$state2.filterColumns;

      var unSelectColumns = _lodash.default.filter(filterColumns, function (column) {
        if (_lodash.default.find(customFilterItemList, function (item) {
          return item.key && (item.key === column.key || item.key === column.filterKey);
        })) {
          return false;
        }

        return true;
      });

      _this.setState({
        unSelectColumns: unSelectColumns
      });
    };

    _this.state = {
      panel: 'list',
      list: props.filterConfig && (0, _toConsumableArray2.default)(props.filterConfig.customFilters),
      data: null,
      fields: {},
      filterColumns: _lodash.default.filter(props.columns.concat(((_props$filterConfig = props.filterConfig) === null || _props$filterConfig === void 0 ? void 0 : _props$filterConfig.filterColumns) || []), function (column) {
        return column.filterOption;
      }),
      t: _mkTranslate.default.noop()
    };
    console.log('this.state:', _this.state);

    _this.localeProcess();

    return _this;
  }

  (0, _createClass2.default)(FilterSettingModal, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$state3 = this.state,
          panel = _this$state3.panel,
          list = _this$state3.list,
          data = _this$state3.data,
          fields = _this$state3.fields,
          filterColumns = _this$state3.filterColumns,
          unSelectColumns = _this$state3.unSelectColumns,
          t = _this$state3.t;
      var _this$props2 = this.props,
          emptyImg = _this$props2.filterConfig.emptyImg,
          ModalManager = _this$props2.ModalManager,
          restProps = (0, _objectWithoutProperties2.default)(_this$props2, _excluded);

      var title = /*#__PURE__*/_react.default.createElement(_breadcrumb.default, {
        separator: /*#__PURE__*/_react.default.createElement("span", {
          className: "fm fm-angle-right"
        })
      }, /*#__PURE__*/_react.default.createElement(_breadcrumb.default.Item, null, /*#__PURE__*/_react.default.createElement("span", {
        onClick: this.goBack
      }, t('filterSettingModal.manage')), /*#__PURE__*/_react.default.createElement(_popover.default, {
        overlayClassName: "title-desc-popover",
        content: t('filterSettingModal.popover')
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: "fm fm-question"
      }))), panel === 'setting' && /*#__PURE__*/_react.default.createElement(_breadcrumb.default.Item, null, data.code ? t('filterSettingModal.edit') : t('filterSettingModal.add')));

      return /*#__PURE__*/_react.default.createElement(_modal.default, (0, _extends2.default)({}, restProps, {
        title: title,
        maskClosable: false,
        centered: true,
        visible: true,
        wrapClassName: "".concat(prefix, "-filter-setting-modal"),
        onOk: this.handleOk
      }), panel === 'list' ? /*#__PURE__*/_react.default.createElement(_Panel.FilterListPanel, {
        addItem: this.addItem,
        editItem: this.editItem,
        deleteItem: this.deleteItem,
        list: list,
        emptyImg: emptyImg,
        setDefaultFilter: this.setDefaultFilter
      }) : /*#__PURE__*/_react.default.createElement(_Panel.FilterSettingPanel, {
        data: data,
        fields: fields,
        columns: filterColumns,
        filterColumns: unSelectColumns,
        onChange: this.handleFormChange,
        addFilterCondition: this.addFilterCondition,
        deleteFilterCondition: this.deleteFilterCondition,
        wrappedComponentRef: function wrappedComponentRef(ref) {
          return _this2.formRef = ref;
        },
        ModalManager: ModalManager
      }));
    }
  }]);
  return FilterSettingModal;
}(_react.Component);

var _default = FilterSettingModal;
exports.default = _default;