"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _moment = _interopRequireDefault(require("moment"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var FilterStateBarItem = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(FilterStateBarItem, _Component);

  var _super = _createSuper(FilterStateBarItem);

  function FilterStateBarItem(props) {
    var _this;

    (0, _classCallCheck2.default)(this, FilterStateBarItem);
    _this = _super.call(this, props);

    _this.getFilterContentName = function () {
      var _this$props$filter = _this.props.filter,
          value = _this$props$filter.value,
          filterColumn = _this$props$filter.filterColumn;
      var filterName = '';

      if (filterColumn && !(0, _lodash.isEmpty)(value)) {
        var filterOption = filterColumn.filterOption;
        var filterPlainText = [];

        if (filterColumn.filters) {
          (0, _lodash.forEach)(filterColumn.filters, function (item) {
            if (value.includes(item.value)) {
              filterPlainText.push(item.text);
            }
          });
        }

        if (filterOption) {
          switch (filterOption.type) {
            case 'dateRange':
              filterName = (0, _moment.default)(value[0]).format('YYYY/MM/DD') + ' ~ ' + (0, _moment.default)(value[1]).format('YYYY/MM/DD');

              _this.setState({
                name: filterName
              });

              break;

            case 'checkbox':
            case 'customTagSelect':
              if (Array.isArray(value) && value.length > 0 && (0, _typeof2.default)(value[0]) === 'object') {
                filterName = value.map(function (item) {
                  return item.text;
                }).join(',');

                _this.setState({
                  name: filterName
                });
              } else {
                filterName = _this.limitLen(filterPlainText.join(','));

                if (!filterName && typeof filterColumn.filtersSync === 'function') {
                  var _map = {};
                  filterColumn.filtersSync().then(function (res) {
                    if (Array.isArray(res)) {
                      res.forEach(function (item) {
                        _map[item.value] = item.text;
                      });
                      filterName = value.map(function (item) {
                        return _map[item] || item;
                      }).join(',');

                      _this.setState({
                        name: filterName
                      });
                    }
                  });
                } else if (filterName) {
                  _this.setState({
                    name: filterName
                  });
                }
              }

              break;

            case 'search':
              filterName = filterPlainText.length > 0 ? filterPlainText[0] : value;

              _this.setState({
                name: filterName
              });

              break;

            case 'department':
              filterName = filterColumn.selectedList instanceof Array ? filterColumn.selectedList.join(',') : filterColumn.selectedList;

              if (!filterName && Array.isArray(value) && value.length > 0) {
                filterName = value.map(function (item) {
                  return item.name;
                }).join(',');
              }

              _this.setState({
                name: filterName
              });

              break;

            case 'budgetment':
              filterName = filterColumn.selectedList instanceof Array ? filterColumn.selectedList.join(',') : filterColumn.selectedList;

              _this.setState({
                name: filterName
              });

              break;

            case 'budgetSubject':
              filterName = filterColumn.selectedList instanceof Array ? filterColumn.selectedList.join(',') : filterColumn.selectedList;

              _this.setState({
                name: filterName
              });

              break;

            case 'tree':
              var result;

              if (Array.isArray(value)) {
                var names = value.map(function (item) {
                  return item.name;
                });
                result = names.join(',');
              }

              _this.setState({
                name: result
              });

              break;

            default:
              _this.setState({
                name: value
              });

              break;
          }
        } else if (filterColumn.filters && !filterColumn.filterMultiple) {
          var filterData = (0, _lodash.find)(filterColumn.filters, {
            value: value[0]
          });
          filterName = filterData ? filterData.text : filterName;

          _this.setState({
            name: filterName
          });
        }
      }
    };

    _this.limitLen = function (str) {
      var len = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 12;
      var result = '';

      if ((0, _lodash.isString)(str)) {
        if (str.length > len) {
          result = str.substr(0, len) + '...';
        } else {
          result = str;
        }
      } else {
        result = str;
      }

      return result;
    };

    _this.state = {
      name: ''
    };
    return _this;
  }

  (0, _createClass2.default)(FilterStateBarItem, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var filter = this.props.filter;
      this.getFilterContentName(filter);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(preProps) {
      if (!(0, _lodash.isEqual)(preProps.filter, this.props.filter)) {
        this.getFilterContentName(this.props.filter);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          filter = _this$props.filter,
          remove = _this$props.remove;
      var name = this.state.name;
      if (!name || name === '') return null; // 原因： 关联申请单时从他人申请切换成我的申请，会出现筛选项bug

      return /*#__PURE__*/_react.default.createElement("div", {
        className: 'filter',
        key: filter.key
      }, /*#__PURE__*/_react.default.createElement("span", {
        className: 'filter-label'
      }, filter.label, ":"), /*#__PURE__*/_react.default.createElement("span", null, name), /*#__PURE__*/_react.default.createElement("span", {
        className: 'filter-close fm fm-cross',
        onClick: function onClick(e) {
          remove(filter);
        }
      }));
    }
  }]);
  return FilterStateBarItem;
}(_react.Component);

var _default = FilterStateBarItem;
exports.default = _default;