"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _rcTrigger = _interopRequireDefault(require("rc-trigger"));

var _OptionInputList = _interopRequireDefault(require("../OptionInputList"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

/*
 * @Author: yuxuan 
 * @Date: 2020-03-06 19:31:22 
 * @Last Modified by: yuxuan
 * @Last Modified time: 2020-08-05 11:35:39
 */
var prefix = _utils.default.prefixCls;

function OptionInputPicker(props) {
  var value = props.value,
      placeholder = props.placeholder,
      showBizCode = props.showBizCode,
      fieldStyleCategory = props.fieldStyleCategory,
      readOnly = props.readOnly,
      legalEntity = props.legalEntity,
      afterChange = props.afterChange,
      privateProps = props.privateProps;

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      isDropDown = _useState2[0],
      setIsDropDown = _useState2[1];

  var _useState3 = (0, _react.useState)(),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      legalEntityAuthzs = _useState4[0],
      setLegalEntityAuthzs = _useState4[1];

  var divRef = (0, _react.useRef)(null);
  var hideDropDown = (0, _react.useCallback)(function () {
    if (readOnly) {
      return;
    }

    ;
    setIsDropDown(false);
  }, [readOnly]);
  var showDropDown = (0, _react.useCallback)(function () {
    if (readOnly) {
      return;
    }

    setIsDropDown(true);
  }, [readOnly]);
  var arrowClass = (0, _react.useMemo)(function () {
    return isDropDown ? 'up' : 'down';
  }, [isDropDown]); // 清空所选项

  var clearValue = function clearValue(e) {
    e.preventDefault();
    e.stopPropagation();

    if (typeof afterChange === 'function') {
      afterChange({});
    }
  }; // 公司抬头变化时，如果当前选项组的值不满足抬头的权限，要将其清空


  (0, _react.useEffect)(function () {
    // 不在分摊表单中时才去清空
    if (!(privateProps && privateProps.isEntityInAllocation)) {
      var code = legalEntity && legalEntity.code || null;

      if (code && legalEntityAuthzs && legalEntityAuthzs.length) {
        if (legalEntityAuthzs.every(function (_ref) {
          var authzCode = _ref.authzCode;
          return authzCode !== code;
        })) {
          if (typeof afterChange === 'function') {
            afterChange({
              value: undefined
            });
          }
        }
      }
    }
  }, [legalEntity, legalEntityAuthzs, afterChange, privateProps]);
  return /*#__PURE__*/_react.default.createElement("div", {
    ref: divRef
  }, /*#__PURE__*/_react.default.createElement(_rcTrigger.default, {
    action: ['click'],
    popupVisible: isDropDown,
    popupAlign: {
      points: ['tl', 'bl'],
      offset: [0, -60]
    },
    popupClassName: "".concat(prefix, "-option-input"),
    popupStyle: {
      maxWidth: divRef && divRef.current ? divRef.current.clientWidth : 400
    },
    popup: /*#__PURE__*/_react.default.createElement(_OptionInputList.default, (0, _extends2.default)({}, props, {
      legalEntityAuthzs: legalEntityAuthzs,
      onSetLegalEntityAuthz: setLegalEntityAuthzs,
      showDropDown: isDropDown,
      hideDropDown: hideDropDown
    }))
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefix, "-option-input-display-value ").concat(fieldStyleCategory === 'origin' ? "".concat(prefix, "-option-input-table-cell") : null),
    onClick: showDropDown
  }, value && value.name ? /*#__PURE__*/_react.default.createElement("div", null, value.name, showBizCode && value.bizCode ? "(".concat(value.bizCode, ")") : '') : /*#__PURE__*/_react.default.createElement("div", {
    className: "placeholder"
  }, placeholder), value && value.name && /*#__PURE__*/_react.default.createElement("span", {
    className: 'ant-select-clear',
    onClick: function onClick(event) {
      return clearValue(event);
    }
  }, /*#__PURE__*/_react.default.createElement(_icon.default, {
    type: "close"
  })), /*#__PURE__*/_react.default.createElement("span", {
    className: "ant-select-arrow ".concat(arrowClass, " ").concat(value && value.name && 'ant-select-arrow-hide'),
    unselectable: "on"
  }, /*#__PURE__*/_react.default.createElement(_icon.default, {
    type: "down"
  })))));
}

var _default = OptionInputPicker;
exports.default = _default;