"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("maycur-antd/lib/tag/style/css");

var _tag = _interopRequireDefault(require("maycur-antd/lib/tag"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _OptionSelectionModal = _interopRequireDefault(require("./Modal/OptionSelectionModal"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

var _constants = _interopRequireDefault(require("../../utils/constants"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _mkTranslate = _interopRequireDefault(require("../../utils/mkTranslate"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var OPTION_PICKER = _constants.default.OPTION_PICKER;
var prefix = _utils.default.prefixCls;

var OptionPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(OptionPicker, _Component);

  var _super = _createSuper(OptionPicker);

  function OptionPicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, OptionPicker);
    _this = _super.call(this, props);
    _this.state = {
      // rc-form组件契约：接受value属性成为受控组件
      value: props.value || []
    };
    _this.onChange = _this.onChange.bind((0, _assertThisInitialized2.default)(_this));
    _this.openModal = _this.openModal.bind((0, _assertThisInitialized2.default)(_this));
    _this.convertFromValue = _this.convertFromValue.bind((0, _assertThisInitialized2.default)(_this));
    _this.convertToValue = _this.convertToValue.bind((0, _assertThisInitialized2.default)(_this));
    _this.isExternal = props.group && props.group[0] && props.group[0].fromExternal;
    _this.t = _mkTranslate.default.getLocalNs('MK_ConditionSetting', (0, _assertThisInitialized2.default)(_this));
    return _this;
  } // rc-form组件契约：注册onChange事件为form提供值变化感知


  (0, _createClass2.default)(OptionPicker, [{
    key: "onChange",
    value: function onChange(value) {
      var onChange = this.props.onChange;

      if (typeof onChange === 'function') {
        onChange(value);
      }
    } // rc-form组件契约：接受value属性成为受控组件

  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var group = nextProps.group,
          code = nextProps.code,
          value = nextProps.value;

      if (code !== this.props.code) {
        //是否是外部档案
        this.isExternal = group && group[0] && group[0].fromExternal;
      }

      if (_lodash.default.isEqual(value, this.props.value)) {
        return;
      } else {
        this.setState({
          value: value
        });
      }
    }
  }, {
    key: "convertFromValue",
    value: function convertFromValue(value) {
      var _this2 = this;

      value = value || [];
      return _lodash.default.map(value, function (item) {
        if (_this2.isExternal) {
          return {
            code: item.bizCode,
            _code: item.code,
            name: item.name,
            type: item.type,
            userEmployeeId: item.userEmployeeId
          };
        } else {
          return {
            code: item.code,
            name: item.name,
            type: item.type,
            userEmployeeId: item.userEmployeeId
          };
        }
      });
    }
  }, {
    key: "convertToValue",
    value: function convertToValue(selectList) {
      var _this3 = this;

      selectList = selectList || [];
      return _lodash.default.map(selectList, function (item) {
        if (_this3.isExternal) {
          return {
            code: item._code || item.code,
            bizCode: item.code,
            name: item.name,
            type: item.type,
            userEmployeeId: item.userEmployeeId
          };
        } else {
          return {
            code: item.code,
            name: item.name,
            type: item.type,
            userEmployeeId: item.userEmployeeId
          };
        }
      });
    }
  }, {
    key: "openModal",
    value: function openModal(e) {
      var _this4 = this;

      var value = this.state.value;
      var _this$props = this.props,
          scope = _this$props.scope,
          isShowUserGroup = _this$props.isShowUserGroup,
          maxSelectLength = _this$props.maxSelectLength,
          disabled = _this$props.disabled,
          code = _this$props.code,
          isSelectCategory = _this$props.isSelectCategory,
          ModalManager = _this$props.ModalManager,
          apis = _this$props.apis;
      e.stopPropagation();

      if (disabled) {
        return;
      }

      ModalManager.open({
        component: _OptionSelectionModal.default,
        componentProps: {
          selectList: this.convertFromValue(value),
          scope: scope,
          isShowUserGroup: isShowUserGroup,
          maxSelectLength: maxSelectLength,
          isSelectCategory: isSelectCategory,
          apis: apis,
          code: code
        }
      }).then(function (selectList) {
        var value = _this4.convertToValue(selectList);

        _this4.setState({
          value: value
        });

        _this4.onChange(value);
      }, _utils.default.noop);
    }
  }, {
    key: "render",
    value: function render() {
      var value = this.state.value;
      var _this$props2 = this.props,
          className = _this$props2.className,
          maxShowLength = _this$props2.maxShowLength,
          scope = _this$props2.scope,
          emptyText = _this$props2.emptyText,
          disabled = _this$props2.disabled;
      var containerClass = (0, _classnames.default)("".concat(prefix, "-option-picker-container"), className, {
        "disabled": disabled
      });
      var defaultEmptyText;

      if (!emptyText) {
        switch (scope) {
          case OPTION_PICKER.SCOPE_CATEGORY:
            defaultEmptyText = "未选择分类";
            break;

          case OPTION_PICKER.SCOPE_ITEM:
            defaultEmptyText = "未选择选项";
            break;

          default:
            defaultEmptyText = this.t('allOptions');
            break;
        }
      }

      return /*#__PURE__*/_react.default.createElement("div", {
        className: containerClass,
        onClick: this.openModal
      }, value && value.length ? _lodash.default.take(value, maxShowLength).map(function (item) {
        return /*#__PURE__*/_react.default.createElement(_tag.default, {
          className: "name",
          key: item.code
        }, item.type === OPTION_PICKER.CATEGORY ? /*#__PURE__*/_react.default.createElement("span", {
          className: 'fm fm-cube'
        }) : item.type === OPTION_PICKER.ITEM ? /*#__PURE__*/_react.default.createElement("span", {
          className: 'fm fm-paper'
        }) : /*#__PURE__*/_react.default.createElement("span", {
          className: 'fm fm-user-group'
        }), item.name);
      }) : /*#__PURE__*/_react.default.createElement("span", {
        className: "empty"
      }, emptyText || defaultEmptyText), value && value.length > maxShowLength ? /*#__PURE__*/_react.default.createElement("span", {
        className: "stats"
      }, "\u5171", /*#__PURE__*/_react.default.createElement("span", {
        className: 'strong'
      }, value.length), "\u9879") : null, /*#__PURE__*/_react.default.createElement("span", {
        className: 'fm fm-more-o'
      }));
    }
  }]);
  return OptionPicker;
}(_react.Component);

OptionPicker.defaultProps = {
  maxShowLength: 6,
  maxSelectLength: -1,
  scope: OPTION_PICKER.SCOPE_ALL
};
var _default = OptionPicker;
exports.default = _default;