"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

require("maycur-antd/lib/message/style/css");

var _message2 = _interopRequireDefault(require("maycur-antd/lib/message"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _treeItem = _interopRequireDefault(require("./treeItem"));

var _lodash = _interopRequireDefault(require("lodash"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var prefix = _utils.default.prefixCls;

var TreeView = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(TreeView, _Component);

  var _super = _createSuper(TreeView);

  function TreeView(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TreeView);
    _this = _super.call(this, props);

    _this.onCheckNode = function (node) {
      var shouldRemove = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

      var checkedNodes = _this.state.checkedNodes.slice(0);

      var maxSelectLength = _this.props.maxSelectLength;
      /*if( !Array.isArray(codes)) {
          codes = [codes];
      }
         codes.forEach( code => {
          if(checkedNodes.indexOf(code) == -1) {
              checkedNodes.push(code)
          } else if( shouldRemove ){
              _.remove(checkedNodes, (n) => {
                  return n == code
              })
          }
      })*/

      if (_lodash.default.find(checkedNodes, (0, _defineProperty2.default)({}, _this.code, node[_this.code]))) {
        _lodash.default.remove(checkedNodes, function (o) {
          return o[_this.code] === node[_this.code];
        });
      } else {
        if (checkedNodes && maxSelectLength > 0 && checkedNodes.length >= maxSelectLength) {
          _message2.default.error('最多可以选择' + maxSelectLength + '项！');

          return;
        }

        checkedNodes.push(node);
      }

      _this.setState({
        checkedNodes: checkedNodes
      });

      _this.props.onCheck(checkedNodes);
    };

    _this.onCheckDownNodes = function (code, isChecked) {
      var node = _this.findNodeData(_this.props.treeData, code);

      var children = [];

      _this.getChildcodes(node, children);

      _this.onCheckNode(children, !isChecked);
    };

    _this.onExpandNodes = function (code) {
      var expandedNodes = _this.state.expandedNodes.slice(0);

      var onExpand = _this.props.onExpand;

      if (expandedNodes.indexOf(code) === -1) {
        expandedNodes.push(code);
      } else {
        _lodash.default.remove(expandedNodes, function (n) {
          return n === code;
        });
      }

      _this.setState({
        expandedNodes: expandedNodes
      });

      if (onExpand && typeof onExpand === 'function') {
        onExpand(expandedNodes);
      }
    };

    _this.isNodeChecked = function (code) {
      // console.log(this.state.checkedNodes.indexOf(code) != -1);
      return _lodash.default.find(_this.state.checkedNodes, (0, _defineProperty2.default)({}, _this.code, code)) !== undefined;
    };

    _this.isNodeExpanded = function (code) {
      return _this.state.expandedNodes.indexOf(code) !== -1;
    };

    _this.state = {
      checkedNodes: props.defaultCheckedNodes || [],
      expandedNodes: props.defaultExpandedNodes || []
    };
    _this.name = props.name;
    _this.code = props.code;
    return _this;
  }

  (0, _createClass2.default)(TreeView, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      var defaultCheckedNodes = nextProps.defaultCheckedNodes;
      this.setState({
        checkedNodes: defaultCheckedNodes || []
      });
    }
  }, {
    key: "render",
    value: function render() {
      var treeData = this.props.treeData;
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "".concat(prefix, "-pop-selector-wrap")
      }, treeData && treeData.length > 0 ? this.renderTree(treeData) : /*#__PURE__*/_react.default.createElement("div", {
        className: "empty-result"
      }, "\u672A\u67E5\u8BE2\u5230\u6570\u636E!"));
    } //暂时不考虑node为数组 一次多选的情况

  }, {
    key: "findNodeData",
    value: function findNodeData(treeData, code) {
      if (treeData) {
        for (var i = 0; i < treeData.length; i++) {
          if (treeData[i].code === code) {
            return treeData[i];
          }

          var found = this.findNodeData(treeData[i].children, code);
          if (found) return found;
        }
      }
    }
  }, {
    key: "getChildCodes",
    value: function getChildCodes(data, children) {
      var _this2 = this;

      if (!data) return;

      if (data.code) {
        children.push(data.code);
        data = data.children;
      }

      data.forEach(function (node) {
        children.push(node[_this2.code]);

        _this2.getChildCodes(node.children, children);
      });
    }
  }, {
    key: "renderTree",
    value:
    /*toggleClick = (e) => {
        const { onToggle, treeData } = this.props;
        const targetNode = this.findNodeData(treeData, e.target.code);
        onToggle(targetNode, targetNode.active, e.target);
         e.stopPropagation();
    }*/
    function renderTree(data, expanded) {
      var _this3 = this;

      if (!data) return;
      return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("ul", {
        className: "tree-box"
      }, data.map(function (node, index) {
        console.log(_this3.code);
        return /*#__PURE__*/_react.default.createElement(_treeItem.default, (0, _extends2.default)({
          node: node,
          key: node[_this3.code],
          checkNodes: _this3.onCheckNode,
          expandNodes: _this3.onExpandNodes,
          isNodeChecked: _this3.isNodeChecked,
          isNodeExpanded: _this3.isNodeExpanded,
          onCheckDownNodes: _this3.onCheckDownNodes
        }, _this3.props), _this3.isNodeExpanded(node[_this3.code]) && _this3.renderTree(node.children, node[_this3.code]));
      })));
    }
  }]);
  return TreeView;
}(_react.Component);

var _default = TreeView;
exports.default = _default;