"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DefaultsKeys = exports.Defaults = exports.Selectors = exports.Store = exports.Browser = void 0;

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var prefix = _utils.default.prefixCls;
var Browser = {};
exports.Browser = Browser;

if (typeof window !== 'undefined') {
  Browser.SUPPORTED = 'requestAnimationFrame' in window;
  Browser.SUPPORTS_TOUCH = 'ontouchstart' in window;
  Browser.touch = false;
  Browser.dynamicInputDetection = true; // Chrome device/touch emulation can make this dynamic

  Browser.iOS = function () {
    return /iPhone|iPad|iPod/.test(navigator.userAgent) && !window.MSStream;
  };
}
/**
* The global storage array which holds all data reference objects
* from every instance
* This allows us to hide tooltips from all instances, finding the ref when
* clicking on the body, and for followCursor
*/


var Store = [];
/**
* Selector constants used for grabbing elements
*/

exports.Store = Store;
var Selectors = {
  POPPER: ".".concat(prefix, "-tippy-popper"),
  TOOLTIP: ".".concat(prefix, "-tippy-tooltip"),
  CONTENT: ".".concat(prefix, "-tippy-tooltip-content"),
  CIRCLE: '[x-circle]',
  ARROW: '[x-arrow]',
  TOOLTIPPED_EL: '[data-tooltipped]',
  CONTROLLER: '[data-tippy-controller]'
};
/**
* The default settings applied to each instance
*/

exports.Selectors = Selectors;
var Defaults = {
  html: false,
  position: 'top',
  animation: 'shift',
  animateFill: true,
  arrow: false,
  arrowSize: 'regular',
  delay: 0,
  trigger: 'mouseenter focus',
  // duration: 350,
  duration: 0,
  interactive: false,
  interactiveBorder: 2,
  theme: 'dark',
  size: 'regular',
  distance: 10,
  offset: 0,
  hideOnClick: true,
  multiple: false,
  followCursor: false,
  inertia: false,
  // flipDuration: 350,
  flipDuration: 0,
  sticky: false,
  // stickyDuration: 200,
  stickyDuration: 0,
  appendTo: function appendTo() {
    return document.body;
  },
  zIndex: 9999,
  touchHold: false,
  performance: false,
  dynamicTitle: false,
  useContext: false,
  reactInstance: undefined,
  popperOptions: {},
  open: undefined,
  onRequestClose: function onRequestClose() {}
};
/**
* The keys of the defaults object for reducing down into a new object
* Used in `getIndividualSettings()`
*/

exports.Defaults = Defaults;
var DefaultsKeys = Browser.SUPPORTED && Object.keys(Defaults);
exports.DefaultsKeys = DefaultsKeys;