"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _react = _interopRequireWildcard(require("react"));

var _ManagePicker = _interopRequireDefault(require("../ManagePicker"));

var _constants = _interopRequireDefault(require("../utils/constants"));

var _mkTranslate = _interopRequireDefault(require("../utils/mkTranslate"));

var _lodash = _interopRequireDefault(require("lodash"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var MANAGE_PICKER = _constants.default.MANAGE_PICKER;

var TradingPartnerPicker = /*#__PURE__*/function (_Component) {
  (0, _inherits2.default)(TradingPartnerPicker, _Component);

  var _super = _createSuper(TradingPartnerPicker);

  function TradingPartnerPicker(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TradingPartnerPicker);
    _this = _super.call(this, props);

    _this.fetchSourceList = function (categoryCode) {
      var pageParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var getTradingPartnerTree = _this.props.getTradingPartnerTree;

      var params = _objectSpread({
        parentCode: categoryCode
      }, pageParams);

      return getTradingPartnerTree(params, {
        pageId: MANAGE_PICKER.SOURCE_LIST
      }).then(function (resp) {
        if (resp.code === 'ACK') {
          var data = resp.data && resp.data.data || [];

          _lodash.default.forEach(data, function (item) {
            if (!item.partnerProperty) {
              item.type = MANAGE_PICKER.CATEGORY;
              item.hasMore = item.hasChildren;
              item.icon = "fm fm-folder-o";
            } else {
              item.type = MANAGE_PICKER.ITEM;
              item.icon = item.partnerProperty === 'CORP' ? 'fm fm-legal-entity' : 'fm fm-store';
            }
          });

          return data;
        }
      });
    };

    _this.fetchSearchList = function (keywords) {
      var pageParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      return _this.props.searchPartner(_objectSpread({
        keywords: keywords
      }, pageParams), {
        pageId: MANAGE_PICKER.SEARCH_LIST
      }).then(function (res) {
        var data = res.data && res.data.data || [];

        _lodash.default.forEach(data, function (item) {
          item.type = MANAGE_PICKER.ITEM;
          item.icon = item.partnerProperty === 'CORP' ? 'fm fm-legal-entity' : 'fm fm-store';
        });

        return data;
      });
    };

    _this.state = {};
    _this.t = _mkTranslate.default.getLocalNs('MK_ManagePicker', (0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(TradingPartnerPicker, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react.default.createElement(_ManagePicker.default, (0, _extends2.default)({
        title: this.t('ManagePicker.title'),
        fetchSourceList: this.fetchSourceList,
        fetchSearchList: this.fetchSearchList
      }, this.props));
    }
  }]);
  return TradingPartnerPicker;
}(_react.Component);

TradingPartnerPicker.defaultProps = {
  getTradingPartnerTree: function getTradingPartnerTree() {},
  searchPartner: function searchPartner() {},
  paging: true,
  pageSize: 50
};
var _default = TradingPartnerPicker;
exports.default = _default;