"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatChangedFields = exports.getChangedFields = exports.toUpperCase = exports.LANGS_CONFIG = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

/*
 * @Author: Jiangang LU
 * @Date: 2021-01-05 12:55:57
 * @LastEditors: Jiangang Lu
 * @LastEditTime: 2021-01-21 17:01:59
 * @Description: Do not edit
 */
var LANGS_CONFIG = [{
  key: 'Zh',
  label: '简体中文',
  placeholder: '输入简体中文'
}, {
  key: 'En',
  label: 'English',
  placeholder: 'Enter English'
}];
exports.LANGS_CONFIG = LANGS_CONFIG;

var toUpperCase = function toUpperCase() {
  var val = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  return "".concat(val.charAt(0).toUpperCase()).concat(val.slice(1));
};

exports.toUpperCase = toUpperCase;

var getChangedFields = function getChangedFields(params, identifier) {
  var result = (0, _defineProperty2.default)({}, identifier, params[identifier]);
  var propertyKey = null;
  LANGS_CONFIG.forEach(function (lang) {
    propertyKey = "".concat(identifier).concat(lang['key']);
    result[propertyKey] = params[propertyKey];
  });
  return result;
};

exports.getChangedFields = getChangedFields;

var formatChangedFields = function formatChangedFields() {
  var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var result = {};
  Object.keys(params).forEach(function (key) {
    result[key] = {
      name: key,
      value: params[key]
    };
  });
  return result;
};

exports.formatChangedFields = formatChangedFields;