"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.defaultToolbars = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var React = _interopRequireWildcard(require("react"));

var _Icon = _interopRequireWildcard(require("./Icon"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var defaultToolbars = [{
  key: 'zoomIn',
  actionType: _Icon.ActionType.zoomIn
}, {
  key: 'zoomOut',
  actionType: _Icon.ActionType.zoomOut
}, {
  key: 'prev',
  actionType: _Icon.ActionType.prev
}, {
  key: 'reset',
  actionType: _Icon.ActionType.reset
}, {
  key: 'next',
  actionType: _Icon.ActionType.next
}, {
  key: 'rotateLeft',
  actionType: _Icon.ActionType.rotateLeft
}, {
  key: 'rotateRight',
  actionType: _Icon.ActionType.rotateRight
}, {
  key: 'scaleX',
  actionType: _Icon.ActionType.scaleX
}, {
  key: 'scaleY',
  actionType: _Icon.ActionType.scaleY
}, {
  key: 'download',
  actionType: _Icon.ActionType.download
}, {
  key: 'fullscreen',
  actionType: _Icon.ActionType.fullscreen
}];
exports.defaultToolbars = defaultToolbars;

function deleteToolbarFromKey(toolbars, keys) {
  var targetToolbar = toolbars.filter(function (item) {
    return keys.indexOf(item.key) < 0;
  });
  return targetToolbar;
}

var ViewerToolbar = /*#__PURE__*/function (_React$Component) {
  (0, _inherits2.default)(ViewerToolbar, _React$Component);

  var _super = _createSuper(ViewerToolbar);

  function ViewerToolbar() {
    var _this;

    (0, _classCallCheck2.default)(this, ViewerToolbar);
    _this = _super.call(this);

    _this.renderAction = function (config) {
      var content = null; // default toolbar

      if (typeof _Icon.ActionType[config.actionType] !== 'undefined') {
        content = /*#__PURE__*/React.createElement(_Icon.default, {
          type: config.key
        });
      } // extra toolbar


      if (config.render) {
        content = config.render;
      }

      return /*#__PURE__*/React.createElement("li", {
        key: config.key,
        className: "".concat(_this.props.prefixCls, "-btn"),
        onClick: function onClick() {
          _this.handleAction(config);
        },
        "data-key": config.key,
        style: content ? null : {
          display: 'none'
        }
      }, content);
    };

    return _this;
  }

  (0, _createClass2.default)(ViewerToolbar, [{
    key: "handleAction",
    value: function handleAction(config) {
      this.props.onAction(config);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      // let attributeNode = this.props.attribute ? (
      //     <p className={`${this.props.prefixCls}-attribute`}>
      //         {this.props.alt && `${this.props.alt}`}
      //         {this.props.noImgDetails || <span className={`${this.props.prefixCls}-img-details`}>
      //             {`(${this.props.width} x ${this.props.height})`}
      //         </span>}
      //     </p>
      // ) : null;
      var toolbars = this.props.toolbars;

      if (!this.props.zoomable) {
        toolbars = deleteToolbarFromKey(toolbars, ['zoomIn', 'zoomOut']);
      }

      if (true) {
        //删除formweb传过来的全屏icon
        toolbars = deleteToolbarFromKey(toolbars, ['fullscreen']);
      }

      if (!this.props.changeable) {
        toolbars = deleteToolbarFromKey(toolbars, ['prev', 'next']);
      }

      if (!this.props.rotatable) {
        toolbars = deleteToolbarFromKey(toolbars, ['rotateLeft', 'rotateRight']);
      }

      if (!this.props.scalable) {
        toolbars = deleteToolbarFromKey(toolbars, ['scaleX', 'scaleY']);
      }

      if (!this.props.downloadable) {
        toolbars = deleteToolbarFromKey(toolbars, ['download']);
      }

      return /*#__PURE__*/React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-header")
      }, /*#__PURE__*/React.createElement("ul", {
        className: "".concat(this.props.prefixCls, "-toolbar")
      }, toolbars.map(function (item) {
        return _this2.renderAction(item);
      })));
    }
  }]);
  return ViewerToolbar;
}(React.Component);

exports.default = ViewerToolbar;