"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = HeadTable;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("./utils");

var _reactPerfectScrollbar = _interopRequireDefault(require("react-perfect-scrollbar"));

require("react-perfect-scrollbar/dist/css/styles.css");

var _BaseTable = _interopRequireDefault(require("./BaseTable"));

function HeadTable(props, _ref) {
  var table = _ref.table;
  var _table$props = table.props,
      prefixCls = _table$props.prefixCls,
      scroll = _table$props.scroll,
      showHeader = _table$props.showHeader;
  var columns = props.columns,
      fixed = props.fixed,
      tableClassName = props.tableClassName,
      handleBodyScrollLeft = props.handleBodyScrollLeft,
      expander = props.expander;
  var saveRef = table.saveRef;
  var useFixedHeader = table.props.useFixedHeader;
  var headStyle = {};

  if (scroll.y) {
    useFixedHeader = true; // Add negative margin bottom for scroll bar overflow bug

    var scrollbarWidth = (0, _utils.measureScrollbar)('horizontal');

    if (scrollbarWidth > 0 && !fixed) {
      headStyle.marginBottom = '-' + scrollbarWidth + 'px';
      headStyle.paddingBottom = '0px';
    }
  }

  if (!useFixedHeader || !showHeader) {
    return null;
  }

  return /*#__PURE__*/_react.default.createElement('div', {
    className: prefixCls + '-left-header'
  }, /*#__PURE__*/_react.default.createElement(_reactPerfectScrollbar.default, {
    key: 'headTable',
    ref: fixed ? null : function (ref) {
      saveRef('headTable')(ref && ref._container);
    },
    className: prefixCls + '-header',
    onScrollX: handleBodyScrollLeft
  }, /*#__PURE__*/_react.default.createElement(_BaseTable.default, {
    tableClassName: tableClassName,
    hasHead: true,
    hasBody: false,
    fixed: fixed,
    columns: columns,
    expander: expander
  })));
}

HeadTable.propTypes = {
  fixed: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.bool]),
  columns: _propTypes.default.array.isRequired,
  tableClassName: _propTypes.default.string.isRequired,
  handleBodyScrollLeft: _propTypes.default.func.isRequired,
  expander: _propTypes.default.object.isRequired
};
HeadTable.contextTypes = {
  table: _propTypes.default.any
};