"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _lodash = _interopRequireDefault(require("lodash"));

/*
 * @Description: file content
 * @Author: RongWei
 * @Date: 2019-09-26 15:56:08
 * @LastEditors: RongWei
 * @LastEditTime: 2019-11-15 15:12:51
 */
var AssociationSort = function AssociationSort() {
  var _this = this;

  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  (0, _classCallCheck2.default)(this, AssociationSort);

  this.buildGraph = function (associationFields) {
    var associationFieldsIdentifier = _lodash.default.map(associationFields, 'identifier');

    _lodash.default.each(associationFields, function (field) {
      var _cascadeDataRelations = _lodash.default.remove(field.cascadeDataRelations, function (item) {
        return associationFieldsIdentifier.includes(item.value);
      });

      var cascadeFieldsLength = _cascadeDataRelations.length || 0;
      var _cascadeFields = [];

      for (var i = 0; i < cascadeFieldsLength; i++) {
        // 若数据互联依赖了数据互联之外的其他组件，则不考虑在内
        if (associationFieldsIdentifier.includes(_cascadeDataRelations[i].value)) {
          _cascadeFields.push(_cascadeDataRelations[i]);
        }
      }

      field.cascadeDataRelations = _cascadeDataRelations;

      if (_cascadeFields.length) {
        _this.surplusArr.push(field);
      } else {
        _this.noDependArr.push(field);
      }
    });

    _this.sortCascade();
  };

  this.sortCascade = function () {
    var _loop = function _loop() {
      var identifiers = _lodash.default.map(_this.noDependArr, 'identifier');

      if (_this.noDependArr.length) {
        // 将无依赖的数组放入 sortedList 中
        _this.sortedList.push(_this.noDependArr);

        _this.noDependArr = [];
      } // 对于入度不为0的顶点，将n从他们的依赖中删除，如果删除后入度为0，则将其添加到noDependArr中


      for (var i = 0; i < _this.surplusArr.length; i++) {
        var cascadeDataRelations = _this.surplusArr[i].cascadeDataRelations; // 在 cascadeDataRelations 中删除依赖了 noDependArr 的 item

        _lodash.default.remove(cascadeDataRelations, function (item) {
          return identifiers.includes(item.value);
        }); // 删除后若无依赖，则放入 noDependArr 中


        if (!cascadeDataRelations.length) {
          _this.noDependArr.push(_this.surplusArr[i]);

          _this.surplusArr.splice(i, 1);

          i--;
        }
      }
    };

    while (_this.noDependArr.length) {
      _loop();
    }
  };

  this.traversalSortedList = /*#__PURE__*/function () {
    var _ref = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(getAssociationFieldDefaultValue) {
      var options,
          i,
          _args = arguments;
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              options = _args.length > 1 && _args[1] !== undefined ? _args[1] : {};
              i = 0;

            case 2:
              if (!(_this.sortedList && i < _this.sortedList.length)) {
                _context.next = 8;
                break;
              }

              _context.next = 5;
              return _this.callApi(_this.sortedList[i], getAssociationFieldDefaultValue, options);

            case 5:
              i++;
              _context.next = 2;
              break;

            case 8:
              return _context.abrupt("return", true);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }();

  this.callApi = function (sortedList, getAssociationFieldDefaultValue, options) {
    if (!(sortedList instanceof Array)) {
      sortedList = [sortedList];
    }

    return Promise.all(_lodash.default.map(sortedList, function (field) {
      return getAssociationFieldDefaultValue(field, options);
    }));
  };

  this.noDependArr = [];
  this.surplusArr = [];
  this.sortedList = [];
} // 构建数据
;

var _default = AssociationSort;
exports.default = _default;