"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _utils = _interopRequireDefault(require("./utils"));

var _lodash = _interopRequireDefault(require("lodash"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var currencyPairRate = [];
var exhangeRateFn;
/* 报销单通过费用金额计算报销金额 */

function expenseSumAmount(_x, _x2) {
  return _expenseSumAmount.apply(this, arguments);
}
/* 费用转换目标单据币种金额转换 */


function _expenseSumAmount() {
  _expenseSumAmount = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2(expenseList, reimCurrency) {
    var precision,
        totlaAmount,
        entPayAmount,
        updatedExpenseList,
        _args2 = arguments;
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            precision = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : 2;
            totlaAmount = 0;
            entPayAmount = 0;
            updatedExpenseList = _lodash.default.cloneDeep(expenseList);
            _context2.next = 6;
            return _utils.default.asyncForEach(updatedExpenseList, /*#__PURE__*/function () {
              var _ref = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(expense) {
                var targetDate, fromCurrency, toCurrency, expenseToCurrency, customExchangeRate, consumeAmount, availAmount, rate;
                return _regenerator.default.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        toCurrency = reimCurrency, consumeAmount = 0, availAmount = 0;

                        if (expense.consumeTime) {
                          if (expense.consumeTime.currentTime) {
                            targetDate = expense.consumeTime.currentTime;
                          } else if (expense.consumeTime.timeRange) {
                            targetDate = expense.consumeTime.timeRange.startDate;
                          }
                        }

                        if (expense.consumeAmount) {
                          fromCurrency = expense.consumeAmount.currency;
                          consumeAmount = expense.consumeAmount.amount || 0;
                          customExchangeRate = expense.consumeAmount.customExchangeRate;
                          expenseToCurrency = expense.consumeAmount.toCurrency;
                        }

                        if (!(fromCurrency === toCurrency)) {
                          _context.next = 7;
                          break;
                        }

                        availAmount = _lodash.default.round(consumeAmount, precision);
                        _context.next = 16;
                        break;

                      case 7:
                        if (!(targetDate && fromCurrency && toCurrency)) {
                          _context.next = 16;
                          break;
                        }

                        if (!(expenseToCurrency === reimCurrency && customExchangeRate)) {
                          _context.next = 12;
                          break;
                        }

                        rate = customExchangeRate;
                        _context.next = 15;
                        break;

                      case 12:
                        _context.next = 14;
                        return getExhangeRate({
                          targetDate: targetDate,
                          fromCurrency: fromCurrency,
                          toCurrency: toCurrency
                        });

                      case 14:
                        rate = _context.sent;

                      case 15:
                        availAmount = _lodash.default.round(consumeAmount * rate, precision);

                      case 16:
                        if (expense.extraTag && expense.extraTag.includes('ent_paid_order')) {
                          entPayAmount += availAmount;
                        }

                        totlaAmount += availAmount;
                        expense.approvedAmount = {
                          currency: reimCurrency,
                          amount: availAmount
                        };
                        expense.amount = {
                          currency: reimCurrency,
                          amount: availAmount
                        };

                      case 20:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee);
              }));

              return function (_x5) {
                return _ref.apply(this, arguments);
              };
            }());

          case 6:
            return _context2.abrupt("return", {
              totlaAmount: totlaAmount,
              entPayAmount: entPayAmount,
              expenseList: updatedExpenseList
            });

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _expenseSumAmount.apply(this, arguments);
}

function expenseToReceipt(originCny, targetCny, rate) {
  var originAmount = originCny.amount;
  return {
    currency: targetCny.currency,
    amount: originAmount * rate
  };
}
/* 统计费用报销总金额 */


function sumApprovelAmount(expenseList) {
  var totlaAmount = 0;
  var entPayAmount = 0;
  var afterwardsPayAmount = 0;

  _lodash.default.forEach(expenseList, function (expense) {
    if (!_lodash.default.isEmpty(expense.extraTag)) {
      if (expense.extraTag.includes('ent_paid_order')) {
        entPayAmount += expense.approvedAmount && expense.approvedAmount.amount ? expense.approvedAmount.amount : 0;
      } else if (expense.extraTag.includes('pay_afterwards')) {
        afterwardsPayAmount += expense.approvedAmount && expense.approvedAmount.amount ? expense.approvedAmount.amount : 0;
      }
    }

    totlaAmount += expense.approvedAmount && expense.approvedAmount.amount ? expense.approvedAmount.amount : 0;
  });

  return {
    totlaAmount: totlaAmount,
    entPayAmount: entPayAmount,
    afterwardsPayAmount: afterwardsPayAmount
  };
}
/* 费用金额换算成报销金额 */


function convertAmount(_x3, _x4) {
  return _convertAmount.apply(this, arguments);
}

function _convertAmount() {
  _convertAmount = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee4(expenseList, reimCurrency) {
    var precision,
        updatedExpenseList,
        _args4 = arguments;
    return _regenerator.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            precision = _args4.length > 2 && _args4[2] !== undefined ? _args4[2] : 2;
            updatedExpenseList = [];
            _context4.next = 4;
            return _utils.default.asyncForEach(expenseList, /*#__PURE__*/function () {
              var _ref2 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee3(expense) {
                var targetDate, fromCurrency, toCurrency, expenseToCurrency, customExchangeRate, consumeAmount, availAmount, rate;
                return _regenerator.default.wrap(function _callee3$(_context3) {
                  while (1) {
                    switch (_context3.prev = _context3.next) {
                      case 0:
                        toCurrency = reimCurrency, consumeAmount = 0, availAmount = 0;

                        if (expense.consumeTime) {
                          if (expense.consumeTime.currentTime) {
                            targetDate = expense.consumeTime.currentTime;
                          } else if (expense.consumeTime.timeRange) {
                            targetDate = expense.consumeTime.timeRange.startDate;
                          }
                        }

                        if (expense.consumeAmount) {
                          fromCurrency = expense.consumeAmount.currency;
                          consumeAmount = expense.consumeAmount.amount || 0;
                          customExchangeRate = expense.consumeAmount.customExchangeRate;
                          expenseToCurrency = expense.consumeAmount.toCurrency;
                        }

                        if (!(fromCurrency === toCurrency)) {
                          _context3.next = 7;
                          break;
                        }

                        availAmount = _lodash.default.round(consumeAmount, precision);
                        _context3.next = 16;
                        break;

                      case 7:
                        if (!(targetDate && fromCurrency && toCurrency)) {
                          _context3.next = 16;
                          break;
                        }

                        if (!(expenseToCurrency === reimCurrency && customExchangeRate)) {
                          _context3.next = 12;
                          break;
                        }

                        rate = customExchangeRate;
                        _context3.next = 15;
                        break;

                      case 12:
                        _context3.next = 14;
                        return getExhangeRate({
                          targetDate: targetDate,
                          fromCurrency: fromCurrency,
                          toCurrency: toCurrency
                        });

                      case 14:
                        rate = _context3.sent;

                      case 15:
                        availAmount = _lodash.default.round(consumeAmount * rate, precision);

                      case 16:
                        updatedExpenseList.push(_objectSpread(_objectSpread({}, expense), {}, {
                          approvedAmount: {
                            currency: reimCurrency,
                            amount: availAmount
                          },
                          amount: {
                            currency: reimCurrency,
                            amount: availAmount
                          }
                        }));

                      case 17:
                      case "end":
                        return _context3.stop();
                    }
                  }
                }, _callee3);
              }));

              return function (_x6) {
                return _ref2.apply(this, arguments);
              };
            }());

          case 4:
            return _context4.abrupt("return", {
              expenseList: updatedExpenseList
            });

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _convertAmount.apply(this, arguments);
}

function setExhangeRateFn(fn) {
  exhangeRateFn = fn;
}
/* 获取币种对汇率 */


function getExhangeRate(params) {
  var targetDate = params.targetDate,
      fromCurrency = params.fromCurrency,
      toCurrency = params.toCurrency;

  var matchedPair = _lodash.default.find(currencyPairRate, {
    fromCurrency: fromCurrency,
    toCurrency: toCurrency,
    targetDate: _utils.default.dateRemoveTime(new Date(targetDate))
  });

  return new Promise(function (resolve, reject) {
    if (matchedPair) {
      resolve(matchedPair.exchangeRate);
    } else if (typeof exhangeRateFn === 'function') {
      var dto = {
        amount: 1,
        targetDate: targetDate,
        fromCurrency: fromCurrency,
        toCurrency: toCurrency
      };
      exhangeRateFn(dto).then(function (resp) {
        if (resp.code === 'ACK' && resp.data) {
          var exchangeRate = resp.data.exchangeRate;
          currencyPairRate = currencyPairRate.concat([{
            fromCurrency: fromCurrency,
            toCurrency: toCurrency,
            targetDate: _utils.default.dateRemoveTime(new Date(targetDate)),
            exchangeRate: exchangeRate
          }]);
          resolve(exchangeRate);
        } else {
          resolve(0);
        }
      }, function () {
        resolve(0);
      });
    } else {
      reject();
    }
  });
}
/* 报销单核销借款单 */


function reimburseWriteOffLoan() {
  return _reimburseWriteOffLoan.apply(this, arguments);
}
/* 分摊兼容无币种模式的数据格式转换函数 */


function _reimburseWriteOffLoan() {
  _reimburseWriteOffLoan = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee6() {
    var reimburseAmountSet,
        loanList,
        isAllowModifyDeuction,
        useTemp,
        reimCny,
        reimAmount,
        _args6 = arguments;
    return _regenerator.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            reimburseAmountSet = _args6.length > 0 && _args6[0] !== undefined ? _args6[0] : {};
            loanList = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : [];
            isAllowModifyDeuction = _args6.length > 2 ? _args6[2] : undefined;
            useTemp = _args6.length > 3 ? _args6[3] : undefined;
            reimCny = reimburseAmountSet.currency, reimAmount = reimburseAmountSet.amount;

            if (reimCny) {
              _context6.next = 7;
              break;
            }

            return _context6.abrupt("return", loanList);

          case 7:
            if (!(useTemp === 'REPAYMENT')) {
              _context6.next = 11;
              break;
            }

            _lodash.default.forEach(loanList, function (d) {
              d.deductionAmount = isAllowModifyDeuction ? d.allowModifyAmount : d.owedAmount;
            });

            _context6.next = 13;
            break;

          case 11:
            _context6.next = 13;
            return _utils.default.asyncForEach(loanList, /*#__PURE__*/function () {
              var _ref3 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee5(loan) {
                var targetDate, fromCurrency, toCurrency, writeOffAmount, availAmount, rate;
                return _regenerator.default.wrap(function _callee5$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        if (!(reimAmount > 0)) {
                          _context5.next = 19;
                          break;
                        }

                        toCurrency = reimCny, writeOffAmount = 0, availAmount = 0, rate = 0;
                        targetDate = loan.settledAt;
                        fromCurrency = loan && loan.owedAmount && loan.owedAmount.currency;

                        if (!(fromCurrency === toCurrency)) {
                          _context5.next = 8;
                          break;
                        }

                        rate = 1;
                        _context5.next = 12;
                        break;

                      case 8:
                        if (!(targetDate && fromCurrency && toCurrency)) {
                          _context5.next = 12;
                          break;
                        }

                        _context5.next = 11;
                        return getExhangeRate({
                          targetDate: targetDate,
                          fromCurrency: fromCurrency,
                          toCurrency: toCurrency
                        });

                      case 11:
                        rate = _context5.sent;

                      case 12:
                        if (isAllowModifyDeuction) {
                          availAmount = loan.allowModifyAmount ? loan.allowModifyAmount.amount : 0;
                        } else {
                          availAmount = loan.owedAmount ? loan.owedAmount.amount : 0;
                        }

                        writeOffAmount = availAmount * rate;

                        if (writeOffAmount > reimAmount) {
                          writeOffAmount = reimAmount;
                        }

                        reimAmount -= writeOffAmount;
                        loan.deductionAmount = {
                          currency: reimCny,
                          amount: writeOffAmount
                        };
                        _context5.next = 20;
                        break;

                      case 19:
                        loan.deductionAmount = {
                          currency: reimCny,
                          amount: 0
                        };

                      case 20:
                        if (isAllowModifyDeuction) {
                          loan.allowModifyAmount = loan.deductionAmount;
                        }

                      case 21:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, _callee5);
              }));

              return function (_x7) {
                return _ref3.apply(this, arguments);
              };
            }());

          case 13:
            return _context6.abrupt("return", loanList);

          case 14:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _reimburseWriteOffLoan.apply(this, arguments);
}

function allocationDataConvert(expenses, currency) {
  var direct = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'currency';

  var data = _lodash.default.cloneDeep(expenses);

  if (data && data.reimburseExpenseAllocations && data.reimburseExpenseAllocations.length > 0) {
    data.reimburseExpenseAllocations.forEach(function (allocation) {
      var allocationBase = allocation.allocationBase;

      if (direct === 'currency' && !_lodash.default.isObject(allocationBase.amount)) {
        allocationBase.amount = {
          currency: currency,
          amount: allocationBase.amount
        };
      } else if (direct === 'money' && _lodash.default.isObject(allocationBase.amount)) {
        allocationBase.amount = allocationBase.amount.amount;
      }
    });
  }

  return data;
}

function summaryExpense(expenses, isAllocation, pureCalculation) {
  var pureCurrency = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 'CNY';
  var selectedRows = expenses;
  var currencySummary = {};

  _lodash.default.forEach(selectedRows, function (expense) {
    var consumeAmount; //分摊总金额计算如果是对公费用要取receiptAmount

    if (expense.corpExpense && isAllocation) {
      consumeAmount = expense.receiptAmount;
    } else {
      consumeAmount = expense.consumeAmount;
    }

    if (pureCalculation) {
      currencySummary[pureCurrency] = !currencySummary[pureCurrency] ? consumeAmount.amount : consumeAmount.amount + currencySummary[pureCurrency];
    } else if (_lodash.default.has(currencySummary, consumeAmount.currency)) {
      currencySummary[consumeAmount.currency] += consumeAmount.amount;
    } else {
      currencySummary[consumeAmount.currency] = consumeAmount.amount;
    }
  });

  return _lodash.default.map(currencySummary, function (value, key) {
    return {
      currency: key,
      amount: _lodash.default.round(value, 2)
    };
  });
}

function summaryApprovel(approvel) {
  var selectedRows = approvel;
  var currencySummary = {};

  _lodash.default.forEach(selectedRows, function (approvel) {
    var approvedAmount;
    approvedAmount = approvel.approvedAmount;

    if (_lodash.default.has(currencySummary, approvedAmount.currency)) {
      currencySummary[approvedAmount.currency] += approvedAmount.amount;
    } else {
      currencySummary[approvedAmount.currency] = approvedAmount.amount;
    }
  });

  return _lodash.default.map(currencySummary, function (value, key) {
    return {
      currency: key,
      amount: _lodash.default.round(value, 2)
    };
  });
}

var _default = {
  expenseToReceipt: expenseToReceipt,
  expenseSumAmount: expenseSumAmount,
  reimburseWriteOffLoan: reimburseWriteOffLoan,
  allocationDataConvert: allocationDataConvert,
  setExhangeRateFn: setExhangeRateFn,
  summaryExpense: summaryExpense,
  summaryApprovel: summaryApprovel,
  getExhangeRate: getExhangeRate,
  convertAmount: convertAmount,
  sumApprovelAmount: sumApprovelAmount
};
exports.default = _default;