"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = run;

var funcs = _interopRequireWildcard(require("./functions"));

var _compile = _interopRequireDefault(require("./compile"));

var _isfunction = _interopRequireDefault(require("./isfunction"));

var _assign = _interopRequireDefault(require("./assign"));

var _istext = _interopRequireDefault(require("./istext"));

var _error = require("./error");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// Copyright 2015-2018 FormBucket LLC
// m is a cache of compiled expressions.
var m = {}; // Execute a formula expression

function run(exp) {
  var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  // if the exp is a function then return it immediately.
  var locals = (0, _assign.default)({}, params); // Default get for plain object.

  if (locals.get !== "function") {
    locals.get = function (name, scope) {
      if ((0, _istext.default)(scope)) {
        return locals[scope] ? locals[scope][name] : undefined;
      }

      return locals[name];
    };
  }

  if ((0, _isfunction.default)(exp)) return exp(locals, funcs);else if (!(0, _istext.default)(exp)) return _error.ERRORTYPES.na; // check cached and shortcut if appropriate.

  if (m.hasOwnProperty(exp)) {
    // reload the compiled function.
    compiled = m[exp];
  } else {
    // compile the expression.
    var compiled = (0, _compile.default)(exp); // cache the compiled function.

    m[exp] = compiled;
  }

  return compiled(locals, funcs);
}