"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = second;

var _constants = require("./constants");

var _isdate = _interopRequireDefault(require("./isdate"));

var _trunc = _interopRequireDefault(require("./trunc"));

// Copyright 2015-2018 FormBucket LLC
function second(value) {
  if ((0, _isdate.default)(value)) {
    return value.getSeconds();
  } // calculate total seconds


  var totalSeconds = (value - (0, _trunc.default)(value)) * _constants.SecondsInDay; // calculate number of seconds for hour component


  var hourSeconds = (0, _trunc.default)(totalSeconds / _constants.SecondsInHour) * _constants.SecondsInHour; // calculate number of seconds in minute component


  var minuteSeconds = (0, _trunc.default)((totalSeconds - hourSeconds) / _constants.SecondsInMinute) * _constants.SecondsInMinute; // remove seconds for hours and minutes and round to nearest value


  return Math.round(totalSeconds - hourSeconds - minuteSeconds);
}